# This file is sourced by shell scripts to obtain common settings
# for all bp shell scripts.

if [ -r /etc/default/bp.ini ]; then
    eval $(egrep '^[ 	]*BPDIR=' /etc/default/bp.ini 2> /dev/null)
fi

if [ -z "$BPDIR" ]; then
    printf "%s: Can\'t determine where BP is installed.\n" \
        $(basename $0)
    exit 1
fi

export BPDIR

PATH="$PATH:$BPDIR/bin"
export PATH

UT_SHLIB="$BPDIR/lib/shlib"
export UT_SHLIB

# This lets a shell search the shlib when doing ". <filename>"
PATH="$PATH:$UT_SHLIB"

## python path to include monitoring
MONLIB="$BPDIR/lib/monitoring"
## if dir exists then
if [ -d $MONLIB ]; then
  ## if PYTHONPATH is not set, then append MONLIB
  if [ -z ${PYTHONPATH+x} ]; then
    PYTHONPATH+="$MONLIB"
  else
    ## if PYTHONPATH already set, then append MONLIB if its not there
    [[ ! $PYTHONPATH =~ (^|:)$MONLIB(:|$) ]] && PYTHONPATH+=":$MONLIB"
  fi
  export PYTHONPATH
fi

