#!/bin/sh
## 6032 BT 	build_archive_media.sh created

. /etc/default/bp.ini > /dev/null 2>&1
. ${BPDIR}/bin/archive/constants.incl
. ${BPDIR}/bin/archive/common.incl
. ${BPDIR}/bin/archive/backup.incl

PortNum="Unknown"
MAILTO=`${BPBIN}/bputil -g "Unattended Backup Information" "MailTo" "NULL" ${BPDIR}/bpinit/master.ini`
REPORT="${BPRPT}/archive_space_check.rpt"
ARCHIVEMOUNTED="False"
QuietFlag="n" # Always interactive
OperationInProgress="Media Setup"

stty sane
stty erase ^H

do_work(){
	${ECHO} "The utility is designed to assist with the creation of archive media"
	${ECHO} "where the medium is either single disk or multi-drive archive unit (MDA)."
	${ECHO} "It will remove any existing archives and create an empty archive media."
	${ECHO} "The benefit of this utility is the ability to add a drive to an MDA's"
	${ECHO} "archive media set when the profile needs to archive more data than will"
	${ECHO} "fit on the current archive media.  (Example:  You have a 3 drive archive"
	${ECHO} "unit in your MDA and your profile will no longer fit.  You may use this utility"
	${ECHO} "to build the additional fourth disk into the archive MDA's RAID-0.)\n"
	${ECHO} "Proceed? [y/n] (Default: n) \c"
	read ANS
	ANS=`echo ${ANS} | tr [A-Z] [a-z]`
	if [[ "${ANS}" == "y" || "${ANS}" == "yes" ]]; then
		continue
	else
		return 2
	fi
	${ECHO} "Are you sure? [y/n] (Default: n) \c"
	read ANS
	ANS=`echo ${ANS} | tr [A-Z] [a-z]`
	if [[ "${ANS}" == "y" || "${ANS}" == "yes" ]]; then
		continue
	else
		return 2
	fi
	
	GetDPUTypeAndArchTarget
	if [ $? -eq 2 ]
	then
		# User wants to exit
		return 2
	fi

	if [ "$DPUType" = "unknown" ]
	then
		${ECHO} "Cannot locate valid disk device or determine DPU type."
		if [ $QuietFlag = "n" ]
		then
			${ECHO} "Press <Enter> to return... \c"
			read
		fi
		return 1
	fi
	Build3WareArchive $TwTarget INDEPENDENT
	${ECHO} "Done."
	${ECHO} "Press <Enter> to exit...\c"
	read
	return $?
}

GetDPUType
# 6459
# This script only supported on DPUs with raid hardware
if TwArchivingSupported
then
	trap 'cleanUp $?' EXIT TERM INT
	CreateLockOrExit
	
	do_work

	if [ $? -ne 2 ]; then
		cleanUp $?
	fi
else
	$ECHO "Rebuilding Archive Media is not supported on this platform."
	$ECHO "Press <Enter> to return... \c"
	read
fi
exit $?
