# Script run interactive SQL on remote DPV
# ERROR cases:
# 1 - ssh tunnel not up
# 2 - could not connect to remote database

. /etc/default/bp.ini 2> /dev/null

LOCAL_ERR_FILE=$BPDIR/logs.dir/dpv_bp_sql.err

$BPDIR/bin/data_tunnel_up.sh >$LOCAL_ERR_FILE 2>&1
loc_ret=$?
if [ $loc_ret -ne 0 ]
then
	echo "dpv_bp_sql.sh: ERROR: data_tunnel_up failed with error $loc_ret." >>$LOCAL_ERR_FILE
	exit 1
fi

psql -U postgres -h localhost -p 5555 bpdb 

loc_ret=$?
if [ $loc_ret -ne 0 ]
then
	echo "dpv_bp_sql.sh: ERROR: accessing remote database failed with error $loc_ret." 
	exit 2
fi

exit $loc_ret

