:
##!/bin/sh
##*************************************************************************
##       Source Id:       @(#)lmgrlib.make	1.2.2.1		10/20/98
##*************************************************************************/
##
##  routines to manage lmgr licenses
##
##
##    Exported variables that these routines may use:
##
##	LM_EMAIL:	your email address where the user sends the
##			license request.
##	LM_FAX_HEADER:  path to a file containing fax sheet header
##			information where the user should send the
##			license upgrade request.  Used by the program
##			"lmbrand".
##	PATH:		MUST contain the path to the lm programs,
##			lmbrand and lmmgr.
##
#######################################################################








# ************************************************************************* 
#    	Source Id:	 @(#)bpsh.inc	1.1.1.3		08/24/98
# *************************************************************************

## BP Shell Init

[ -n "$PRODDIR" ] && BPDIR=$PRODDIR
export BPDIR




PSCMD="ps ax"











MAILCMD=mail


set_ECHO() { 
	[ -d /usr/5bin ] && { PATH="/usr/5bin:${PATH}"; export PATH; }
  ECHO="echo -e"; 
  echo -e "hello" | grep "e h" >/dev/null && ECHO="echo"
  OS=`uname 2>/dev/null`
  case "$OS" in
      SunOS) [ -x /usr/5bin/echo ] && ECHO=/usr/5bin/echo ;;
  esac
  unset OS;
}

set_ECHO; export ECHO

bpsh_init()
{
	RTN=0

	eval `id  |  sed 's/[^a-z0-9=].*//'`
	




	
	# Bug 7515 Enable core dump

CHECK_SCO_OS=`uname 2>/dev/null`
if [ "$CHECK_SCO_OS" != "SCO_SV" ]
then
        ulimit -S -c unlimited
else
        ulimit -f 512
fi

	umask 022

	if [ -z "$BPDIR" ]; then
		if [ ! -f /etc/default/bp.ini ]; then
        id | grep "\(root\)" > /dev/null
        if [ $? -eq 0 ]; then
    		   $ECHO "\n  * File \"/etc/default/bp.ini\" does not exist!\n  * Consider reinstalling the product."
        else
           $ECHO "\n  * Unable to access file \"/etc/default/bp.ini\" "
           $ECHO "\n  * Please check your permissions\n"
        fi
    		RTN=1
		else
			# The brackets contain a space and a tab
			eval `egrep '^[ 	]*BPDIR=' /etc/default/bp.ini 2>/dev/null`
			if [ ! -d "$BPDIR" ]; then
    			$ECHO "\n  * Can't determine product directory.\n  * Try setting BPDIR to the install directory in \"/etc/default/bp.ini\""
    			RTN=1
			fi
		fi
	else
		if [ ! -d "$BPDIR" ]; then
			$ECHO "\n  * Invalid product directory from BPDIR environment variable."
			RTN=1
		fi
	fi

	BPUTIL="$BPDIR/bin/bputil"
	MASTER_INI="$BPDIR/bpinit/master.ini"

	return $RTN
}

























trap 'bringup_tasker; exit 1' 2

bringup_tasker()
{
	if [ "$BRINGUP_TASKER" = YES ]
	then
		clear
		${ECHO} "\nRestarting tasker ..."
		BRINGUP_TASKER=NO
		$BPDIR/bin/dispatch start
		if [ $? -eq 0 ]; then ${ECHO} "Success!!"; else ${ECHO} "Failed!!"; fi
	fi
}

shutdown_tasker()
{
if $BPDIR/bin/dispatch status >/dev/null 2>&1 
then 
	clear
${ECHO}  "${WARN} Tasker is currently running!!$B"
	${ECHO} "\n\nYou must shut down tasker in order to register your license key.\n"
	if prompt y "Shut down tasker at this time?" 
	then
		${ECHO} "\nShutting down tasker ..."
		$BPDIR/bin/dispatch stop 
		if [ $? -eq 0 ]; then ${ECHO} "Success!!"; else ${ECHO} "Failed!!"; fi
		BRINGUP_TASKER=YES
		pressret; 
	fi
	clear
else
BRINGUP_TASKER=NO
fi
return
}

: ${LicEmail:="lic_request@unitrends.com"}  # Our Email address for licensing

LM_EMAIL="$LicEmail"
PROD=""
INSTDEV="/dev/install"
EXP=""
prodname=""
ltype=""
utype=""
ftype=""
LICchanged=1	# not changed
LM_LAST_CMD=""

bpsh_init; [ $? -ne 0 ] && ${ECHO} $?

BPUTIL=$BPDIR/bin/bputil
LMMGR=$BPDIR/bin/lmmgr
LMBRAND=$BPDIR/bin/lmbrand

[ -d /usr/5bin ] && { PATH="/usr/5bin:${PATH}"; export PATH; }
PATH="$BPDIR/bin:$PATH:/usr/sbin"


##
## source a section of an INI file
## Usage: source_ini_section <section> <file>
##
## Please Note: Any illegal characters in the variables will be removed:
##	ie. Start-Dir=/tmp/foo  ->  StartDir=/tmp/foo
##
source_ini_section()
{
	tmpf=/tmp/bpvar.$$
	
	# The sed removes:
	#	illegal chars in variable names.
	#	whitespace before/after the equal(=) sign.
	#	leading whitespace.
	#	puts quotes around value of variable
	$BPUTIL -g "$1" NULL "" "$2" | grep = | sed -e 's/-\(.*=\)/\1/;s/[ 	]*=[ 	]*/=/;s/=\(.*\)/=\"\1\"/' -e 's/^[ 	]*//' > $tmpf
	eval `cat $tmpf`
	export `cat $tmpf | awk -F= '{print $1}'`

	rm -f $tmpf
}

lmgr_help()
{
    cat << EOF 

License Management Help.

${REV}Generate License Upgrade Request$ROFF
--------------------------------
These options allow you to create a ${SEL}license upgrade request${B}, depending
upon the changes you want to your license.  For example, you can generate a
request to ${LT}extend${B} the expiration period of a demo or you can
generate a request to ${LT}upgrade$B a demo to a full license.

The request is stored in a file and you later have the ability through
the menu options to print, email or view the license request.  If you email the
request, you should still print it so that you have a hard copy to go by when
you have to register the license.

Once the distribution center has received your request, they will process it
and return to you a new ${SE2}license key$B (see the next section).
EOF
pressret; clear

cat << EOF

${REV}Register a License Upgrade$ROFF
--------------------------------
Once you have made your ${SEL}license upgrade request${B} to the distribution center,
they will return to you new license information which includes 
a ${SE2}license key${B}.  In all cases except for a serial number change,
this will be a simple matter of entering a new ${SE2}license key${B}.  Otherwise, 
enter information from the license sheet carefully and exactly as 
requested for each item of the license.




${REV}Re-Installing a License$ROFF
--------------------------------
The license information you receive will be valid until the Expiration Date
field has expired.  At any time, you may re-install the software from the
distribution media and using this menu, re-register your license using
the ${SE2}license key$B specified in the previous paragraph.

EOF
}

new_printer(){
${ECHO} "\nYou must enter the entire printer command to use"
${ECHO} "For example, if you have a printer called \"${SE2}accounting1${BASE}\", you
should enter the line \"${SE2}lpr -d accounting1${BASE}\""
promptfor PRINTER_CMD "Enter the complete printer command to use:"
## We don't update the config file here because the unattended report
## may go to a different printer.
${ECHO} "\nThankyou!!\n\nThe new printer command is: ${SE2}$PRINTER_CMD${BASE}\n"
}
##
##  print the license upgrade request
##
lmgr_print_request()
{
    while [ 1 ]; do
   	clear
${ECHO} "$LMLINE_U"
${ECHO} "\t$v                    $REV  Print License Request  $ROFF                  $v"
${ECHO} "$LMLINE_L"
        ${ECHO} "\n"
        cat << EOF
You may elect to print the license request now, or not print from here, and
print it yourself at a later time.  If you have access to the Internet, you
may deliver the request by email.  The license request is in the file
	${LT}/tmp/newlic.req${BASE}

EOF
		${ECHO} "\n\n${SEL}Please choose:"
        ${ECHO} "    ${SEL}1${BASE})  ${LT}P${BASE}rint license request    [Printer command: ${SE2}$PRINTER_CMD${BASE}]"
        ${ECHO} "    ${SEL}2${BASE})  ${LT}C${BASE}hange above printer command/destination."
        ${ECHO} "    ${SEL}3${BASE})  ${LT}V${BASE}iew license request."
	if [ -n "$LM_EMAIL" ]; then
	    ${ECHO} "    ${SEL}4${BASE})  ${LT}M${BASE}ail license request to \"${SE2}$LM_EMAIL${BASE}\""
	fi
        ${ECHO} "\n${SEL}Enter choice or '${LT}q${B}${SEL}' to quit: $B\c"
        read ans

        case $ans in
	    1 | P | p )
			[ -z "$PRINTER_CMD" ] && PRINTER_CMD=lpr
			${ECHO} "\n\nPrinting Request using command \"${SE2}${PRINTER_CMD}${BASE}\"..."
         	${PRINTER_CMD} /tmp/newlic.req
	        pressret
	        ;;
	    3 | V | v )
		clear
	        ${PAGER:="more"} /tmp/newlic.req
	        pressret
	        ;;
		2|c|C) clear; new_printer ; pressret; clear;;
	    4 | M | m )
		clear
		cat <<EOF

                       ${WARN} * * * DECISION * * * $B

You must have a direct ${SEL}Internet mail connection${BASE} from 
this machine in order for this to work.  If you do not have a direct 
${SEL}Internet mail connection${BASE}, strike '${LT}q$B' to quit.
EOF
		pressretq || continue
		clear
		${ECHO}
		${ECHO} "Sending license request to \"${SE2}${LM_EMAIL}${BASE}\" ..."
		mail -s "License Request" $LM_EMAIL < /tmp/newlic.req
		if [ $? -eq 0 ]; then
		    ${ECHO} "
The ${SEL}license request${B} has been sent and you will soon get a response by email."
		${ECHO} "
You should now print the ${SEL}license request${B} to be used as a reference. 
Keep this on hand while you are awaiting return email. If you do not get
a response from us within several days you can send this printed 
${SEL}license request${B} to us via fax or US Mail."
		else
		    ${ECHO} "\n${WARN}Error sending license request!!$B"
		    ${ECHO} "License request DID NOT get delivered!"
		fi
		pressret
		;;
	    99|X|x|q|Q )
	        break
	        ;;
        esac
    done

    ${ECHO} "\n"
}

##
##  lmgr_demo_menu  --  allows user to manage his license for a product
##
##	Usage: lmgr_demo_menu <product_path>
##
lmgr_demo_menu()
{
    if [ -z "$1" -o ! -f "$1" ]; then
	${ECHO} "lmgr_menu: Can't find product path."
	return 1
    fi

    PROD="$1"

    while [ 1 ]
    do
   	clear
${ECHO} "$LMLINE_U"
${ECHO} "\t$v               $REV  License Management Menu Facility  $ROFF            $v"
${ECHO} "\t$v      (c) Copyright 2006 - Unitrends Software Corporation      $v"
${ECHO} "\t$v                                                               $v"
${ECHO} "\t$v                       Product: ${LT}$prodname${BASE}      $v"
${ECHO} "\t$v                       Type:    ${LT}$ltype${BASE}      $v"
${ECHO} "\t$v                       Points:  ${LT}$utype${BASE}      $v"
${ECHO} "\t$v                       Feature: ${LT}$ftype${BASE}      $v"
${ECHO} "\t$v                       Expires: ${LT}$EXP${BASE}      $v"
${ECHO} "$LMLINE_L"
   	${ECHO} "\n\n${SEL}Please choose:"
	${ECHO} "    ${SEL}1${BASE})  Generate registration to obtain ${LT}P${BASE}ERMANENT license and support"
        ${ECHO} "    ${SEL}2${BASE})  Generate registration to ${LT}E${BASE}XTEND a DEMO for more time"
        ${ECHO} "    ${SEL}3${BASE})  ${LT}R${BASE}egister license, now that you have received return fax"
        ${ECHO} "    ${SEL}4${BASE})  ${LT}V${BASE}iew license info for product"
        ${ECHO} "    ${SEL}5${BASE})  ${LT}H${BASE}elp"

	${ECHO} "\n${SEL}Enter choice or '${LT}q${B}${SEL}' to quit: $B\c"
	read ans

	case $ans in
	    1 | P | p )
		clear
		LMARGS="-fp $PROD -upgrade -request -e none -us see_invoice"
		${LMBRAND} $LMARGS $LMCLIENT_ARGS
		status=$?
		pressret
		[ -f newlic.req ] && mv newlic.req /tmp
		if [ $status -eq 0 ]; then
		    lmgr_print_request
		fi
		;;
	    2 | E | e )
		clear
		LMARGS="-fp $PROD -extend -request"
		${LMBRAND} $LMARGS $LMCLIENT_ARGS
		status=$?
		pressret
		if [ $status -eq 0 ]; then
		    lmgr_print_request
		fi
		;;
	    3 | R | r )
		shutdown_tasker
		if [ ! -w $PROD ]; then
		    clear
		    ${ECHO} "You don't have permission to write $PROD"
		    pressret
		    continue
		fi
		if prompt n "Are you registering a DEMO extension?"
		then
		    demoext=1
		    clear
		    LMARGS="-fp $PROD -extend -upgrade"
		    LMLAST_ARGS="-extend -upgrade"
		else
		    demoext=0
		    LMARGS="-fp $PROD -upgrade"
		    LMLAST_ARGS="-upgrade"
		    clear

		fi
		clear

		${LMBRAND} $LMARGS $LMCLIENT_ARGS
		STATUS=$?
		FULL_OR_DEMO="`${LMMGR} -info "%t" $PROD 2>/dev/null`"
		if [ $STATUS -eq 0 -a "$FULL_OR_DEMO" = FULL ]; then
		    LICchanged=0
			ltype=`${ECHO} "$FULL_OR_DEMO" |
				awk -F= '{printf "%-25s", $1}' 2>/dev/null `
		    LM_LAST_CMD="${LMBRAND} $LMLAST_ARGS"
		    if [ $demoext -eq 0 ]; then
				rm -f $HOMEBASE/LM_License # If present, triggers notices
				pressret; clear
				if [ -d /usr/cactus/airbag  -a ! -f /usr/cactus/airbag/Last_A1 ]
				then
					${ECHO} "\n${WARN}WARNING!!! ${B}"
${ECHO} "
Please don't forget to generate your A1 and A2 Airbag diskettes. 
You will need these when your Server crashes."
${ECHO} "\n
Remember, it is wise to always regenerate ${LT}2 copies${B} of your A2-Airbag disektte!!"
				pressret; clear
				fi
		        lmgr_full_menu $PROD 
		        break
		    fi
		fi
		bringup_tasker
		pressret
		;;
	    4 | V | v )
		clear
		${LMMGR} -info $PROD  2>&1 | ${PAGER:="more"}
		pressret
		;;
	    5 | H | h )
		clear
		lmgr_help
		pressret
		;;
		u|U|unload)
		clear
		${ECHO} "\nSorry, you can only unload (de-install) a FULL license."
		${ECHO} "\nYou have a DEMO license."
		pressret
		;;
	    99 | X | x|q|Q )
		break
		;;
	esac
    done
}

##
##  lmgr_full_menu  --  allows user to manage his license for a product
##
##	Usage: lmgr_full_menu <product_path>
##
lmgr_full_menu()
{
    if [ -z "$1" -o ! -f "$1" ]; then
	${ECHO} "lmgr_menu: Can't find product path."
	return 1
    fi

    PROD="$1"

    while [ 1 ]
    do
   	clear
${ECHO} "$LMLINE_U"
${ECHO} "\t$v               $REV  License Management Menu Facility  $ROFF            $v"
${ECHO} "\t$v      (c) Copyright 2006 - Unitrends Software Corporation      $v"
${ECHO} "\t$v                                                               $v"
${ECHO} "\t$v                       Product: ${LT}$prodname${BASE}      $v"
${ECHO} "\t$v                       Type:    ${LT}$ltype${BASE}      $v"
${ECHO} "\t$v                       Points:  ${LT}$utype${BASE}      $v"
${ECHO} "\t$v                       Feature: ${LT}$ftype${BASE}      $v"
${ECHO} "$LMLINE_L"
   	${ECHO} "\n\n${SEL}Please choose:"
        ${ECHO} "    ${SEL}1${BASE})  Generate registration to ${LT}U${BASE}PGRADE a license"
        ${ECHO} "    ${SEL}2${BASE})  ${LT}R${BASE}egister license, now that you have received return fax"
        ${ECHO} "    ${SEL}3${BASE})  ${LT}V${BASE}iew license info for product"
        ${ECHO} "    ${SEL}4${BASE})  ${LT}H${BASE}elp"

	${ECHO} "\n${SEL}Enter choice or '${LT}q${B}${SEL}' to quit: $B \c"
	read ans

	case $ans in
	    1 | U | u )
		clear
		e=`${LMMGR} -info '%f' $PROD 2>/dev/null`
		us=`${LMMGR} -info '%U' $PROD 2>/dev/null`
		LMARGS="-fp $PROD -upgrade -request"
		${LMBRAND} $LMARGS -e "$e" -us "$us" -d "" $LMCLIENT_ARGS
		status=$?
		pressret
		if [ $status -eq 0 ]; then
		    lmgr_print_request
		fi
		;;
	    2 | R | r )
		clear
		shutdown_tasker
		if [ ! -w $PROD ]; then
		    ${ECHO} "You don't have permission to write $PROD"
		    pressret
		    continue
		fi
		LMARGS="-fp $PROD -upgrade"
		${LMBRAND} $LMARGS $LMCLIENT_ARGS
		if [ $? -eq 0 ]; then
		    LICchanged=0
		    LM_LAST_CMD="${LMBRAND} -upgrade $LMCLIENT_ARGS"
		fi
		bringup_tasker
		pressret
		;;
	    3 | V | v )
		clear
		${LMMGR} -info $PROD  2>&1 | ${PAGER:="more"}
		pressret
		;;
	    4 | H | h )
		clear
		lmgr_help
		pressret
		;;
		u|U|unload) lm_uninstall ;;

	    99 | X | x|q|Q )
		break
		;;
	esac
    done
}

lm_uninstall() {
clear
${ECHO} "                     ${WARN} *  *  *  WARNING  * * *$B  "
${ECHO} "\nThis will completely remove your licence from the system."
${ECHO} "\nUse this only if you are doing a license transfer from one "
${ECHO} "system to another.  This should be done under guidance of our "
${ECHO} "technical support staff."
${ECHO} "\nYou ${SE2}will NOT be able to run${B} this product when this is finished!!"
prompt n "Do you wish to continue?" || return 1
clear
${ECHO} "                     ${WARN} *  *  *  WARNING  * * *$B  "
${ECHO} "\nThis is your last chance to quit.  If you proceed beyond this point,"
${ECHO} "your license will be de-installed and you can no longer run this software!!"
${ECHO} "\nOnly proceed beyond this point upon instructions from our technical"
${ECHO} "support staff."
prompt n "Do you wish to continue?" || return 1
clear
${ECHO} "Once the license is de-installed, a ${SEL}checksum number$B will be displayed"
${ECHO} "Write this ${SEL}checksum number$B down, and give it to our technical support staff."
${ECHO} "\nThis confirms that you actually de-installed the license and is "
${ECHO} "necessary in order to transfer the product to another machine."
prompt n "Do you wish to continue?" || return 1
clear
FULL_OR_DEMO="`${LMMGR} -info "%t" $PROD 2>/dev/null`"
if [ "$FULL_OR_DEMO" = "NONE" ] ; then
	${ECHO} "\nLicense has already been unloaded (de-installed)!!"
else
	${ECHO} "De-installing License ..."
	${LMBRAND} -unload -fp $PROD && ${ECHO} "\n                 ${WARN}^^^^^^^^^^$B${SEL}---> write this number down!!$B"
fi
pressret
}

lmgr_get_install_device()
{
    clear
    cat << EOF
Please place the distribution media for the product into the installation
device.  Enter the name of the installation device at the prompt.

EOF

    dev="${INSTDEV:=/dev/fd0}"
	INSTDEV=
    while [ -z "$INSTDEV" ]; do
        promptfor dev "Enter Install Device: \c"
	if [ -n "$dev" ]; then
	    if [ ! -b "$dev" -a ! -f "$dev" ]; then
		${ECHO} "\nERROR: Install device must be a block device.\n"
	    else
	        INSTDEV="$dev"
	    fi
	fi
    done
}

## do the last lmbrand to this file
##    Usage: lmgr_same_lic <from_path> <to_path>
##
lmgr_same_lic()
{
    if [ -z "$LM_LAST_CMD" ]; then
	return 0
    fi

    $LM_LAST_CMD -fp $2 -y $1
}

#######################################################################
##
##    MAIN
##
##    Exported variables that these routines may use:
##
##	LM_EMAIL:	your email address where the user sends the
##			license request.
##	LM_FAX_HEADER:  path to a file containing fax sheet header
##			information where the user should send the
##			license upgrade request.  Used by the program
##			"lmbrand".
##	PATH:		MUST contain the path to the lm programs,
##			lmbrand and lmmgr.
##
#######################################################################

## Usage: lmgr_menu <path_to_product_binary>
## 	return 0 if license was changed, 1 if not.
##
lmgr_menu()
{
    LICchanged=1	# not changed
    LM_LAST_CMD=""

    if [ $# -ne 1 ]; then
		${ECHO} "Usage: lmgr_menu <path_to_product_binary>"
		return 0
    fi

	. $BPDIR/bin/ctlib
    if [ -z "$GRAPHICS_INIT" -o "$GRAPHICS_INIT" = NO ]; then
        graphics_init
    fi
	${ECHO} " "
    
    Ltype=`${LMMGR} -info %t $1 2> /dev/null`
    ltype=`${ECHO} $Ltype | awk '{printf "%-25s", $1}'`
	Utype=`${LMMGR} -info %U $1 2> /dev/null`
	utype=`${ECHO} $Utype | awk '{printf "%-25s", $1}'`
	Ftype=`${LMMGR} -info %f $1 2> /dev/null`
	ftype=`${ECHO} $Ftype | awk '{printf "%-25s", $1}'`
    Prodname=`${LMMGR} -info %p $1 2> /dev/null`
    prodname=`${ECHO} $Prodname | awk '{printf "%-25s", $1}'`

    if [ -z "$LM_DAEMON" -o "$LM_DAEMON" = "NO" ]; then
		hostid=`${LMMGR} -hostid -q 2> /dev/null`
        LMCLIENT_ARGS="-c $hostid -u 0"
    fi

    if [ -n "$Ltype" -a "$Ltype" = "DEMO" ]; then
		exp=`${LMMGR} -info %e $1 2> /dev/null`
		EXP=`${ECHO} $exp | awk '{printf "%-25s", $1}'`
        lmgr_demo_menu $1
    else
        lmgr_full_menu $1
    fi

    return $LICchanged
}

######################################################################
##
##    MAIN
##
######################################################################

## get tech support info straight
##
source_ini_section "Tech Support Information" $BPDIR/bpinit/master.ini
[ -z "$OurVoice" ] && OurVoice="$OURVOICE"
[ -z "$OurFaxno" ] && OurFaxno="$OURFAX"
[ -z "$OurEmail" ] && OurEmail="$OUREMAIL"
[ -z "$YourDealer" ] && YourDealer="$YOURDEALER"
[ -z "$YourName" ] && YourName="$YOURNAME"
[ -z "$YourVoice" ] && YourVoice="$YOURVOICE"
[ -z "$YourFaxno" ] && YourFaxno="$YOURFAX"
[ -z "$YourEmail" ] && YourEmail="$YOUREMAIL"
[ -z "$LicEmail" ] && LicEmail="$LM_EMAIL"
LM_EMAIL="$LicEmail"
export OurVoice OurFaxno OurEmail YourDealer YourName YourVoice YourFaxno LicEmail

# # This is used by lmbrand when making a license request
LM_FAX_HEADER="$BPDIR/bpinit/lm_fax_header"
export LM_FAX_HEADER
${ECHO} " To: $YourDealer" > $LM_FAX_HEADER
${ECHO} "Fax: $OurFaxno" >> $LM_FAX_HEADER
${ECHO} "" >> $LM_FAX_HEADER
${ECHO} "BP Version: " "8.2.0-6.20150912_1625" >> $LM_FAX_HEADER
${ECHO} "Copyright (C) 1994-2010, Unitrends Software Corp.  All rights reserved." >> $LM_FAX_HEADER
${ECHO} "" >> $LM_FAX_HEADER

lmgr_menu $*
