#!/usr/bin/php -q
<?php
bp_bypass_cookie(3);
$all_storage = bp_get_storage_list();
foreach ($all_storage as $sid => $sname) {
	if ($sid != 1) {
		$storage_info = bp_get_storage_info($sid);
		if (!isset($storage_info)) 
			continue;
		$usage = $storage_info["usage"];
		$type = $storage_info["type"];
		$online = $storage_info["online"];

		# Check for NAS storages which are being protected.
		if (($type == "4") && ($usage == "source")) {
        		echo "checking storage: [ $sname ] ...\n";
			if ($online == true) {

				# If the sorage is mounted under "/backups", then 
				# unmount the storage and remount on "/mnt/nas".
				$protocol = $storage_info["properties"]["protocol"];
				$hostname = $storage_info["properties"]["hostname"];
				$port = $storage_info["properties"]["port"];
				$share_name = $storage_info["properties"]["share_name"];
				$mountpath = "/backups/$sname";
				$newmountpath = "/mnt/nas/$sname";

				# Construct string pattern to be searched in 'mount' cmd  output
				# as e.g. "//192.168.20.13/Development on /backups/test type"
				switch($protocol) {
					case "cifs" :
						$search_str="$hostname/$share_name on /backups/$sname type";
						break;
					case "nfs" :
						$search_str="$hostname:/$share_name on /backups/$sname type";
						break;
				}
				$mount_output = shell_exec('mount');
				$migrate_mount_point = strstr($mount_output, $search_str);

				if ($migrate_mount_point) {
					# Disconnnect the storage.
					$res = bp_disconnect_storage($sid);
					if ($res == false) {
			  			echo "Failed to disconnect.\n";
						continue;
					}	
					# Re-connnect the storage.
					$res = bp_connect_storage($sid);
					if ($res == $sid) {
			  			echo "Mount point successfully migrated.\n";
						#Alert user to Modify include and exclude lists.
                                		bp_send_notification(108, $sname, $mountpath, $newmountpath);
					} else {
			  			echo "Failed to migrate Successfully migrated.\n";
					}
				} else 
					echo "Migration not required.\n";
			} else {
				#Get version for the locally installed software.
				$sysinfo = bp_get_system_info(1);
				if (!isset($sysinfo)) 
					continue;

				#Check if version is less then equal to 6.1 Beta.
				$result = $sysinfo['version'];
				$split_version = explode('-', $result, 2);
				$after_dash = explode('.', $split_version[1], 3);
				$version = explode('.', $split_version[0], 3); 
				if ($version[0] < 6) {
					$alert_flg="1";
				} else if (($version[0] == 6) && ($version[1] < 1)) {
					$alert_flg="1";
				} else if (($version[0] == 6) && ($version[1] == 1) && ($version[2] == 0) && ($after_dash[0] < 1)) {
					$alert_flg="1";
				} else {
					$alert_flg="0";
				}
				#Alert if required.
				if ($alert_flg == "1") {
					# Raise an alert saying storage has been 
					# migrated to "/mnt/nas/storage", ask user to 
					# Modify include and exclude lists.
					$mountpath = "/backups/$sname";
					$newmountpath = "/mnt/nas/$sname";
			  		echo "Mount point will be migrated on next connect.\n";
                                	bp_send_notification(108, $sname, $mountpath, $newmountpath);
				} else {
					echo "No need to Alert [ as Version: $result ]\n";
				}
			}
		}
	}
}
?>
