#!/bin/sh
#
#	BP schedule After-Command example
#

#
# source some BP shell include files
. $BPDIR/util/bpsh.inc
. $BPDIR/util/lcsutil.inc

#
# setup the BP shell environment
bpsh_init

#
# parse the first backup from the list that was set in the environment before
# this command was called
BpLcsGetFirstStatus

#
# step through each backup and tell what we know about it
while [ -n "$_NEXT_BACKUP" ]; do
	case "$_NEXT_TYPE" in
	M)
		$ECHO "Master backup \c"
		;;
	V)
		$ECHO "    Verify after \c"
		;;
	S)
		$ECHO "Selective backup \c"
		;;
	I)
		$ECHO "Incremental backup \c"
		;;
	esac
	
	if [ $_NEXT_BACKUP -gt 0 ]; then
		$ECHO "#$_NEXT_BACKUP, \c"
		[ "$_NEXT_STATUS" = "success" ] && $ECHO "SUCCESSFUL."
		[ "$_NEXT_STATUS" = "failed" ] && $ECHO "FAILED."
		[ "$_NEXT_STATUS" = "none" ] && $ECHO "was not performed."
	else
		$ECHO "was not performed."
	fi
	
	#
	# parse next backup info
	BpLcsGetNextStatus
done

exit 1	# exit != 0 puts output into backup messages for the task.
