<?php

//in progress
class Backups
{
    private $BP;

    public function __construct($BP, $sid)
    {
        $this->BP = $BP;
        $this->now = time();
        $this->sid = $sid;

        require_once('function.lib.php');
        $this->functions = new Functions($this->BP);

	$this->SYSTEM_METADATA = "system metadata";

        $this->GLOBAL_BACKUP_TYPES = array(
            "master",
            "differential",
            "incremental",
            "baremetal",
            "selective",
            "mssql full",
            "mssql differential",
            "mssql transaction",
            "exchange full",
            "exchange differential",
            "exchange incremental",
            "legacy mssql full",
            "legacy mssql diff",
            "legacy mssql trans",
            "vmware full",
            "vmware differential",
            "vmware incremental",
            "hyperv full",
            "hyperv incremental",
            "hyperv differential",
            "oracle full",
            "oracle incr",
            "sharepoint full",
            "sharepoint diff",
            "ucs service profile full",
            "integrated bm restore",
            "ndmp full",
            "ndmp diff",
            "ndmp incr"
        );

    }


    public function get($which, $filter, $sid)
    {
        switch ($which) {
            case -1:
                $cid = isset($_GET['cid']) ? (int)$_GET['cid'] : null;
                $iid = isset($_GET['iid']) ? (int)$_GET['iid'] : null;
                $bid = isset($_GET['bid']) ? $_GET['bid'] : null;
                $startDate = isset($_GET['start_date']) ? $_GET['start_date'] : strtotime(Constants::DATE_ONE_WEEK_AGO);
                $endDate = isset($_GET['end_date']) ? $this->functions->formatEndDate($_GET['end_date']) : strtotime('now');

                //did they pass in sid, cid, iid, or a bid list?
                if ($sid !== false) {
                    $inputArray = array(
                        'system_id' => $sid,
                        'start_time' => $startDate,
                        'end_time' => $endDate
                    );

                    if ($cid !== null) {
                        $inputArray = array_merge($inputArray, array('client_id' => (int)$cid));
                    }
                    if ($iid) {
                        $inputArray = array_merge($inputArray, array('instance_id' => $iid));
                    }
                    if ($bid) {
                        $bidArray = array_map('intval', explode(',', $bid));
                        $inputArray = array_merge($inputArray, array('backup_ids' => $bidArray));
                        unset($inputArray['start_time']);
                    }

                    $backupStatus = $this->BP->get_backup_status($inputArray);
                    if ($backupStatus !== false) {
                        foreach ($backupStatus as $backup) {
                            $data["BackupStatus"][] = $this->buildOutput($backup, $sid);
                        }
                    }
                } else {
                    $systems = $this->BP->get_systems();
                    foreach ($systems as $id => $name) {
                        $inputArray = array(
                            'system_id' => $id,
                            'start_time' => $startDate,
                            'end_time' => $endDate
                        );

                        $backupStatus = $this->BP->get_backup_status($inputArray);
                        if ($backupStatus !== false) {
                            foreach ($backupStatus as $backup) {
                                $data["BackupStatus"][$name][] = $this->buildOutput($backup, $sid);
                            }
                        }
                    }
                }
                break;

            case "details":
                if (isset($_GET['bid'])) {
                    $bid = $_GET['bid'];
                    $backups = array_map('intval', array_filter(explode(',', $bid), 'is_numeric'));
                    if ($sid == false) {
                        $data = false;
                    } else {
                        $inputArray = array(
                            'system_id' => $sid,
                            'backup_ids' => $backups
                        );
                        $backupInfoArray = $this->BP->get_backup_info($inputArray);
                        if ($backupInfoArray !== false) {
                            foreach ($backupInfoArray as $backupInfo) {
                                $data["BackupInfo"][] = $this->buildInfoOutput($backupInfo);
                            }
                        }
                    }
                }
                break;
            case "catalog" :
                $cid = isset($_GET['cid']) ? (int)$_GET['cid'] : false;
                $iid = isset($_GET['iid']) ? (int)$_GET['iid'] : false;
                $aid = isset($_GET['aid']) ? (int)$_GET['aid'] : false;
                $startDate = isset($_GET['start_date']) ? strtotime($_GET['start_date']) : strtotime(Constants::DATE_ONE_WEEK_AGO);
                $endDate = isset($_GET['end_date']) ? $this->functions->formatEndDate($_GET['end_date']) : strtotime('now');
                $view = isset($_GET['view']) ? $_GET['view'] : "system";
                $gclients = isset($_GET['grandclients']) ? $_GET['grandclients'] : false;
                $metadata = isset($_GET['metadata']) ? $_GET['metadata'] : false;

                $result_format['type'] = $this->GLOBAL_BACKUP_TYPES;
                if ($metadata) {
                    $result_format['type'][] = $this->SYSTEM_METADATA;
                }
                $result_format['start_time'] = $startDate;
                $result_format['end_time'] = $endDate;
                $result_format['grandclients'] = $gclients;

                if($cid){
                    $result_format['client_id'] = $cid;
                }
                if($iid){
                    $result_format['instance_id'] = $iid;
                }
                if($aid){
                    $result_format['application_id'] = $aid;
                }

                if ($sid == false) {
                    $systems = $this->functions->selectSystems();
		            $data["catalog"] = array();
                    foreach ($systems as $sid => $name) {
                        $result_format['system_id'] = $sid;
                        if ($view !== false){
                            $data["catalog"] = $this->merge_view($data["catalog"], $this->getBackupsByView($view, $result_format, $sid), $view);
                        }
                    }

                } else {
                    $result_format['system_id'] = $sid;
                    if ($view !== false){
                        $data["catalog"] = $this->getBackupsByView($view, $result_format, $sid);
                    }
                }
                if ($view == 'day') {
                    // If day view, sort all days in the catalog.
                    $orderByDate = array();
                    foreach ($data["catalog"] as $key => $row) {
                        $orderByDate[$key] = strtotime($row['day']);
                    }
                    array_multisort($orderByDate, SORT_DESC, $data["catalog"]);
                }
                break;

            case "search" :
                $timestr = isset($_GET['timestr']) ? $_GET['timestr'] : "";
                $searchID = array('pid' => (int)$filter, 'timestr' => $timestr);

                $searchResults = $this->BP->get_file_search_results($searchID, $sid);

                if ($searchResults !== false) {
                    foreach ($searchResults as $search) {
                        $fileID = isset($search['id']) ? $search['id'] : "";
                        $bid = isset($search['backup_id']) ? $search['backup_id'] : "";
                        $type = isset($search['type']) ? $search['type'] : "";
                        $directory = isset($search['directory']) ? $search['directory'] : "";
                        $name = isset($search['name']) ? $search['name'] : "";
                        $size = isset($search['size']) ? $search['size'] : "";
                        $date = isset($search['date']) ? $this->functions->formatDateTime($search['date']) : "";

                        $data["results"][] = array(
                            'id' => $fileID,
                            'backup_id' => $bid,
                            'type' => $type,
                            'directory' => $directory,
                            'name' => $name,
                             'size' => $size,
                            'date_string' => $date
                        );
                    }
                }
                break;
            case 'files':
                $bid = (int)$filter;
                $start = isset($_GET['dir']) ? $_GET['dir'] : "";
                $last = isset($_GET['last']) ? $_GET['last'] : "";
                $count = isset($_GET['count']) ? (int)$_GET['count'] : 0;
                $files = $this->BP->get_backup_files($bid, $start, $last, $count, $sid);
                if($files != false) {
                    for($i = 0; $i < count($files); $i++) {
                        unset($files[$i]['parent']);
                        unset($files[$i]['size']);
                        unset($files[$i]['date']);
                        if(array_key_exists('has_children', $files[$i])) {
                            $files[$i]['branch'] = $files[$i]['has_children'];
                            unset($files[$i]['has_children']);
                        }
                    }
                    $data = array();
                    $data['data'] = $files;
                    $data['count'] = $count;
                    $data['total'] = count($files);
                } else {
                    $data = $files;
                }
                break;
            case "related" :
                if ($which) {
                    if (is_string($filter)){
                        $backupIDs = explode(',', $filter);
                        $related = array();
                        foreach($backupIDs as $backupID){
                            $related = array_merge($related, $this->processRelatedBackups($backupID, $this->sid));
                        }
                        if (isset($_GET['original'])) {
                            // include input backups in return array.
                            $bidArray = array_map('intval', $backupIDs);
                            $inputArray = array(
                                'system_id' => $this->sid,
                                'backup_ids' => $bidArray
                        	);
                            $original = array();
                            $backupStatus = $this->BP->get_backup_status($inputArray);
                            if ($backupStatus !== false) {
                                foreach ($backupStatus as $backup) {
                                    $original[] = $this->buildOutput($backup, $this->sid);
                                }
                            }
                            $related = array_merge($related, $original);
                        }
                        $data['data'] = $related;
                    }
                }
                break;
        }
        return $data;

    } // end get

    function processRelatedBackups($bid, $sid){
	$data = array();

        $relatedBackups = $this->BP->get_related_backups($bid, $sid);
        if ($relatedBackups !== false and !empty($relatedBackups)) {
            foreach ($relatedBackups as $related) {
                $backup = array(
                    'id' => isset($related['id']) ? $related['id'] : "",
                    'type' => isset($related['type']) ? $this->functions->getBackupTypeDisplayName($related['type']) : "",
                    'start_time' => isset($related['start_time']) ? $this->functions->formatDateTime($related['start_time']) : "",
                    'application' => isset($related['app_name']) ? $related['app_name'] : "",
                    'status' => isset($related['status']) ? $this->getBackupCompleteStatus($related) : 'n/a'
                );
                if (isset($related['instance_id'])) {
                    $instanceInfo = $this->BP->get_appinst_info($related['instance_id'], $sid);
                    foreach($instanceInfo as $instance) {
                        $inst = array(
                            'client' => isset($instance['client_name']) ? $instance['client_name'] : "",
                            'primary_name' => isset($instance['primary_name']) ? $instance['primary_name'] : "",
                            'secondary_name' => isset($instance['secondary_name']) ? $instance['secondary_name'] : ""
                        );
                    }
                }
                $legalHoldInfo = $this->BP->get_legalhold_backup_info($bid, $sid);
                if($legalHoldInfo !== false){
                    $legalHoldInfo = current($legalHoldInfo);
                    if(isset($legalHoldInfo['is_on_hold'])){
                        $backup['legalhold'] = $legalHoldInfo['is_on_hold'];
                    }
                }
                $data[] = array_merge($backup, $inst);
            }
        }

        return $data;
    }

    public function search($data, $sid) {

        $result = array();

        $cid = isset($_GET['cid']) ? (int)$_GET['cid'] : null;
        if($data) {
            $searchResult = $this->BP->start_file_search($data, $cid, $sid);

            if ($searchResult !== false) {
                $pid = isset($searchResult['pid']) ? $searchResult['pid'] : "";
                $timestr = isset($searchResult['timestr']) ? $searchResult['timestr'] : "";

                $result = array(
                    'pid' => $pid,
                    'timestr' => $timestr
                );
            }
        } else {
            $result = "Search parameters are required";
        }
        return $result;
    }

    public function delete($backupIDs, $sid)
    {
        $legalHoldIDs = isset($_GET['legalhold']) ? $_GET['legalhold'] : "none";
        $data = $this->BP->delete_backup($backupIDs, $legalHoldIDs, $sid);

        return $data;
    }

    public function put($which, $inputArray){
        if(!isset($inputArray['systemID'])) {
            $dpuID = $this->BP->get_local_system_id();
        } else {
            $dpuID = $inputArray['systemID'];
        }
        return $this->BP->rest_backup_now($inputArray['backup_type'], $inputArray['client_info'], $dpuID);
    }

    public function hold($which, $filter, $sid){
        $legalHoldDays = (int)$filter;
        $bid = $which;
        $data = $this->BP->save_legalhold_per_backup($bid, $legalHoldDays, $sid);

        return $data;
    }

    public function post($input, $sid) {
        $data = array();
        $backupStatus = $this->BP->get_backup_status($input);
        foreach ($backupStatus as $backup){
           $data["data"][] = $this->buildOutput($backup, $sid);
        }

        return $data;
    }

    function buildOutput($backup, $sid){

        $id = isset($backup['id']) ? $backup['id'] : null;
        $ids = $id != null ? array($id) : array();
        $inputArray = array(
            'system_id' => $sid,
            'backup_ids' => $ids,
        );
        $backupInfoArray = $this->BP->get_backup_info($inputArray);

        if ($backupInfoArray !== false){
            foreach ($backupInfoArray as $backupInfo){
                $output = isset($backupInfo['output']) ? $backupInfo['output'] : "n/a";
                $purgeable = isset($backupInfo['purgeable']) ? $backupInfo['purgeable'] : "n/a";
                $last = isset($backupInfo['last']) ? $backupInfo['last'] : "n/a";
            }
        }

        $type = isset($backup['type']) ? $this->functions->getBackupTypeString($backup['type']) : null;
        $restoredBackupType = (isset($backup['restored_bkup_type']) && $backup['type'] == "virtual restore") ? $this->functions->getBackupTypeString($backup['type']) : null;
        $clientID = isset($backup['client_id']) ? $backup['client_id'] : null;
        $clientName = isset($backup['client_id']) ? $this->getClientName($backup['client_id'], $sid) : null;
        $startTime = isset($backup['start_time']) ? $this->functions->formatDateTime($backup['start_time']) : null;
        $elapsedTime = isset($backup['elapsed_time']) ? $backup['elapsed_time'] : null;
        $complete = isset($backup['complete']) ? $backup['complete'] : null;
        $status = $this->getBackupCompleteStatus($backup);
        $size = isset($backup['size']) ? $backup['size'] : null;
        $files = isset($backup['files']) ? $backup['files'] : null;
        $encrypted = isset($backup['encrypted']) ? $backup['encrypted'] : null;
        $syncStatus = isset($backup['sync_status']) ? $backup['sync_status'] : null;
        $verified = isset($backup['verified']) ? $backup['verified'] : null;

        $verifyStatus = $this->getBackupVerifyStatus($backup);

        $presyncSeconds = isset($backup['presync_seconds']) ? $backup['presync_seconds'] : null;
        $syncSeconds = isset($backup['sync_seconds']) ? $backup['sync_seconds'] : null;
        $postsyncSeconds = isset($backup['postsync_seconds']) ? $backup['postsync_seconds'] : null;
        $syncMessage = isset($backup['sync_message']) ? $backup['sync_message'] : null;
        $serverInstanceName = isset($backup['server_instance_name']) ? $backup['server_instance_name'] : null;
        $serverName  = isset($backup['server_name']) ? $backup['server_name'] : null;
        $databaseName = isset($backup['database_name']) ? $backup['database_name'] : null;
        $instanceID  = isset($backup['instance_id']) ? $backup['instance_id'] : null;
        $appID  = isset($backup['app_id']) ? $backup['app_id'] : null;
        $appName  = isset($backup['app_name']) ? $backup['app_name'] : null;
        $synthesized = isset($backup['synthesized']) ? $backup['synthesized'] : null;
        $synthCapable = isset($backup['synth_capable']) ? $backup['synth_capable'] : null;
        $diskMetadata = isset($backup['disk_metadata']) ? $backup['disk_metadata'] : null;
        $clientConfig = isset($backup['client_config']) ? $backup['client_config'] : null;
        $replicated = isset($backup['replicated']) ? $backup['replicated'] : null;
        $vmWareTemplate = isset($backup['vmware_template']) ? $backup['vmware_template'] : "n/a";
        $certified = isset($backup['certified']) ? $backup['certified'] : "n/a";

        $isCluster = isset($backup['is_cluster']) ? $backup['is_cluster'] : null;
        $guid = isset($backup['guid']) ? $backup['guid'] : null;
        $vmName = isset($backup['vm_name']) ? $backup['vm_name'] : null;

        $backupID = array();

        if($id !== null){
            $backupID = array(
                'id' => $id
            );
        }

        $isSecuresync = $this->functions->isBackupTypeSecuresync($backup['type']);
        $isFileLevel = $this->functions->isBackupFileLevel($backup['type']);
        $isHyperV = $this->functions->isBackupHyperV($backup['type']);
        $isExchange = $this->functions->isBackupExchange($backup['type']);
        $isSQL = $this->functions->isBackupSQL($backup['type']);
        $isVMWare = $this->functions->isBackupVMWare($backup['type']);
        $isVirtualRestore = $this->functions->isBackupVirtualRestore($backup['type']);

        $fileLevel = array();
        $applicationTypes = array();
        $SQLTypes = array();
        $exchangeTypes = array();
        $VMWareTypes = array();
        $syncTypes = array();
        $hyperVTypes = array();
        $virtualRestoreTypes = array();

        if ($isFileLevel){
            $fileLevel = array(
                'files' => $files
            );
        }

        $alwaysReturned = array(
            'client_id' => $clientID,
            'client_name' => $clientName,
            'type' => $type,
            'start_time' => $startTime,
            'synthesized' => $synthesized,
            'synth_capable' => $synthCapable,
            'disk_metadata' => $diskMetadata,
            'client_config' => $clientConfig,
            'replicated' => $replicated,
            'duration' => $elapsedTime,
            'complete' => $complete,
            'status' => $status,
            'size' => $size,
            'encrypted' => $encrypted,
            'verified' => $verified,
            'verify_status' => $verifyStatus,
            'vmware_template' => $vmWareTemplate,
            'certified' => $certified,
            'output' => $output,
            'purgeable' => $purgeable,
            'last' => $last

        );

        if ($appID !== null) {
            $applicationTypes = array(
                'instance_id' => $instanceID,
                'app_id' => $appID,
                'app_name' => $appName,
            );
        }

        if ($isSQL) {
            $SQLTypes = array(
                'server_instance_name' => $serverInstanceName,
                'database_name' => $databaseName
            );
        }

        if ($isExchange) {
            $exchangeTypes = array(
                'database_name' => $databaseName
            );
        }

        if ($isVMWare) {
            $VMWareTypes = array(
                'server_instance_name' => $serverInstanceName,
                'server_name' => $serverName,
                'database_name' => $databaseName
            );
        }

        if($isSecuresync){
            $syncTypes = array(
                'sync_status' => $syncStatus,
                'presync_seconds' => $presyncSeconds,
                'sync_seconds' => $syncSeconds,
                'postsync_seconds' => $postsyncSeconds,
                'sync_message' => $syncMessage
            );
        }

        if($isHyperV){
            $hyperVTypes = array(
                'is_cluster' => $isCluster,
                'guid' => $guid,
                'vm_name' => $vmName
            );
        }

        if ($isVirtualRestore) {
            $virtualRestoreTypes = array(
                'restored_backup_type' => $restoredBackupType
            );
        }

        $data = array_merge($backupID, $alwaysReturned);

        if ($fileLevel !== null){
            $data = array_merge($data, $fileLevel);
        }
        if ($applicationTypes !== null){
            $data = array_merge($data, $applicationTypes);
        }
         if ($syncTypes !== null){
             $data = array_merge($data, $syncTypes);
         }
        if ($hyperVTypes !== null){
            $data = array_merge($data, $hyperVTypes);
        }
        if ($exchangeTypes !== null){
            $data = array_merge($data, $exchangeTypes);
        }
        if ($SQLTypes !== null){
            $data = array_merge($data, $SQLTypes);
        }
        if ($VMWareTypes !== null){
            $data = array_merge($data, $VMWareTypes);
        }
        if ($virtualRestoreTypes !== null){
            $data = array_merge($data, $virtualRestoreTypes);
        }

        return $data;
    }

    function buildInfoOutput($backup){
        $id = isset($backup['id']) ? $backup['id'] : null;
        $deviceID = isset($backup['device_id']) ? $backup['device_id'] : null;
        $output = isset($backup['output']) ? $backup['output'] : null;
        $comment = isset($backup['comment']) ? $backup['comment'] : null;
        $purgeable = isset($backup['purgeable']) ? $backup['purgeable'] : null;
        $last = isset($backup['last']) ? $backup['last'] : null;

        $data = array(
            'id' => $id,
            'device_id' => $deviceID,
            'output' => $output,
            'comment' => $comment,
            'purgeable' => $purgeable,
            'last' => $last
        );

        return $data;
    }

    function getSystemName($sid) {
        $systemName = NULL;
        $systems = $this->BP->get_system_list();
        foreach ($systems as $id => $name) {
            if ($sid == $id) {
                $systemName = $name;
                break;
            }
        }
    return $systemName;
    }

    function getClientName($cid, $sid){
        $clientInfo = $this->BP->get_client_info($cid, $sid);
        $clientName = isset($clientInfo['name']) ? $clientInfo['name'] : null;

        return $clientName;
    }

    function getBackupsByView($view, $result_format, $sid){

        switch($view){
            case "day":
                $data = $this->catalogByDay($result_format, $sid);
                break;
            case "instance":
                $data = $this->catalogByInstance($result_format, $sid);
                break;
            case "storage":
                $data = $this->catalogByStorage($result_format, $sid);
                break;
            case "system" :
                $data = $this->catalogBySystem($result_format, $sid);
                break;

        }
        return $data;
    }

    function getBackupCompleteStatus($backup){
        $status = null;
        if (isset($backup['status'])) {
            $status = $backup['status'];
            if (is_int($status)) {
                // Backup Status: 0 = Successful, 1 = Warning, 2 = Failed.
                $status = ($status === 0) ? 'Successful' : (($status === 1) ? 'Warning' : 'Failed');
            }
        }
        return $status;
    }

    function getBackupVerifyStatus($backup){
        $verifyStatus = null;
        if (isset($backup['verify_status'])) {
            $verifyStatus = $backup['verify_status'];
            if (is_int($verifyStatus)) {
                // verify Status: 0 = Not Applicable, 1 = Successful, 2 = Failed.
                $verifyStatus = ($verifyStatus === 0) ? 'Not Applicable' : (($verifyStatus === 1) ? 'Successful' : 'Failed');
            }
        }
        return $verifyStatus;
    }

    function getBackupDeviceInfo($bid, $sid){
        return null;
        /*
        $data = array();
        $bids[] = $bid;
        $backupInfo = $this->BP->get_backup_info(array('backup_ids' => $bids, 'system_id' => $sid));

        foreach ($backupInfo as $info) {
            $deviceID = isset($info['device_id']) ? $info['device_id'] : false;
            if ($deviceID) {
                $deviceInfo = $this->BP->get_device_info($deviceID);
                if ($deviceInfo) {
                    $data = array(
                        'id' => $deviceID,
                        'name' => $deviceInfo['dev_name'],
                        'mb_size' => $deviceInfo['capacity'],
                        'storage_id' => $deviceInfo['storage_id']
                    );
                }
            } else {
                $data = false;
            }
        }
        */

        return $data;
    }

    function catalogByDay($result_format, $sid){
        $data = false;

        $backups = $this->BP->get_backup_status($result_format, $sid);

        if ($backups !== false) {
	        $data = array();
            $items = array();
            foreach ($backups as $backup) {
                $day = isset($backup['start_time']) ? $this->functions->formatDate($backup['start_time']) : null;
                $synthesized = isset($backup['synthesized']) ? $backup['synthesized'] : "n/a";
                $type = isset($backup['type']) ? $this->functions->getBackupTypeString($backup['type'], $synthesized) : null;
                $appName = isset($backup['app_name']) ? $backup['app_name'] : "";
                $vmWareTemplate = isset($backup['vmware_template']) ? $backup['vmware_template'] : "n/a";
                $startDate = isset($backup['start_time']) ? $this->functions->formatDateTime($backup['start_time']) : null;
                $replicated = isset($backup['replicated']) ? $backup['replicated'] : "";
                $dbName = isset($backup['database_name']) ? $backup['database_name'] : "";
                $bid = isset($backup['id']) ? $backup['id'] : null;
                $clientID = isset($backup['client_id']) ? $backup['client_id'] : null;
                $clientName = $this->getClientName($clientID, $sid);
                $disks = $this->getBackupDeviceInfo($bid, $sid);
                $storage = $this->getStorageType($bid, $sid);
                $instanceID = isset($backup['instance_id']) ? $backup['instance_id'] : null;
                $instanceName = isset($backup['instance_id']) ? $this->BP->get_appinst_name($backup['instance_id']) : "";
                $legalHold = ($bid != null) ? $this->getLegalHoldBackup($bid, $sid) : "n/a";
                $status = isset($backup['status']) ? $backup['status'] : "";
                $importedFromArchive = isset($backup['imported_from_archive']) ? $backup['imported_from_archive'] : "";
                $complete = $backup['complete'];
                if ($complete === true) {
                    $backup = array(
                        'id' => $bid,
                        'type' => $type,
                        'start_date' => $startDate,
                        'disks' => $disks,
                        'legal_hold' => $legalHold,
                        'status' => $status,
                        'replicated' => $replicated,
                        'vmware_template' => $vmWareTemplate,
                        'imported_from_archive' => $importedFromArchive,
                        'storage' => $storage
                    );
                    $index = $this->encode_index($appName, $clientID, $clientName, $dbName, $instanceID, $instanceName, $sid);
                    $items[$day][$index][] = $backup;
                }
            }

            foreach ($items as $day => $indices) {
                $instances = array();
                foreach ($indices as $index => $backups) {
                    $instance = $this->create_instance($index);
                    //sort backups with the most recent first
                    $backups = $this->sortBackups($backups);
                    $instance['backups'] = $backups;
                    $instances[] = $instance;
                }
                $data[] = array('day' => $day, 'instances' => $instances);
            }

        } else {
            global $Log;
            $Log->writeError($this->BP->getError(), true);
        }
        return $data;
    }

    function catalogByInstance($result_format, $sid){
        $data = false;

        $backups = $this->BP->get_backup_status($result_format, $sid);

        if ($backups !== false) {
            $items = array();
            foreach ($backups as $backup) {
                $day = isset($backup['start_time']) ? $this->functions->formatDate($backup['start_time']) : null;
                $synthesized = isset($backup['synthesized']) ? $backup['synthesized'] : "n/a";
                $type = isset($backup['type']) ? $this->functions->getBackupTypeString($backup['type'], $synthesized) : null;
                $appName = isset($backup['app_name']) ? $backup['app_name'] : "";
                $vmWareTemplate = isset($backup['vmware_template']) ? $backup['vmware_template'] : "n/a";
                $startDate = isset($backup['start_time']) ? $this->functions->formatDateTime($backup['start_time']) : null;
                $replicated = isset($backup['replicated']) ? $backup['replicated'] : "";
                $dbName = isset($backup['database_name']) ? $backup['database_name'] : "";
                $bid = isset($backup['id']) ? $backup['id'] : null;
                $clientID = isset($backup['client_id']) ? $backup['client_id'] : null;
                $clientName = $this->getClientName($clientID, $sid);
                $disks = $this->getBackupDeviceInfo($bid, $sid);
                $storage = $this->getStorageType($bid, $sid);
                $instanceID = isset($backup['instance_id']) ? $backup['instance_id'] : null;
                $instanceName = isset($backup['instance_id']) ? $this->BP->get_appinst_name($backup['instance_id']) : "";
                if ($instanceName == "") {
                    $instanceName = $clientName;
                }
                $legalHold = ($bid != null) ? $this->getLegalHoldBackup($bid, $sid) : "n/a";
                $status = isset($backup['status']) ? $backup['status'] : "";
                $importedFromArchive = isset($backup['imported_from_archive']) ? $backup['imported_from_archive'] : "";
                $complete = $backup['complete'];
                if ($complete === true) {
                    $backup = array(
                        'id' => $bid,
                        'type' => $type,
                        'start_date' => $startDate,
                        'disks' => $disks,
                        'legal_hold' => $legalHold,
                        'status' => $status,
                        'replicated' => $replicated,
                        'vmware_template' => $vmWareTemplate,
                        'imported_from_archive' => $importedFromArchive,
                        'storage' => $storage
                    );
                    $index = $this->encode_index($appName, $clientID, $clientName, $dbName, $instanceID, $instanceName, $sid);
                    $items[$instanceName][$index][] = $backup;
                }

            }

	        $data = array();
            foreach ($items as $instanceID => $indices) {
                $instances = array();
                foreach ($indices as $index => $backups) {
                    $instance = $this->create_instance($index);
                    //sort backups with the most recent first
                    $backups = $this->sortBackups($backups);
                    $instance['backups'] = $backups;
                    $instances[] = $instance;
                }
                $data = array_merge($data, $instances);
            }
        } else {
            global $Log;
            $Log->writeError($this->BP->getError(), true);
        }
        return $data;
    }

    function catalogByStorage($result_format, $sid){
        $data = false;

        $backups = $this->BP->get_backup_status($result_format, $sid);

        if ($backups !== false) {
	        $data = array();
            $items = array();
            foreach ($backups as $backup) {
               // $day = isset($backup['start_time']) ? $this->functions->formatDate($backup['start_time']) : null;
                $synthesized = isset($backup['synthesized']) ? $backup['synthesized'] : "n/a";
                $type = isset($backup['type']) ? $this->functions->getBackupTypeString($backup['type'], $synthesized) : null;
                $appName = isset($backup['app_name']) ? $backup['app_name'] : "";
                $vmWareTemplate = isset($backup['vmware_template']) ? $backup['vmware_template'] : "n/a";
                $startDate = isset($backup['start_time']) ? $this->functions->formatDateTime($backup['start_time']) : null;
                $replicated = isset($backup['replicated']) ? $backup['replicated'] : "";
                $dbName = isset($backup['database_name']) ? $backup['database_name'] : "";
                $bid = isset($backup['id']) ? $backup['id'] : null;
                $clientID = isset($backup['client_id']) ? $backup['client_id'] : null;
                $clientName = $this->getClientName($clientID, $sid);
                $disks = $this->getBackupDeviceInfo($bid, $sid);
                $storage = $this->getStorageType($bid, $sid);
                $instanceID = isset($backup['instance_id']) ? $backup['instance_id'] : null;
                $instanceName = isset($backup['instance_id']) ? $this->BP->get_appinst_name($backup['instance_id']) : "";
                $legalHold = ($bid != null) ? $this->getLegalHoldBackup($bid, $sid) : "n/a";
                $status = isset($backup['status']) ? $backup['status'] : "";
                $importedFromArchive = isset($backup['imported_from_archive']) ? $backup['imported_from_archive'] : "";
                $complete = $backup['complete'];
                if ($complete === true) {
                    $backup = array(
                        'id' => $bid,
                        'type' => $type,
                        'start_date' => $startDate,
                        'disks' => $disks,
                        'legal_hold' => $legalHold,
                        'status' => $status,
                        'replicated' => $replicated,
                        'vmware_template' => $vmWareTemplate,
                        'imported_from_archive' => $importedFromArchive,
                        'storage' => $storage
                    );
                    $index = $this->encode_index($appName, $clientID, $clientName, $dbName, $instanceID, $instanceName, $sid);
                    $items[$storage][$index][] = $backup;
                }
            }

            foreach ($items as $storage => $indices) {
                $instances = array();
                foreach ($indices as $index => $backups) {
                    $instance = $this->create_instance($index);
                    //sort backups with the most recent first
                    $backups = $this->sortBackups($backups);
                    $instance['backups'] = $backups;
                    $instances[] = $instance;
                }
                $data[] = array('storage' => $storage, 'instances' => $instances);
            }
        } else {
            global $Log;
            $Log->writeError($this->BP->getError(), true);
        }
        return $data;
    }

    function catalogBySystem($result_format, $sid){
        $data = false;

        $backups = $this->BP->get_backup_status($result_format, $sid);
        $systemName = $this->getSystemName($sid);

        if ($backups !== false) {
            $data = array();
            $items = array();
            foreach ($backups as $backup) {
                $day = isset($backup['start_time']) ? $this->functions->formatDate($backup['start_time']) : null;
                $synthesized = isset($backup['synthesized']) ? $backup['synthesized'] : "n/a";
                $type = isset($backup['type']) ? $this->functions->getBackupTypeString($backup['type'], $synthesized) : null;
                $appName = isset($backup['app_name']) ? $backup['app_name'] : "";
                $vmWareTemplate = isset($backup['vmware_template']) ? $backup['vmware_template'] : "n/a";
                $startDate = isset($backup['start_time']) ? $this->functions->formatDateTime($backup['start_time']) : null;
                $replicated = isset($backup['replicated']) ? $backup['replicated'] : "";
                $dbName = isset($backup['database_name']) ? $backup['database_name'] : "";
                $bid = isset($backup['id']) ? $backup['id'] : null;
                $clientID = isset($backup['client_id']) ? $backup['client_id'] : null;
                $clientName = $this->getClientName($clientID, $sid);
                $disks = $this->getBackupDeviceInfo($bid, $sid);
                $storage = $this->getStorageType($bid, $sid);
                $instanceID = isset($backup['instance_id']) ? $backup['instance_id'] : null;
                $instanceName = isset($backup['instance_id']) ? $this->BP->get_appinst_name($backup['instance_id']) : "";
                $legalHold = ($bid != null) ? $this->getLegalHoldBackup($bid, $sid) : "n/a";
                $importedFromArchive = isset($backup['imported_from_archive']) ? $backup['imported_from_archive'] : "";
                $complete = $backup['complete'];
                if ($complete === true) {
                    $backup = array(
                        'id' => $bid,
                        'type' => $type,
                        'start_date' => $startDate,
                        'disks' => $disks,
                        'legal_hold' => $legalHold,
                        'replicated' => $replicated,
                        'vmware_template' => $vmWareTemplate,
                        'imported_from_archive' => $importedFromArchive,
                        'storage' => $storage
                    );
                    $index = $this->encode_index($appName, $clientID, $clientName, $dbName, $instanceID, $instanceName, $sid);
                    $items[$systemName][$index][] = $backup;
                }
            }

            foreach ($items as $systemName => $indices) {
                $instances = array();
                foreach ($indices as $index => $backups) {
                    $instance = $this->create_instance($index);
                    //sort backups with the most recent first
                    $backups = $this->sortBackups($backups);
                    $instance['backups'] = $backups;
                    $instances[] = $instance;
                }
                $data[] = array('System' => $systemName, 'instances' => $instances);
            }
        } else {
            global $Log;
            $Log->writeError($this->BP->getError(), true);
        }
        return $data;
    }
    function encode_index($appName, $clientID, $clientName, $dbName, $instanceID, $instanceName, $sid) {
        return $appName . '^' . $clientID . '^' . $clientName . '^' . $dbName . '^' . $instanceID . '^' . $instanceName . '^' . $sid;
    }

    function create_instance($index) {
        $instance = array();
        $a = explode('^', $index);
        $instance = array(
            'app_name' => $a[0],
            'client_id' => $a[1],
            'client_name' => $a[2],
            'database_name' => $a[3],
            'instance_id' => $a[4],
            'instance_name' => $a[5],
            'system_id' => $a[6],
            'system_name' => $this->getSystemName($a[6])
        );
        return $instance;
    }

    // Sorts the backups in descending order of the 'start_date'
    function sortBackups($backupArr) {
        $backups = $backupArr;
        $orderByStartDate = array();
        foreach ($backups as $key => $row) {
            $orderByStartDate[$key] = strtotime($row['start_date']);
        }
        array_multisort($orderByStartDate, SORT_DESC, $backups);
        return $backups;
    }

    function getLegalHold($iid, $sid){
        $input = array('instance_id'=>$iid);
        $retentionSettings = $this->BP->get_retention_settings($input, $sid);
        $hold = isset($retentionSettings['legal_hold']) ? $retentionSettings['legal_hold']: null;

        $data = $hold == 0 ? false : true;

        return $data;
    }

    function getLegalHoldBackup($bid, $sid){
        $data = false;
        $bids = (string)$bid;
        $result = $this->BP->get_legalhold_backup_info($bids, $sid);
        if ($result !== false) {
            foreach ($result as $backup) {
                if ($backup['backup_no'] == $bid) {
                    $data = $backup['is_on_hold'];
                    break;
                }
            }
        }
        return $data;
    }


    function getStorageType($bid, $sid){
        $data = array();
        $disks = $this->getBackupDeviceInfo($bid, $sid);
        $storageID = (int)$disks['storage_id'];
        $storageInfo = $this->BP->get_storage_info($storageID, $sid);
        if ($storageInfo !== false) {
            $data = isset($storageInfo['name']) ? $storageInfo['name'] : null;
        }

        return $data;
    }

    function merge_view($a1, $a2, $view){
        $result = array();
        if (is_array($a1) && count($a1) > 0 && is_array($a2) && count($a2) > 0) {
            if ($view != 'day') {
                $result = array_merge($a1, $a2);
            } else {
                // merge days that overlap, and add others that do not.
                $len1 = count($a1);
                for ($i = 0; $i < $len1; $i++) {
                    $day1 = $a1[$i]['day'];
                    $len2 = count($a2);
                    for ($j = 0; $j < $len2; $j++) {
                        $day2 = $a2[$j]['day'];
                        if (strcmp($day1, $day2) == 0) {
                        // If a match, remove each day from the original arrays.
                        $merged = array_merge($a1[$i]['instances'], $a2[$j]['instances']);
                            $result[] = array('day' => $day2, 'instances' => $merged);
                            unset($a1[$i]);
                            unset($a2[$j]);
                        }
                    }
                }
                // the leftovers do not have day matches.
                $result = array_merge($result, $a1);
                $result = array_merge($result, $a2);
            }
        } elseif (is_array($a1) && count($a1) > 0) {
            $result = $a1;
        } elseif (is_array($a2) && count($a2) > 0) {
            $result = $a2;
        }
        return ($result);
    }

}   //end backups class

?>
