<?php
/**
 * Created by PhpStorm.
 * User: Sonja12
 * Date: 4/10/2015
 * Time: 8:30 PM
 */

class Catalogs
{
    private $BP;

    public function __construct($BP = NULL)
    {
        $this->BP = $BP;

    }


    public function get_catalog($type, $filter, $sid, $systems)
    {
        $allCatalogs = array();

        switch ($type[0]) {
            case 'backups':
                $allCatalogs = $this->getBackupCatalog($filter, $sid, $systems);
                break;
            case 'archives':
                $allCatalogs = $this->getArchiveCatalog($filter, $sid, $systems);
                break;
            default:
                $backupCatalog = $this->getBackupCatalog($filter, $sid, $systems);
                $archiveCatalog = $this->getArchiveCatalog($filter, $sid, $systems);

                if (array_key_exists('catalog', $backupCatalog)) {
                    $a = $backupCatalog['catalog'];
                }

                if (array_key_exists('catalog', $archiveCatalog)) {
                    $b = $archiveCatalog['catalog'];
                }
                $view = isset($_GET['view']) ? $_GET['view'] : "system";

                $combined = array();
                if ($view == "day") {
                    foreach ($a as $backup){
                        $combined[] = $this->mergeDayView($backup, $b);
                    }
                }
                if ($view == "instance") {
                    foreach ($a as $backup){
                        $combined[] = $this->mergeInstanceView($backup, $b);

                    }
                }
                $allCatalogs['catalog'] = $combined;
                break;
        }
        return $allCatalogs;
    }

    function getBackupCatalog($filter, $sid, $systems)
    {
        require_once('backups.php');
        $backups = new Backups($this->BP, $sid);
        $backupCatalog = $backups->get("catalog", $filter, $sid, $systems);

        return $backupCatalog;
    }

    function getArchiveCatalog($filter, $sid, $systems)
    {
        $which = array();
        $which[] = "catalog";

        require_once('archive.php');
        $archive = new Archive($this->BP, $sid);
        $archiveCatalog = $archive->get($which, $filter, $sid, $systems);

        return $archiveCatalog;
    }

    function mergeDayView($backup, $archives){
         foreach($archives as $archive){
                if(array_key_exists("day", $archive)){
                    $archiveDay = $archive['day'];
                }
                if($archiveDay == $backup['day']){
                    $backupInstances = $backup['instances'];
                    $archiveInstances = $archive['instances'];
                    //TODO:  check for instances with archives, but no backups

                    for ($i=0; $i < count($backupInstances); $i++){
                        for ($j=0; $j < count($archiveInstances); $j++){
                            if($backupInstances[$i]['instance_name'] == $archiveInstances[$j]['instance_name']){
                                $archives = $archiveInstances[$j]['archives'];
                                $backupsArray = array_merge($backup['instances'][$i]['backups'], $archives);
                                $backups = $this->sortBackups($backupsArray);
                                $backup['instances'][$i]['backups'] = $backups;
                            }
                        }
                    }
                }
            }

        return $backup;
    }

    function mergeInstanceView($backup, $archives)
    {
        foreach ($archives as $archive) {
            //TODO:  check for instances with archives, but no backups
            if ($backup['instance_name'] == $archive['instance_name']) {
                $archives = $archive['archives'];
                $backupsArray = array_merge($backup['backups'], $archives);
                $backups = $this->sortBackups($backupsArray);
                $backup['backups'] = $backups;
            }
        }
        return $backup;
    }
    function sortBackups($backupArr) {
        $backups = $backupArr;
        $orderByStartDate = array();
        foreach ($backups as $key => $row) {
            $orderByStartDate[$key] = strtotime($row['start_date']);
        }
        array_multisort($orderByStartDate, SORT_DESC, $backups);

        return $backups;
    }
}
