<?php
/**
 * Created by PhpStorm.
 * User: Sonja12
 * Date: 1/16/2015
 * Time: 6:47 PM
 */

class JobsFunctions {
    private $BP;

    public function __construct($BP = NULL){
        $this->BP = $BP;

        $rootdir = $_SERVER['DOCUMENT_ROOT'] . "/api/";
        $include_dir = $rootdir . "includes/";

        require_once( $include_dir . 'function.lib.php');
        $this->functions = new Functions($this->BP);
    }



    public function buildCSVExport($allJobs)
    {
        if ($allJobs != null) {
            require_once('./includes/csv.php');
            $CSV = new CSV();
            $allJobs = $allJobs['data'];
            $header = $allJobs[0];
            $csv = $CSV->toCSV($header, $allJobs);
            $allJobs['data'] = $csv;
            $allJobs['csv'] = true;
            return $allJobs;
        }
    }

    // convert detailed type name to "backup", "restore", "archive".
    public function getJobType($type)
    {
        $userType = "backup";
        if (strstr($type, 'restore') != false) {
            $userType = "restore";
        }
        if (strstr($type, 'archive') != false) {
            $userType = "archive";
        }
        return $userType;
    }

    public function getStartDateFromBackup($backups, $originalDate){
        $startDate = $originalDate;
        foreach($backups as $backup){
            if (isset($backup['start_time'])) {
                $startDate = $backup['start_time'];
                break;
            }
        }
        return $startDate;
    }

    public function getClientNameFromBackup($backups){
        $clientName = "";
        foreach($backups as $backup){
             if(isset($backup['primary_name'])){
                 $clientName = $backup['primary_name'];
                 break;
             }
        }
        return $clientName;
    }


    public function buildBackupsOutput($backups, $failed){
        $data = array();
        foreach ($backups as $runStart => $backupArray) {
            $runStart = strftime('%m/%d/%Y %r', $runStart);
            $backupsForSchedule = array();

            foreach ($backupArray as $backup) {

                $backupsForSchedule['message'] = isset($backup['description']) ? $backup['description'] : "";
                $backupsForSchedule['primary_name'] = isset($backup['primary_name']) ? $backup['primary_name'] : "";
                $backupsForSchedule['secondary_name'] = isset($backup['secondary_name']) ? $backup['secondary_name'] : "";
                $backupsForSchedule['start_time'] = $runStart;
                $backupsForSchedule['failed'] = isset($backup['failed']) ? $backup['failed'] : "";
                $backupsForSchedule['type'] = isset($backup['type']) ? $this->functions->getBackupTypeString($backup['type']) : "";
                $backupsForSchedule['files'] = isset($backup['files']) ? $backup['files'] : "";
                $backupsForSchedule['size'] = isset($backup['size']) ? $backup['size'] : "";
                $backupsForSchedule['backup_id'] = isset($backup['backup_id']) ? $backup['backup_id'] : "N/A";

                if($failed !== null and $backupsForSchedule['failed'] !== true){
                    continue;
                }
                $data[] = $backupsForSchedule;
            }

        }
        return $data;
    }

    public function calcEndDate($endDateString){
        $endDate = $endDateString;
        $pieces = explode("/", $endDateString);
        if (count($pieces) > 3){
            //user specified h:m:s
            $endDate = strtotime($endDate);
        } else {
            $endDate = $this->functions->formatEndDate($_GET['end_date']);
        }
        return $endDate;
    }
}