<?php

class Replication{

    private $BP;

    public function __construct($BP)
    {
        require_once('function.lib.php');
        $this->functions = new Functions($this->BP);
        $this->BP = $BP;
    }

    public function get($which, $filter, $sid) {

        if($sid === false) {
            $systemID = $this->BP->get_local_system_id();
        } else {
            $systemID = (int)$sid;
        }

        switch($which){

            case "config":
                $maxConcurrent=$this->BP->get_ini_value("Replication","MaxConcurrent",$systemID);
                $reportMailto=$this->BP->get_ini_value("Replication","ReportMailTo",$systemID);
                $reportTime=$this->BP->get_ini_value("Replication","ReportTime",$systemID);
                $configData=array(
                                  'max_concurrent'=>$maxConcurrent,
                                  'report_mail_to'=>$reportMailto,
                                  'report_time'=>$reportTime
                                 );
                $data=array('config'=>$configData);
                break;

            case "throttle":
                $throttle=$this->BP->get_ini_value("Replication","BlockOutPeriods",$systemID);
                $throttledata= explode(",",$throttle);
                $max=0;$min=999;
                foreach($throttledata as $key=>$val){
                    $data2[]=explode(":",$val);
                    $data3[]=explode("=",$data2[$key][1]);
                    $data4[]=(int)$data3[$key][1];
                    if($data4[$key]>=$max){
                        $max=$data4[$key];
                    }
                    if($data4[$key]<=$min){
                        $min=$data4[$key];
                    }
                }
                foreach($throttledata as $key=>$val){
                    $percent[$key]=intval(($data4[$key]*100)/$max);
                }
                asort($percent);
                //$data=$percent;
                //var_dump($percent);
                $current=$min;
                $days=array();
                foreach($percent as $key=> $val){
                    if($current==$val){
                        $data1['percentage']=$current;
                        //var_dump($data2[$key][0]);
                        //var_dump($data3[$key][0]);
                        $days[]=(int)$data2[$key][0];
                        $time=explode("-",$data3[$key][0]);
                        $starttime=(int)$time[0];
                        $currentstarttime=$starttime;
                        if(isset($time[1])){
                            $endtime=(int)$time[1];
                        }
                        else{
                            $endtime=(int)$time[0]+1;
                        }
                        $data1['starttime']=$starttime;
                        $data1['endtime']=$endtime;

                    }
                    else{
                        //var_dump($days);
                        $current=$val;
                        //asort($days);
                        if($days!=null){
                            $data1['days']=$days;
                            $data['throttle'][]=$data1;
                        }

                        //$data1['percentage'][]=null;
                        //var_dump($data2[$key][0]);

                        $data1=array();
                        $days=array();
                    }

                }
                $data1['days']=$days;
                $data['throttle'][]=$data1;
                $data['Blockout Period']=$throttle;
               // var_dump($day);

                break;

            case "queue":
                $data = $this->get_replication_queue($filter, $sid);
                break;

            case "strategy":
                $queueScheme=$this->BP->get_ini_value("Replication","QueueScheme",$systemID);
                if($queueScheme==="0"){
                    $data['strategy'] = "Manual";
                }
                elseif($queueScheme==="1"){
                    $data['strategy'] = "Maximum Retention";
                }
                else $data['strategy'] = "Recency";
                break;
        }
    return $data;

    }

    private function get_replication_queue($filter, $systemID)
    {
        require_once('function.lib.php');
        $functions = new Functions($this->BP);

        $replicationQueue = array();
        $activeEntries = array();
        $inactiveEntries = array();
        $filterArray = array('start_position' => -1,
            'max_items' => 50,
            'include_failed' => false,
            'include_active' => true
        );
        $queue = $this->BP->get_replication_queue($filterArray, $systemID);

        if ($queue !== false) {
            $tempQueue = array();
            $tempQueue['start_position'] = 1;
            $tempQueue['total_inactive'] = $queue['total_count'];

            $backup_status_result_format = array();
            $backup_status_result_format['system_id'] = $systemID;

            $activeData = $queue['active_entries'];
            foreach ($activeData as $active) {
                $id = 0;
                $finalSize = 0;
                $dataWritten = 0;
                $name = "";
                $phaseStartDate = "";
                $phaseElapsedTime = "";
                $elapsedTime = 0;
                $operations = $this->BP->get_operation_list("", $systemID);
                $operationsList = $this->getFilteredOperation($operations, $active['backup_no']);
                if ($operationsList !== false) {
                    $id = $operationsList['id'];
                    $name = $this->getFormattedName($operationsList['name']);
                    $finalSize = $operationsList['final_size'];
                    $dataWritten = $operationsList['current_size'];
                    $phaseStartDate = date($functions::DATE_TIME_FORMAT_US, $operationsList['start_time']);

                    $elapsedTime = time() - $operationsList['start_time'];
                    $phaseElapsedTime = $this->getFormattedTime($elapsedTime, false);
                }

                $tempActive = array();
                $tempActive['id'] = $id;   //Operation's ID
                $tempActive['client_name'] = $active['client_name'];
                $tempActive['instance_name'] = $active['instance_name'];
                $tempActive['system_name'] = $functions->getSystemNameFromID($systemID);
                $tempActive['type'] = 'replication';
                //Needs to be defined
                $tempActive['schedule_name'] = 'Unknown';
                $tempActive['mode'] = $functions->getBackupTypeDisplayName($active['type']);
                $tempActive['sid'] = $systemID;
                $tempActive['name'] = $name;   //Operation's Name

                $tempActive['target'] = $active['target_name'];
                $tempActive['backup_id'] = $active['backup_no'];
                $tempActive['size'] = $finalSize;
                $tempActive['data_written'] = $dataWritten;
                $tempActive['start_date'] = date($functions::DATE_TIME_FORMAT_US, $active['rep_start']);

                $duration = time() - $active['rep_start'];
                // time since replication started
                $tempActive['duration'] = $this->getFormattedTime($duration, false);

                if ($dataWritten == 0 && $duration > 0) {
                    $tempActive['percent_complete'] = 'In Progress';
                } else {
                    $percentComplete = ($dataWritten / $finalSize) * 100;
                    $percentComplete = round($percentComplete, 2);
                    $tempActive['percent_complete'] = $percentComplete . '%';
                }
                //time since phase started
                $tempActive['phase_start_date'] = $phaseStartDate;

                //data written is 0, phase_completion is returned as 'Calculating...' or 'In Progress'
                if($dataWritten == 0) {
                    if ($duration > 0) {
                        $tempActive['phase_completion'] = 'In Progress';
                    } else {
                        $tempActive['phase_completion'] = 'Calculating...';
                    }
                } else {
                    $totalTime = (intval(($finalSize / $dataWritten) * $elapsedTime));
                    $phaseCompletion = $totalTime - $elapsedTime;
                    $tempActive['phase_completion'] = $this->getFormattedTime($phaseCompletion, true);
                }

                $tempActive['phase_elapsed_time'] = $phaseElapsedTime;
                $tempActive['status'] = 'running';
                $tempActive['suspendable'] = false;
                $tempActive['cancellable'] = true;

                $tempQueue['active'][] = $tempActive;
            }

            $inactiveData = $queue['queued_entries'];
            foreach ($inactiveData as $inactive) {
                $tempInactive = array();
                $tempInactive['queue_position'] = $inactive['queue_position'];
                $tempInactive['target'] = $inactive['target_name'];
                $tempInactive['backup_id'] = $inactive['backup_no'];
                $tempInactive['type'] = $functions->getBackupTypeDisplayName($inactive['type']);
                $tempInactive['name'] = $inactive['client_name'];
                $tempInactive['instance_name'] = $inactive['instance_name'];

                $backup_status_result_format['backup_ids'] = $inactive['backup_no'];
                $backupStatus = $this->BP->get_backup_status($backup_status_result_format);
                if ($backupStatus !== false) {
                    $tempInactive['size'] = $backupStatus[0]['size'];
                    $tempInactive['start_date'] = date($functions::DATE_TIME_FORMAT_US, $backupStatus[0]['start_time']);
                }
                $tempInactive['status'] = $this->getStatusString($inactive['status']);
                $tempQueue['inactive'][] = $tempInactive;
            }

            if ($tempQueue['active'] !== null) {
                $activeEntries = $tempQueue['active'];
            }
            if ($tempQueue['inactive'] !== null) {
                $inactiveEntries = $tempQueue['inactive'];
            }

            switch($filter) {
                case 'active':
                    $replicationQueue['active'][] = $activeEntries;
                    break;
                case 'inactive':
                    $replicationQueue['inactive'][] = $inactiveEntries;
                    break;
                default:
                    $replicationQueue['data'][] = $tempQueue;
                    break;
            }
        }

        return $replicationQueue;
    }

    private function getFilteredOperation($operations, $backupID)
    {
        $newOperations = array();
        foreach ($operations as $operation) {
            if ($operation['backup_id'] === $backupID) {
                $newOperations = $operation;
            }
        }
        return $newOperations;
    }

    private function getFormattedName($field)
    {
        $name = "";
        switch ($field) {
            case "prepare":
                // on source side
                $name = "Prepare (1/4)";
                break;
            case "replicate":
                // on source side
                $name = "Replicate (2/4)";
                break;
            case "wait":
                // on source side
                $name = "Target Processing (4/4)";
                break;
            case "rebuild":
                // on target side
                $name = "Rebuild (4/4)";
                break;
            case "no_activity":
                $name = "No Activity";
                break;
            case "processing":
                // on source side, after the replicate state but before the wait state
                $name = "Processing (3/4)";
                break;
        }

        return $name;
    }

    private function getStatusString($stat)
    {
        switch ($stat) {
            case 1:
                $status = "Needed";
                break;
            case 2:
                $status = "Done";
                break;
            case 4:
                $status = "Failed";
                break;
            case 8:
                $status = "Aborted";
                break;
            case 16:
                $status = "In Progress";
                break;
            case 32:
                $status = "Terminated";
                break;
            default:
                $status = "";
                break;
        }

        return $status;
    }

    /*
     * If 'inWords' is true, returns time in the format of "1d 2h 3m".
     * If false, returns time in the format of "00:00:00" (h:m:s).
     */
    private function getFormattedTime($time, $inWords)
    {
        $compTime = "";

        $days = intval(intval(($time) / (3600*24)));
        if($days > 0 && $inWords === true) {
            $compTime .= $days . 'd ';
        } elseif ($inWords === false) {
            $compTime = "";
        }
        // get the hours
        $hours = (intval(($time) / 3600)) % 24;
        if($hours > 0 && $inWords === true) {
            $compTime .= $hours . 'h ';
        } elseif ($inWords === false) {
            if($hours > 9) {
                $compTime .= $hours . ':';
            } elseif($hours < 10 && $hours > 0) {
                $compTime .= '0' . $hours . ':';
            } else {
                $compTime .= '00:';
            }
        }
        // get the minutes
        $minutes = (intval(($time) / 60)) % 60;
        if($minutes > 0 && $inWords === true) {
                $compTime .= $minutes . 'm';
        } elseif ($inWords === false) {
            if($minutes > 9) {
                $compTime .= $minutes . ':';
            } elseif($minutes < 10 && $minutes > 0) {
                $compTime .= '0' . $minutes . ':';
            } else {
                $compTime .= '00:';
            }
        }
        //less than a minute
        if($inWords && !($days > 0 || $hours > 0 || $minutes > 0)) {
            $compTime .= '<1min';
        } elseif ($inWords === false) {
            $seconds = (intval(($time) / 60));
            if($seconds > 9) {
                $compTime .= $seconds;
            } elseif($seconds < 10 && $seconds > 0) {
                $compTime .= '0' . $seconds;
            } else {
                $compTime .= '00';
            }
        }
        return $compTime;
    }

    public function put($which,$filter, $inputArray, $sid) {
        if($sid === false) {
            $systemID = $this->BP->get_local_system_id();
        } else {
            $systemID = (int)$sid;
        }
        switch($which){
            case "config":
                if(isset($inputArray['max_concurrent'])){
                    $maxConcurrent=$this->BP->set_ini_value("Replication","MaxConcurrent",$inputArray['max_concurrent'],$systemID);
                    $data["max_concurrent"]=$maxConcurrent;
                }
                if(isset($inputArray['report_mail_to'])){
                    $reportMailto=$this->BP->set_ini_value("Replication","ReportMailTo",$inputArray['report_mail_to'],$systemID);
                    $data["report_mail_to"]=$reportMailto;
                }
                if(isset($inputArray['report_time'])){
                    $reportTime=$this->BP->set_ini_value("Replication","ReportTime",$inputArray['report_time'],$systemID);
                    $data["report_time"]=$reportTime;
                }
                break;

            case "strategy":
                if(isset($inputArray['strategy'])){
                    if($inputArray['strategy']==="Manual"){
                        $queueScheme=$this->BP->set_ini_value("Replication","QueueScheme","0",$systemID);
                        $data=$queueScheme;
                    }
                    elseif($inputArray['strategy']==="Maximum Retention"){
                        $queueScheme=$this->BP->set_ini_value("Replication","QueueScheme","1",$systemID);
                        $data=$queueScheme;
                    }
                    else{
                        $queueScheme=$this->BP->set_ini_value("Replication","QueueScheme","2",$systemID);
                        $data=$queueScheme;
                    }
                }
                break;

            case "queue":
                $filter=array('start_position'=> -1,
                    'max_items'=> 1,
                    'include_active'=> 1,
                    'include_failed'=> 1
                );
                $queue=$this->BP->get_replication_queue($filter,$systemID);
                //var_dump($inputArray);
                if(isset($inputArray['backups']) and $inputArray['action']==="reset" and isset($queue['active_entries'])){
                    $backupTargets=$inputArray["backups"];
                    //var_dump($backupTargets);
                    foreach($queue['active_entries'] as $key=>$val){
                        $activeData=$queue['active_entries'];
                        $clientName[]=$activeData[$key]['client_name'];
                    }
                    $deleteFilter=array("backup_targets"=>$backupTargets,
                                        "clients"=>$clientName,
                                        "action"=>$inputArray['action']);

                    $update=$this->BP->delete_from_replication_queue($deleteFilter,$systemID);
                    $data=$update;
                }
                if(isset($inputArray['clients'])){

                }
                if(isset($inputArray['instances'])){

                }
                break;
        }
        return $data;
    }

    public function delete_replication($which,$filter, $inputArray, $sid) {

        if($sid === false) {
            $systemID = $this->BP->get_local_system_id();
        } else {
            $systemID = (int)$sid;
        }
        $filterReplication=array('start_position'=> -1,
            'max_items'=> 1,
            'include_active'=> 1,
            'include_failed'=> 1
        );
        $queue=$this->BP->get_replication_queue($filterReplication,$systemID);

        foreach($queue['active_entries'] as $key=>$val){
            $activeData=$queue['active_entries'];
            if(((int)$filter[2]===$activeData[$key]['backup_no']) and $_GET['target']===$activeData[$key]['target_name']){
                $backup['backup_no']=$activeData[$key]['backup_no'];
                $backup['target_name']=$activeData[$key]['target_name'];
            }
            $backupTargets[]=$backup;
        }
        $deleteFilter=array("backup_targets"=>$backupTargets,
                            "action"=>"terminate");
        $delete=$this->BP->delete_from_replication_queue($deleteFilter,$sid);
        return $deleteFilter;
    }

}

?>