<?php
//IN PROGRESS
class Schedule
{
    private $BP;
    private $FUNCTIONS;

    public function __construct($BP)
    {
        $this->BP = $BP;
        $this->FUNCTIONS = new Functions($BP);

    }

    public function get($which, $systems)
    {
        $allJoborders = array();

        foreach($systems as $sid => $sname) {
            if(is_numeric($which) and $which == -1) {
                //getting all
                $backup = $this->get_backup(-1, $sid, $sname);
                $archive = $this->get_archive(-1, $sid, $sname);
                $replication = $this->get_replication($sid, $sname);
                $jobOrders = array_merge($backup, $archive, $replication);
            } else {
                //specific type or id entered
                $withInfo = false;
                if(is_numeric($which) and $which == 0) {
                    $type = 'replication';
                    $withInfo = true;
                } elseif(is_numeric(substr($which, 0, -1))) {
                    $id = substr($which, 0, -1);
                    switch(substr($which, -1)) {
                        case 'b':
                            $type = 'backup';
                            break;
                        case 'a':
                            $type = 'archive';
                            break;
                        case 'r':
                            $type = 'restore';
                            break;
                        case 'i':
                            $type = 'ir';
                            break;
                        case 'f':
                            $type = 'flr';
                            break;
                    }
                    $withInfo = true;
                } else {
                    $id = -1;
                    $type = $which;
                }
                switch($type) {
                    case 'backup':
                        $jobOrders = $this->get_backup($id, $sid, $sname, $withInfo);
                        break;
                    case 'archive':
                        $jobOrders = $this->get_archive($id, $sid, $sname, $withInfo);
                        break;
                    case 'replication':
                        $jobOrders = $this->get_replication($sid, $sname, $withInfo);
                        break;
                    default:
                        $jobOrders = false;
                        break;
                }
            }
            $allJoborders = array_merge($allJoborders, $jobOrders);
        }

        $allJoborders = array('data' => $allJoborders);
        return $allJoborders;
    }

    //
    //creates the list of backup joborders
    //if there are no backup joborders, an empty list is returned
    //
    private function get_backup($id, $sid, $sname, $withInfo = false) {
        $joborders = array();

        $appSchedules = $this->BP->get_app_schedule_list(-1, -1, $sid);

        foreach ($appSchedules as $appSchedule) {
            $joborder = array();
            if($id != -1 and $appSchedule['id'] != $id) {
                continue;
            } else {
                if(isset($appSchedule['id'])) {
                    $joborder['id'] = $appSchedule['id'] . "b";
                }
                if(isset($appSchedule['name'])) {
                    $joborder['name'] = $appSchedule['name'];
                }
                $joborder['type'] = 'backup';
                $joborder['app_id'] = isset($appSchedule['app_id']) ? $appSchedule['app_id'] : 1;

                if(!$withInfo) {
                    $joborder['sid'] = $sid;
                    $joborder['system_name'] = $sname;
                    if(isset($appSchedule['description'])) {
                        $joborder['description'] = $appSchedule['description'];
                    }
                    //TODO: get date created
//                    $joborder['date_created'] = "Waiting on core";
                    if(isset($appSchedule['enabled'])) {
                        $joborder['enabled'] = $appSchedule['enabled'];
                    }
                    if(isset($appSchedule['last_time'])) {
                        $lastTime = $appSchedule['last_time'];
                        if ($lastTime == 0) {
                            $dateTime = "Never";
                            $joborder['last_status'] = 'None';
                        } else if ($lastTime == 77) {
                            $dateTime = "Has Been Reset";
                        } else {
//                            $date = date('m/d/Y', $lastTime);
//                            $time = date('H:i:s a', $lastTime);
//                            $dateTime = $date . ' ' . $time;
                            $dateTime = $this->FUNCTIONS->formatDateTime($lastTime);
                        }
                        $joborder['last_time'] = $dateTime;
                    }
                    if(isset($appSchedule['next_time'])) {
                        $nextTime = $appSchedule['next_time'];
                        if ($nextTime == 0) {
                            $dateTime = "Never";
                        } else if ($nextTime == 77) {
                            $dateTime = "Has Been Reset";
                        } else {
//                            $date = date('m/d/Y', $nextTime);
//                            $time = date('H:i:s', $nextTime);
//                            $dateTime = $date . ' ' . $time;
                            $dateTime = $this->FUNCTIONS->formatDateTime($nextTime);
                        }
                        $joborder['next_time'] = $dateTime;
                    }
                    if(!isset($joborder['last_status'])) {
                        $resultFormat = array();
                        $resultFormat['schedule_id'] = $appSchedule['id'];
                        $scheduleHistory = $this->BP->get_schedule_history($resultFormat, $sid);
                        if(count($scheduleHistory) > 0) {
                            $backup = end($scheduleHistory[0]['backups']);
                            switch($backup[0]['description']) {
                                case 'Successful':
                                    $joborder['last_status'] = 'Success';
                                    break;
                                case 'Warnings':
                                    $joborder['last_status'] = 'Warnings';
                                    break;
                                case 'Failed':
                                    $joborder['last_status'] = 'Failure';
                                    break;
                            }
                        }
                        if(!isset($joborder['last_status'])) {
                            $joborder['last_status'] = "Never";
                        }
                    }
                    //get current status of schedule 'Idle' or 'Running'
                    $joborder['status'] = $this->getStatus($appSchedule['name'], $sid);
                }


                $appScheduleInfo = $this->BP->get_app_schedule_info($appSchedule['id'], $sid);
                if ($appScheduleInfo === false) {
                    $appScheduleInfo = $this->BP->get_rae_app_schedule_info($appSchedule['id'], $sid);
                }

                if($appScheduleInfo !== false) {
                    if(isset($appScheduleInfo['calendar'])) {
                        $calendar = $appScheduleInfo['calendar'];
                        $convertedCal = $this->iCalToSchedule($calendar);
                        if(!$withInfo) {
                            $joborder['calendar_str'] = $this->getShortCalendarArr($convertedCal);
                        }
                    }

                    if(!$withInfo) {
                        if(isset($appScheduleInfo['backup_options']['appinst_ids'])) {
                            $instanceID = $appScheduleInfo['backup_options']['appinst_ids'][0];
                            $instanceInfo = $this->BP->get_appinst_info($instanceID, $sid);
                            if($instanceInfo != false) {
                                $joborder['application_name'] = $instanceInfo[$instanceID]['app_type'];
                            }
                        } else {
                            $joborder['application_name'] = "file-level";
                        }
                    }

                    if($withInfo) {
                        if(isset($convertedCal)) {
                            $joborder['calendar'] = $convertedCal;
                        }
                        $joborder['email_report'] = $appScheduleInfo['schedule_options']['email_report'];
                        $joborder['failure_report'] = $appScheduleInfo['schedule_options']['failure_report'];
                        if(isset($appScheduleInfo['backup_options']['dev_name'])) {
                            if(substr($appScheduleInfo['backup_options']['dev_name'], 0, 2) === "_d") {
                                $joborder['storage'] = substr($appScheduleInfo['backup_options']['dev_name'], 2);
                            } else {
                                $joborder['storage'] = $appScheduleInfo['backup_options']['dev_name'];
                            }
                        } else {
                            $joborder['storage'] = "";
                        }

                        switch($appScheduleInfo['backup_options']['verify_level']) {
                            case 0:
                                $joborder['verify'] = "none";
                                break;
                            case 3:
                                $joborder['verify'] = "inline";
                                break;
                        }
                        if(isset($appScheduleInfo['backup_options']['appinst_ids'])) {
                            $instances = array();
                            foreach($appScheduleInfo['backup_options']['appinst_ids'] as $instanceID) {
                                $instanceInfo = $this->BP->get_appinst_info($instanceID, $sid);
                                if($instanceInfo != false) {
                                    $instance = array();
                                    $instance['id'] = $instanceID;
                                    $instance['primary_name'] = $instanceInfo[$instanceID]['primary_name'];
                                    if(isset($instanceInfo[$instanceID]['secondary_name'])) {
                                        $instance['secondary_name'] = $instanceInfo[$instanceID]['secondary_name'];
                                    }
                                    if($instanceInfo[$instanceID]['app_type'] == "Hyper-V") {
                                        $clientInfo = $this->BP->get_client_info($appSchedule['client_id'], $sid);
                                        $instance['client_name'] = $clientInfo['name'];
                                    }
                                    $instances[] = $instance;
                                }
                            }
                            if($instanceInfo[$instanceID]['app_type'] != "Hyper-V") {
                                $joborder['client_name'] = "";
                            }
                            $joborder['instances'] = $instances;
                        } else {
                            $clientInfo = $this->BP->get_client_info($appSchedule['client_id'], $sid);
                            $joborder['client_name'] = $clientInfo['name'];
                            $joborder['client_id'] = $clientInfo['id'];
                            $joborder['instances'] = array();
                        }
                    }
                }
                $joborders[] = $joborder;
            }
        }
        return $joborders;
    }

    //
    //creates the list of archive joborders
    //if there are no archive joborders, an empty list is returned
    //
    private function get_archive($id, $sid, $sname, $withInfo = false) {
        $joborders = array();

        $archiveSchedules = $this->BP->get_archive_schedule_list($sid);


        foreach ($archiveSchedules as $archiveSchedule) {
            //TODO: last_status

            $joborder = array();
            if($id != -1 and $archiveSchedule['id'] != $id) {
                continue;
            } else {
                $joborder['id'] = $archiveSchedule['id'] . "a";
                $joborder['name'] = $archiveSchedule['name'];
                $joborder['type'] = "archive";
                if(!$withInfo) {
                    $joborder['application_name'] = "";
                    $joborder['description'] = $archiveSchedule['description'];
                    $joborder['sid'] = $sid;
                    $joborder['system_name'] = $sname;
                    $joborder['enabled'] = $archiveSchedule['enabled'];
                    //TODO: get date created
//                    $joborder['date_created'] = "Waiting on core";

                    if(isset($archiveSchedule['last_time'])) {
                        $lastTime = $archiveSchedule['last_time'];
                        if ($lastTime == 0) {
                            $dateTime = "Never";
                            $joborder['last_status'] = 'None';
                        } else if ($lastTime == 77) {
                            $dateTime = "Has Been Reset";
                        } else {
                            $dateTime = $this->FUNCTIONS->formatDateTime($lastTime);
                        }
                        $joborder['last_time'] = $dateTime;
                    }
                    if(isset($archiveSchedule['next_time'])) {
                        $nextTime = $archiveSchedule['next_time'];
                        if ($nextTime == 0) {
                            $dateTime = "Never";
                        } else if ($nextTime == 77) {
                            $dateTime = "Has Been Reset";
                        } else {
                            $dateTime = $this->FUNCTIONS->formatDateTime($nextTime);
                        }
                        $joborder['next_time'] = $dateTime;
                    }

                    $joborder['status'] = $this->getStatus($archiveSchedule['name'], $sid);
                }

                $archiveScheduleInfo = $this->BP->get_archive_schedule_info($archiveSchedule['id'], $sid);
                if($archiveScheduleInfo !== false) {
                    if(isset($archiveScheduleInfo['calendar'])) {
                        $calendar = $archiveScheduleInfo['calendar'];
                        $convertedCal = $this->iCalToSchedule($calendar);
                        if(!$withInfo) {
                            $joborder['calendar_str'] = $this->getShortCalendarArr($convertedCal);
                        }
                    }
                    if($withInfo) {
                        if(isset($convertedCal)) {
                            $joborder['calendar'] = $convertedCal;
                        }
                        //get backup types that are being archived
                        $types = $archiveScheduleInfo['profile']['types'];
                        $formattedTypes = array();
                        foreach($types as $type) {
                            $returnType = $this->FUNCTIONS->getBackupTypeDisplayName($type);
                            if(!in_array($returnType, $formattedTypes)) {
                                $formattedTypes[] = $returnType;
                            }
                        }
                        $joborder['types'] = $formattedTypes;
                        $joborder['email_report'] = $archiveScheduleInfo['email_report'];
                        $time = time();
                        $range = $archiveScheduleInfo['profile']['range_size'];
                        if($range == 0) {
                            $joborder['range_size'] = 0;
                        } else {
                            $joborder['range_size'] = (int)(($time - $range) / 86400);
                        }
                        if($archiveScheduleInfo['profile']['range_end'] == 0) {
                            $joborder['range_end'] = 0;
                        }
                        $joborder['storage'] = $archiveScheduleInfo['profile']['target'];
                        if(count($archiveScheduleInfo['profile']['instances']) > 0) {
                            $instances = array();
                            foreach($archiveScheduleInfo['profile']['instances'] as $instanceID) {
                                $instanceInfo = $this->BP->get_appinst_info($instanceID, $sid);
                                if($instanceInfo != false) {
                                    $instance = array();
                                    $instance['id'] = $instanceID;
                                    $instance['primary_name'] = $instanceInfo[$instanceID]['primary_name'];
                                    if(isset($instanceInfo[$instanceID]['secondary_name'])) {
                                        $instance['secondary_name'] = $instanceInfo[$instanceID]['secondary_name'];
                                    }
                                    $instances[] = $instance;
                                }
                            }
                            $joborder['client_name'] = "";
                            $joborder['instances'] = $instances;
                        } else {
                            $clientInfo = $this->BP->get_client_info($archiveScheduleInfo['profile']['clients'][0], $sid);
                            $joborder['client_name'] = $clientInfo['name'];
                            $joborder['client_id'] = $clientInfo['id'];
                        }
                        $joborder['options'] = $archiveScheduleInfo['profile']['options'];
                    }
                }
            }
            $joborders[] = $joborder;
        }

        return $joborders;
    }

    //
    //gets the replication joborder
    //if replication is not configured, an empty array is returned.
    //
    private function get_replication($sid, $sname, $withInfo = false) {
        $joborder = array();

        //check if replication is configured
        $status = $this->BP->is_replication_configured($sid);
        if($status == -1 or $status == false) {
            $status = ($sid === $this->BP->get_local_system_id()) ? $this->BP->local_system_is_replicating() : false;
        }
        if($status != false and $status != -1) {
            //replication is configured
            $joborder['id'] = 0;
            $joborder['name'] = "Replication Job";
            $joborder['type'] = "replication";
            if(!$withInfo) {
                $joborder['application_name'] = "";
                $joborder['sid'] = $sid;
                $joborder['system_name'] = $sname;
                $joborder['enabled'] = $this->BP->is_replication_enabled($sid);
                //TODO: get date created
//                $joborder['date_created'] = "Waiting on core";
            } else {
                $clientList = array();
                $clients = $this->BP->get_client_list($sid);
                foreach($clients as $id => $name) {


                    $clientInfo = $this->BP->get_client_info($id, $sid);
                    switch($clientInfo['os_type_id']) {
                        case 20:
                            if($clientInfo['name'] != "vCenter-RRC") {
                                break;
                            }
                        case 30:
                        case 31:
                        case 32:
                        case 35:
                        case 36:
                        case 37:
                        case 38:
                        case 39:
                        case 41:
                        case 42:
                            $singleClient = array();
                            $singleClient['client_id'] = $id;
                            $singleClient['client_name'] = $name;
                            $applications = array();
                            $clientApplications = $clientInfo['applications'];
                            foreach($clientApplications as $appID => $appInfo) {
                                $replicationInstances = array();
                                $appName = $appInfo['name'];
                                switch($appID) {
                                    case 1:
                                        //file level
                                        if($clientInfo['os_type_id'] != 20) {
                                            $replicationInstances[] = array('instance_name' => 'file_level', 'synchable' => $clientInfo['is_synchable']);
                                            $applications[$appName] = $replicationInstances;
                                        }
                                        break;
                                    case 40:
                                        //VMware
                                        foreach($appInfo['servers'] as $uuid => $serverName) {
                                            $vmInstances = $this->BP->get_vm_info($uuid, null, false, false, $sid);
                                            $replicationInstances[$serverName] = array();
                                            foreach($vmInstances as $vmInstance) {
                                                $replicationInstances[$serverName][] = array('instance_id' => $vmInstance['instance_id'], 'instance_name' => $vmInstance['name'], 'synchable' => $vmInstance['is_synchable']);
                                            }
                                        }
                                        $applications[$appName] = $replicationInstances;
                                        break;
                                    case 50:
                                    case 51:
                                        //Hyper-V
                                        $hypervInstances = $this->BP->get_hyperv_info($id, false, $sid);
                                        foreach($hypervInstances as $hypervInstance) {
                                            $replicationInstances[] = array('instance_id' => $hypervInstance['instance_id'], 'instance_name' => $hypervInstance['name'], 'synchable' => $hypervInstance['is_synchable']);
                                        }
                                        $applications[$appName] = $replicationInstances;
                                        break;
                                }
                            }
                            $singleClient['applications'] = $applications;
                            $clientList[] = $singleClient;
                            break;
                    }






                }
                $joborder['instances'] = $clientList;
            }
        }

        // Even though one item, wrap as array of arrays.
        return (count($joborder) > 0) ? array($joborder) : $joborder;
    }

    public function getStatus($scheduleName, $sid) {
        $jobs = $this->BP->get_job_list($sid);
        if($jobs != false) {
            foreach($jobs as $jobID => $jobName) {
                if(isset($joborder['status'])) {
                    break;
                } else {
                    $jobInfo = $this->BP->get_job_info($jobID, $sid);
                    if(isset($jobInfo['schedule_name']) and $jobInfo['schedule_name'] == $scheduleName) {
                        switch($jobInfo['status']) {
                            case '*ON HOLD*':
                            case 'QUEUED':
                            case 'CONNECTING':
                            case ' *ACTIVE*':
                            case 'ACTIVE':
                            case 'DB. UPDATING':
                                $status = 'Running';
                                break;
                        }
                    }
                }
            }
        }
        if(!isset($status)) {
            $status = 'Idle';
        }
        return $status;
    }

    public function delete($which, $sid) {
        $status = false;
        $type = "";
        $id = -1;
        if(is_numeric($which) and $which == 0) {
            $type = 'replication';
        } elseif(is_numeric(substr($which, 0, -1))) {
            $id = (int)substr($which, 0, -1);
            switch(substr($which, -1)) {
                case 'b':
                    $type = 'backup';
                    break;
                case 'a':
                    $type = 'archive';
                    break;
                case 'r':
                    $type = 'restore';
                    break;
                case 'i':
                    $type = 'ir';
                    break;
                case 'f':
                    $type = 'flr';
                    break;
            }
        }
        switch($type) {
            case 'backup':
                $status = $this->BP->delete_app_schedule($id, $sid);
                break;
            case 'archive':
                $status = $this->BP->delete_archive_schedule($id, $sid);
                break;
            case 'replication':
                $status['error'] = 403;
                $status['message'] = "Deletion of replication joborder is not allowed. Remove replication to remove joborder";
                break;
        }

        return $status;
    }

    public function save_schedule($which, $data, $sid) {
        //because we are creating a schedule, we have to have a system id or we use local
        $status = false;
        if(!$sid) {
            $sid = $this->BP->get_local_system_id();
        }
        $type = "";
        if(is_numeric(substr($which, 0, -1)) and $which != -1) {
            $id = (int)substr($which, 0, -1);
            switch(substr($which, -1)) {
                case 'b':
                    $type = 'backup';
                    break;
                case 'a':
                    $type = 'archive';
                    break;
                case 'r':
                    $type = 'restore';
                    break;
                case 'i':
                    $type = 'ir';
                    break;
                case 'f':
                    $type = 'flr';
                    break;
            }
            switch($type) {
                case 'backup':
                    $appSchedules = $this->BP->get_app_schedule_list(-1, -1, $sid);

                    foreach ($appSchedules as $appSchedule) {
                        if($appSchedule['id'] == $id) {
                            $scheduleInfo = $this->BP->get_app_schedule_info($id, $sid);
                            if($appSchedule['app_id'] == 1 and !isset($scheduleInfo['backup_options']['appinst_ids'])) {
                                //valid copy request
                                unset($appSchedule['last_time']);
                                unset($appSchedule['next_time']);
                                if(isset($appSchedule['esx_uuid'])) {
                                    unset($appSchedule['esx_uuid']);
                                }
                                if(isset($appSchedule['key'])) {
                                    unset($appSchedule['key']);
                                }
                                unset($appSchedule['id']);
                                $appSchedule['name'] = "Copy of " . $appSchedule['name'];
                                $inputParams = array_merge($appSchedule, $scheduleInfo);
                                //add reg expressions due to regex feature
                                $inputParams['regular_expressions'] = array();

                                $result = $this->BP->save_app_schedule_info($inputParams, $sid);
                                if($result !== false) {
                                    if(!is_numeric($result)) {
                                        if (is_array($result)) {
                                            $status = $this->gatherDetailedSaveInfo($result, $sid);
                                            $status = array('result' => $status);
                                        } else {
                                            $status = $result;
                                        }
                                    } else {
                                        $status = array();
                                        $status[]['id'] = $result . "b";
                                        $status = array('result' => $status);
                                    }
                                } else {
                                    $status = $result;
                                }
                            } else {
                                $status = array();
                                $status['error'] = 405;
                                $status['message'] = "Joborders can only be copied if they contain no instances.";
                            }
                            break;
                        }
                    }
                    if(!isset($status)) {
                        $status = array();
                        $status['error'] = 404;
                        $status['message'] = "Joborder with id " . $id . " not found.";
                    }
                    break;
                case 'archive':
                    $status = false;
                    $scheduleInfo = $this->BP->get_archive_schedule_info($id, $sid);
                    if($scheduleInfo != false) {
                        unset($scheduleInfo['id']);
                        $scheduleInfo['name'] = "Copy of " . $scheduleInfo['name'];
                        $result = $this->BP->save_archive_schedule_info($scheduleInfo, $sid);
                        if($result !== false) {
                            if(!is_numeric($result)) {
                                $status = $result;
                            } else {
                                $status = array();
                                $status[]['id'] = $result . "a";
                            }
                            $status = array('result' => $status);
                        } else {
                            $status = $result;
                        }
                    }
                    break;
            }
        } else {
            switch($data['type']) {
                case 'Backup':
                case 'backup':
                    //dealing with saving new schedule
                    $inputParams = array();
                    $backupOptions = array();
                    $scheduleOptions = array();
                    $inputParams['name'] = $data['name'];
                    if(isset($data['description'])) {
                        $inputParams['description'] = $data['description'];
                    } else {
                        $inputParams['description'] = $data['name'];
                    }
                    $inputParams['enabled'] = true;
                    if(isset($data['storage'])) {
                        if($data['storage'] == "" or strtolower($data['storage']) == "internal") {
                            $backupOptions['dev_name'] = "";
                        } else {
                            $backupOptions['dev_name'] = "_d" . $data['storage'];
                        }
                    }

                    if(isset($data['verify'])) {
                        switch($data['verify']) {
                            case 'none':
                                $backupOptions['verify_level'] = 0;
                                break;
                            case 'inline':
                                $backupOptions['verify_level'] = 3;
                                break;
                        }
                    } else {
                        $backupOptions['verify_level'] = 3;
                    }
                    $appType = "";
                    if(isset($data['client_id'])) {
                        $scheduleOptions['client_id'] = $data['client_id'];
                        $inputParams['app_id'] = 1;
                        $appType = "file-level";
                    } elseif (isset($data['instances'])) {
                        $instanceInfo = $this->BP->get_appinst_info($data['instances'][0], $sid);
                        $scheduleOptions['client_id'] = $instanceInfo[$data['instances'][0]]['client_id'];
                        $backupOptions['appinst_ids'] = $data['instances'];
                        $inputParams['app_id'] = $instanceInfo[$data['instances'][0]]['app_id'];
                        $appType = $instanceInfo[$data['instances'][0]]['app_type'];
                    }

                    // For CE, file-level backups are not allowed.
                    if ( $appType === "file-level" )
                    {
                        //Display error message telling the user that file-level backups are not allowed
                        $status = array();
                        $status['error'] = "500";
                        $status['message'] = "Unitrends Community Edition only supports virtual machine backups.  Backups of the virtual host are not currently supported. Please select at least one virtual machine to backup.";
                    }
                    else
                    {
                        if(isset($data['calendar'])) {
                            $inputParams['calendar'] = $this->scheduleToICal($data['calendar'], $appType);
                        }
                        $scheduleOptions['include_new'] = false;
                        $scheduleOptions['email_report'] = isset($data['email_report']) ? $data['email_report'] : false;
                        $scheduleOptions['failure_report'] = isset($data['failure_report']) ? $data['failure_report'] : false;

                        $inputParams['backup_options'] = $backupOptions;
                        $inputParams['schedule_options'] = $scheduleOptions;
                        //added regex parameter
                        $inputParams['regular_expressions'] = array();
                        $result = $this->BP->save_app_schedule_info($inputParams, $sid);
                        if($result !== false) {
                            if(!is_numeric($result)) {
                                $status = $this->gatherDetailedSaveInfo($result, $sid);
                            } else {
                                $status = array();
                                $status[]['id'] = $result . "b";
                            }
                            $status = array('result' => $status);
                        } else {
                            $status = $result;
                        }
                    }
                    break;
                case 'Archive':
                case 'archive':
                    $inputParams = array();

                    $inputParams['name'] = $data['name'];
                    $inputParams['description'] = $data['name'];

                    $inputParams['enabled'] = true;
                    $inputParams['email_report'] = isset($data['email_report']) ? $data['email_report'] : false;
                    $inputParams['failure_report'] = isset($data['failure_report']) ? $data['failure_report'] : false;
                    $appType = 'Archive';
                    $inputParams['calendar'] = $this->scheduleToICal($data['calendar'], $appType);

                    $inputParams['profile'] = array();
                    $inputParams['profile']['description'] = "";
//                    if(isset($data['storage'])) {
//                        if($data['storage'] == "" or strtolower($data['storage']) == "internal") {
//                            $inputParams['profile']['target'] = "";
//                        } else {
//                            $inputParams['profile']['target'] = "_d" . $data['storage'];
//                        }
//                   }
                    $inputParams['profile']['target'] = $data['storage'];
                    if(isset($data['client_id'])) {
                        $inputParams['profile']['clients'] = array();
                        $inputParams['profile']['clients'][] = $data['client_id'];
                        $appType = "file-level";
                        $types = array();
                        foreach($data['types'] as $type) {
                            $types[] = $this->FUNCTIONS->getBackupTypeCoreNameBackupNow($type, $appType);
                        }
                        $inputParams['profile']['types'] = $types;
                    } else {
                        $inputParams['profile']['instances'] = $data['instances'];
                        $appTypes = array();
                        $instances = implode(",", $data['instances']);
                        $instanceInfo = $this->BP->get_appinst_info($instances, $sid);
                        //get unique app types
                        foreach($instanceInfo as $info) {
                            $appType = $info['app_type'];
                            if(!in_array($appType, $appTypes)) {
                                $appTypes[] = $appType;
                            }
                        }
                        //get all backup types based on user-input types and unique app types
                        $types = array();
                        foreach($data['types'] as $type) {
                            foreach($appTypes as $appType) {
                                $types[] = $this->FUNCTIONS->getBackupTypeCoreNameBackupNow($type, $appType);
                            }
                        }
                        $inputParams['profile']['types'] = $types;
                    }

                    $inputParams['profile']['range_end'] = 0;
                    if(isset($data['range_size'])) {
                        if($data['range_size'] == 0) {
                            $inputParams['profile']['range_size'] = 0;
                        } else {
                            $inputParams['profile']['range_size'] = (time()) - (86400 * $data['range_size']);
                        }
                    } else {
                        $inputParams['profile']['range_size'] = 0;
                    }

                    $inputParams['profile']['options'] = array();
                    $inputParams['profile']['options']['append'] = isset($data['append']) ? $data['append'] : true;
                    $inputParams['profile']['options']['purge'] = isset($data['purge']) ? $data['purge'] : false;
                    $inputParams['profile']['options']['compress'] = false;
                    $inputParams['profile']['options']['encrypt'] = isset($data['encrypt']) ? $data['encrypt'] : false;
                    $inputParams['profile']['options']['deduplicate'] = false;
                    $inputParams['profile']['options']['email_report'] = $data['email_report'];
                    $inputParams['profile']['options']['retention_days'] = isset($data['retention_days']) ? $data['retention_days'] : 0;
                    $result = $this->BP->save_archive_schedule_info($inputParams, $sid);
                    if($result !== false) {
                        if(isset($result['id'])) {
                            $status = array();
                            $status[]['id'] = $result['id'] . "a";
                        } else {
                            $status = $result;
                        }
                        $status = array('result' => $status);
                    } else {
                        $status = $result;
                    }
                    break;
            }
        }
        return $status;
    }

    public function put($which, $data, $sid) {
        if(!$sid) {
            $sid = $this->BP->get_local_system_id();
        }
        $status = false;
        if(isset($which[1])) {
            //dealing with enable/disable or run
            $type = "";
            $id = -1;
            $ids = explode(',', $which[1]);
            foreach($ids as $tokID) {
                if(is_numeric($tokID) and $tokID == 0) {
                    $type = 'replication';
                } elseif(is_numeric(substr($tokID, 0, -1))) {
                    $id = (int)substr($tokID, 0, -1);
                    switch(substr($tokID, -1)) {
                        case 'b':
                            $type = 'backup';
                            break;
                        case 'a':
                            $type = 'archive';
                            break;
                        case 'r':
                            $type = 'restore';
                            break;
                        case 'i':
                            $type = 'ir';
                            break;
                        case 'f':
                            $type = 'flr';
                            break;
                    }
                }
                switch($which[0]) {
                    case 'enable':
                        switch($type) {
                            case 'backup':
                                $status = $this->BP->enable_app_schedule($id, $sid);
                                break;
                            case 'archive':
                                $status = $this->BP->enable_archive_schedule($id, $sid);
                                break;
                            case 'replication':
                                $status = $this->BP->enable_replication(true, $sid);
                                break;
                        }
                        break;
                    case 'disable':
                        switch($type) {
                            case 'backup':
                                $status = $this->BP->disable_app_schedule($id, $sid);
                                break;
                            case 'archive':
                                $status = $this->BP->disable_archive_schedule($id, $sid);
                                break;
                            case 'replication':
                                $status = $this->BP->enable_replication(false, $sid);
                                break;
                        }
                        break;
                    case 'run':
                        switch($type) {
                            case 'backup':
                                $status = $this->BP->schedule_now($id, $sid);
                                break;
                            case 'archive':
                                $status = $this->BP->schedule_now($id, $sid);
                                break;
                            case 'replication':
                                $status['error'] = 405;
                                $status['message'] = "Replication joborders are constantly running.";
                                break;
                        }
                        break;
                }
            }
        } else {
            //dealing with a modify
            if($which[0] == 0) {
                $inputParams = array();
                foreach($data['instances'] as $instance) {
                    $instanceInfo = array();
                    $instanceInfo['instance_id'] = $instance['instance_id'];
                    $instanceInfo['priority'] = 500;
                    $instanceInfo['is_synchable'] = $instance['synchable'];
                    $inputParams[] = $instanceInfo;
                }
                $status = $this->BP->save_app_vaulting_info($inputParams, $sid);
            } else {
                $type = "";
                if(is_numeric(substr($which[0], 0, -1)) and $which[0] != -1) {
                    $id = (int)substr($which[0], 0, -1);
                    switch(substr($which[0], -1)) {
                        case 'b':
                            $type = 'backup';
                            break;
                        case 'a':
                            $type = 'archive';
                            break;
                        case 'r':
                            $type = 'restore';
                            break;
                        case 'i':
                            $type = 'ir';
                            break;
                        case 'f':
                            $type = 'flr';
                            break;
                    }
                    switch($type) {
                        case 'backup':
                            $appSchedules = $this->BP->get_app_schedule_list(-1, -1, $sid);

                            foreach ($appSchedules as $appSchedule) {
                                if($appSchedule['id'] == $id) {
                                    $scheduleInfo = $this->BP->get_app_schedule_info($id, $sid);

                                    if(isset($data['name'])) {
                                        $appSchedule['name'] = $data['name'];
                                    }
                                    if($appSchedule['app_id'] == 1) {
                                        $appType = 'file-level';
                                    } else {
                                        $instanceInfo = $this->BP->get_appinst_info($scheduleInfo['backup_options']['appinst_ids'][0], $sid);
                                        $appType = $instanceInfo[$data['instances'][0]]['app_type'];
                                    }
                                    if(isset($data['instances'])) {
                                        $scheduleInfo['backup_options']['appinst_ids'] = $data['instances'];
                                        $instanceInfo = $this->BP->get_appinst_info($data['instances'][0], $sid);
                                        $scheduleInfo['schedule_options']['client_id'] = $instanceInfo[$data['instances'][0]]['client_id'];
                                        $appType = $instanceInfo[$data['instances'][0]]['app_type'];
                                    }
                                    if(isset($data['calendar'])) {

                                        $scheduleInfo['calendar'] = $this->scheduleToICal($data['calendar'], $appType);
                                    }
                                    if(isset($data['email_report'])) {
                                        $scheduleInfo['schedule_options']['email_report'] = $data['email_report'];
                                    }
                                    if(isset($data['failure_report'])) {
                                        $scheduleInfo['schedule_options']['failure_report'] = $data['failure_report'];
                                    }
                                    if(isset($data['storage'])) {
                                        if(strtolower($data['storage']) == "internal" or $data['storage'] == "") {
                                            $scheduleInfo['backup_options']['dev_name'] = "";
                                        } else {
                                            $scheduleInfo['backup_options']['dev_name'] = "_d" . $data['storage'];
                                        }
                                    }
                                    if(isset($data['verify'])) {
                                        switch($data['verify']) {
                                            case 'none':
                                                $scheduleInfo['backup_options']['verify_level'] = 0;
                                                break;
                                            case 'inline':
                                                $scheduleInfo['backup_options']['verify_level'] = 3;
                                                break;
                                        }
                                    }
                                    unset($appSchedule['client_id']);
                                    unset($appSchedule['last_time']);
                                    unset($appSchedule['next_time']);
                                    if(isset($appSchedule['esx_uuid'])) {
                                        unset($appSchedule['esx_uuid']);
                                    }
                                    if(isset($appSchedule['key'])) {
                                        unset($appSchedule['key']);
                                    }
                                    $inputParams = array_merge($appSchedule, $scheduleInfo);
                                    $result = $this->BP->save_app_schedule_info($inputParams, $sid);
                                    if($result !== false) {
                                        if(is_array($result)) {
                                            $status = $this->gatherDetailedSaveInfo($result, $sid);
                                            $status = array('result' => $status);
                                        } else {
                                            $status = $result;
                                        }
                                    } else {
                                        $status = $result;
                                    }
                                    break;
                                }
                            }
                            break;
                        case 'archive':
                            $inputParams = $this->BP->get_archive_schedule_info($id, $sid);
                            if(isset($data['name'])) {
                                $inputParams['name'] = $data['name'];
                            }
                            if(isset($data['instances'])) {
                                $inputParams['profile']['instances'] = $data['instances'];
                            }
                            if(isset($data['types'])) {
                                if(count($inputParams['clients']) > 0 and count($inputParams['instances']) == 0) {
                                    $appType = "file-level";
                                    $types = array();
                                    foreach($data['types'] as $type) {
                                        $types[] = $this->FUNCTIONS->getBackupTypeCoreNameBackupNow($type, $appType);
                                    }
                                    $inputParams['profile']['types'] = $types;
                                } else if (count($inputParams['instances']) > 0) {
                                    $appTypes = array();
                                    $instances = implode(",", $inputParams['instances']);
                                    $instanceInfo = $this->BP->get_appinst_info($instances, $sid);
                                    //get unique app types
                                    foreach($instanceInfo as $info) {
                                        $appType = $info['app_type'];
                                        if(!in_array($appType, $appTypes)) {
                                            $appTypes[] = $appType;
                                        }
                                    }
                                    //get all backup types based on user-input types and unique app types
                                    $types = array();
                                    foreach($data['types'] as $type) {
                                        foreach($appTypes as $appType) {
                                            $types[] = $this->FUNCTIONS->getBackupTypeCoreNameBackupNow($type, $appType);
                                        }
                                    }
                                    $inputParams['profile']['types'] = $types;
                                }

                            }
                            if(isset($data['calendar'])) {
                                $appType = 'Archive';
                                $inputParams['calendar'] = $this->scheduleToICal($data['calendar'], $appType);
                            }
                            if(isset($data['email_report'])) {
                                $inputParams['email_report'] = $data['email_report'];
                            }
                            if(isset($data['storage'])) {
                                $inputParams['profile']['target'] = $data['storage'];
                            }

                            if(isset($data['range_size'])) {
                                if($data['range_size'] == 0) {
                                    $inputParams['profile']['range_size'] = 0;
                                } else {
                                    $inputParams['profile']['range_size'] = (time()) - (86400 * $data['range_size']);
                                }
                            }
                            if(isset($data['append'])) {
                                $inputParams['profile']['options']['append'] = $data['append'];
                            }
                            if(isset($data['purge'])) {
                                $inputParams['profile']['options']['purge'] = $data['purge'];
                            }
                            if(isset($data['encrypt'])) {
                                $inputParams['profile']['options']['encrypt'] = $data['encrypt'];
                            }
                            if(isset($data['retention_days'])) {
                                $inputParams['profile']['options']['retention_days'] = $data['retention_days'];
                            }
                            $status = $this->BP->save_archive_schedule_info($inputParams, $sid);
                            if($status !== false) {
                                if(isset($status['id'])) {
                                 $status = true;
                                }
                            }
                            break;
                    }
                }
            }
        }
        return $status;
    }


    public function scheduleToICal($schedParams, $appType) {
        //Create initial iCal string
        $iCal = "BEGIN:VCALENDAR";

        foreach($schedParams as $calItem) {
            $iCal .= "\r\nBEGIN:VEVENT";
            $iCal .= "\r\nDESCRIPTION:";
            $backupType = $this->FUNCTIONS->getBackupTypeCoreName($calItem['backup_type'], $appType);
            $iCal = $iCal . "\r\nSUMMARY:" . $backupType;
            //DTSTART
            $iCal .= "\r\nDTSTART:";
            $dateStringArr = explode("/", $calItem['start_date']);
            $timeStringArr = explode(":", $calItem['start_time']);
            $dateString = $dateStringArr[2] . $dateStringArr[0] . $dateStringArr[1];
            $timeString = "T" . $timeStringArr[0] . $timeStringArr[1] . "00";
            $iCal .= $dateString . $timeString;

            //Linda thinks it's required by iCal but core does not actually use
//            $iCal = $iCal . "DTEND:" . $dateString . "T" . (((int)$timeStringArr[0] + 1) % 24) . $timeStringArr[1] . "00";
            $iCal .= "\r\nDTEND:" . $dateString . $timeString;

            //only make an RRULE if it is recurring event, ie. schedule_run, run_on, or recurrence are set
            if(isset($calItem['schedule_run']) or isset($calItem['run_on']) or isset($calItem['recurrence'])) {
                //RRULE
                $iCal = $iCal . "\r\nRRULE:";

                if($calItem['schedule_run'] == 0) {
                    $iCal .= "FREQ=WEEKLY";
                }
                if(isset($calItem['run_on']) and count($calItem['run_on']) == 0) {
                    continue;
                } else {
                    //Days
                    $dayString = ";BYDAY=";
                    $individualDayString = "";
                    foreach($calItem['run_on'] as $day) {
                        switch($day) {
                            case 0:
                                $individualDayString .= ",SU";
                                break;
                            case 1:
                                $individualDayString .= ",MO";
                                break;
                            case 2:
                                $individualDayString .= ",TU";
                                break;
                            case 3:
                                $individualDayString .= ",WE";
                                break;
                            case 4:
                                $individualDayString .= ",TH";
                                break;
                            case 5:
                                $individualDayString .= ",FR";
                                break;
                            case 6:
                                $individualDayString .= ",SA";
                                break;
                        }
                    }
                    //Remove the initial comma from the day list
                    $dayString .= substr($individualDayString, 1);
                    $iCal .= $dayString;
                }
                if(isset($calItem['recurrence'])) {
                    $recurrence = $calItem['recurrence'];

                    if($recurrence < 60) {
                        //minutes
                        $iCal .= ";BYMINUTE=";
                        $minutes = '';
                        for($i = 0; $i <= 59/(int)$recurrence; $i++) {
                            $minutes .= ',' . ($i * (int)$recurrence);
                        }
                        $iCal .= substr($minutes, 1);
                    } else {
                        //hours
                        $iCal .= ";BYHOUR=";
                        $hourInterval = (int)$recurrence/60;
                        $hours = '';
                        for($i = 0; $i <= 23/$hourInterval; $i++) {
                            $hours .= ',' . ($i * $hourInterval);
                        }
                        $iCal .= substr($hours, 1);
                    }
                }
            }


            $iCal .= "\r\nEND:VEVENT";
        }

        //End Calendar
        $iCal .= "\r\nEND:VCALENDAR";
//        print_r($iCal);

        return $iCal;
    }


//            if(isset($calItem['recurrence'])) {
//                $recurrenceArr = $calItem['recurrence'];
//                $recurrenceString = "";
//                switch($calItem['interval']) {
//                    case 'hours':
//                        break;
//                    case 'minutes':
//                        if(is_numeric($recurrenceArr['every']) and $recurrenceArr['every'] <= 60 )
//                        $recurrenceString .= "BYMINUTE:";
//                        $numRecurrences = 60/(int)$recurrenceArr['every'];
//                        for($i = 0; $i < $numRecurrences; $i++) {
//                            $recurrenceString = $recurrenceString . ($i * (int)$recurrenceArr['every']) . ",";
//                        }
//                        $recurrenceString = substr($recurrenceString, 0, -1);
//                        break;
//                }
//            }



    public function iCalToSchedule($iCalString) {
        $iCalArr = explode("BEGIN:VEVENT", $iCalString);
        for ($i = 0; $i < count($iCalArr); $i++) {
            $iCalArr[$i] = explode("\r\n", $iCalArr[$i]);
            for ($j = 0; $j < count($iCalArr[$i]); $j++) {
                $iCalArr[$i][$j] = explode(":", $iCalArr[$i][$j]);
            }
        }
        $scheduleParams = array();

        //VEVENT Layer (should never be more than 2)
        for($i = 0; $i < count($iCalArr); $i++) {
            $scheduleItem = array();
            foreach($iCalArr[$i] as $iCalPiece) {
                switch($iCalPiece[0]) {
                    case 'SUMMARY':
                        if(!isset($scheduleItem['backup_type'])) {
                            $scheduleItem['backup_type'] = $this->FUNCTIONS->getBackupTypeDisplayName(strtolower($iCalPiece[1]));
                        }
                        break;
                    case 'DTSTART':
//                        $dateTimeString = explode("T", $iCalPiece[1]);

                        //date will be in format 20140521 to be converted to 05/21/2014
//                        $date = substr($dateTimeString[0], 4, 2) . "/" . substr($dateTimeString[0], 6) . "/" . substr($dateTimeString[0], 0, 4);

                        //time will be in format 134500 to be converted to 13:45
//                        $time = substr($dateTimeString[1], 0, 2) . ":" . substr($dateTimeString[1], 2, 2);

                        $timestamp = $this->FUNCTIONS->dateToTimestamp($iCalPiece[1]);
                        $dateTime = $this->FUNCTIONS->formatDateTime($timestamp);
                        $dateTimeArray = explode(" ", $dateTime);

                        if(!isset($scheduleItem['start_date'])) {
                            $scheduleItem['start_date'] = $dateTimeArray[0];
                        }

                        if(!isset($scheduleItem['start_time'])) {
                            $scheduleItem['start_time'] = $dateTimeArray[1] . " " . $dateTimeArray[2];
                        }
                        break;
                    case 'RRULE':
                        $rules = $iCalPiece[1];
                        $weekly = false;
                        //explode the rule string into each separate rule
                        $ruleArr = explode(";", $rules);
                        for($k = 0; $k < count($ruleArr); $k++) {
                            $ruleArr[$k] = explode("=", $ruleArr[$k]);
                            switch($ruleArr[$k][0]) {
                                case 'FREQ':
                                    switch($ruleArr[$k][1]) {
                                        case 'DAILY':
                                            if(!isset($scheduleItem['schedule_run'])) {
                                                $scheduleItem['schedule_run'] = '0';
                                            }
                                            break;
                                        case 'WEEKLY':
                                            $weekly = true;
                                            if(!isset($scheduleItem['schedule_run'])) {
                                                $scheduleItem['schedule_run'] = '0';
                                            }
                                            break;
                                        case 'MONTHLY':
                                            if(!isset($scheduleItem['schedule_run'])) {
                                                $scheduleItem['schedule_run'] = '1';
                                            }
                                            break;
                                    }
                                    break;
                                case 'BYDAY':
                                    $days = explode(",", $ruleArr[$k][1]);
                                    if(!isset($scheduleItem['run_on'])) {
                                        $dayArr = array();
                                        foreach($days as $day) {
                                            switch($day) {
                                                case 'SU':
                                                    $dayArr[] = '0';
                                                    break;
                                                case 'MO':
                                                    $dayArr[] = '1';
                                                    break;
                                                case 'TU':
                                                    $dayArr[] = '2';
                                                    break;
                                                case 'WE':
                                                    $dayArr[] = '3';
                                                    break;
                                                case 'TH':
                                                    $dayArr[] = '4';
                                                    break;
                                                case 'FR':
                                                    $dayArr[] = '5';
                                                    break;
                                                case 'SA':
                                                    $dayArr[] = '6';
                                                    break;
                                            }
                                            $scheduleItem['run_on'] = $dayArr;
                                        }
                                    }
                                    break;
                                case 'BYHOUR':
                                    if(!isset($scheduleItem['recurrence'])) {
                                        $hours = explode(",", $ruleArr[$k][1]);
                                        if(count($hours) == 23) {
                                            continue;
                                        } else {
                                            if(count($hours) == 1) {
                                                continue;
                                            } else {
                                                $scheduleItem['recurrence'] = (int)(((int)$hours[1] - (int)$hours[0])*60);
                                            }
                                        }
                                    }
                                    break;
                                case 'BYMINUTE':
                                    if(!isset($scheduleItem['recurrence'])) {
                                        $minutes = explode(",", $ruleArr[$k][1]);
                                        $scheduleItem['recurrence'] = (int)((int)$minutes[1] - (int)$minutes[0]);
                                    }
                                    break;
                                case 'INTERVAL':
                                    if($weekly and $ruleArr[$k][1] == 2) {
                                        $scheduleItem['schedule_run'] = '5';
                                    } else {
                                        continue;
                                    }
                                    break;
                            }
                        }
                        break;
                }
            }
            if($scheduleItem) {
//                if(!isset($scheduleItem['run_on'])) {
//                    $scheduleItem['run_on'] = array(0 => '0', 1 => '1', 2 => '2', 3 => '3', 4 => '4', 5 => '5', 6 => '6');
//                }
                $scheduleParams[] = $scheduleItem;
            }
        }
        return $scheduleParams;
    }

    public function getShortCalendarArr($calendarArr) {
        $shortCalArr = array();
        foreach($calendarArr as $calItem) {
            $shortCalString = "";
            if($calItem['backup_type'] != 'archive') {
                $shortCalString .= $calItem['backup_type'] . ": ";
            }
            if(isset($calItem['schedule_run'])) {
                switch($calItem['schedule_run']) {
                    case 1:
                        $shortCalString .= "1st ";
                        break;
                    case 2:
                        $shortCalString .= "2nd ";
                        break;
                    case 3:
                        $shortCalString .= "3rd ";
                        break;
                    case 4:
                        $shortCalString .= "4th ";
                        break;
                }
            }
            if(isset($calItem['run_on'])) {
                if(count($calItem['run_on']) == 7) {
                    $shortCalString .= "Sun-Sat";
                } elseif(count($calItem['run_on']) == 1) {
                    $shortCalString .= $this->shortCalStringHelper($calItem['run_on'][0]);
                } else {
                    $prevDay = $calItem['run_on'][0] - 1;
                    $inSequence = true;
                    foreach($calItem['run_on'] as $day) {
                        if($day == $prevDay + 1) {
                            $prevDay = $day;
                        } else {
                            $inSequence = false;
                            break;
                        }
                    }
                    if($inSequence) {
                        $firstDay = $calItem['run_on'][0];
                        $lastDay = $calItem['run_on'][count($calItem['run_on']) - 1];
                        $shortCalString .= $this->shortCalStringHelper($firstDay) . "-" . $this->shortCalStringHelper($lastDay);
                    } else {
                        foreach($calItem['run_on'] as $day) {
                            $shortCalString .= $this->shortCalStringHelper($day) . ",";
                        }
                        $shortCalString = substr_replace($shortCalString, "", -1);
                    }
                }
            }
            if(isset($calItem['recurrence'])) {
                if($calItem['recurrence'] < 60) {
                    $shortCalString .= " every " . $calItem['recurrence'] . " minutes";
                } else {
                    $shortCalString .= " every " . $calItem['recurrence']/60 . " hours";
                }
            } elseif(!isset($calItem['recurrence']) and !isset($calItem['schedule_run']) and !isset($calItem['run_on'])) {
                $shortCalString .= $calItem['start_date'] . " at " . $calItem['start_time'];
            } else {
                if(!isset($calItem['run_on'])) {
                    $timestamp = strtotime($calItem['start_date']);
                    $day = date("D", $timestamp);
                    $shortCalString .= " " . $day;
                }
                $shortCalString .= " at " . $calItem['start_time'];
            }
            $shortCalArr[] = $shortCalString;
        }
        return $shortCalArr;
    }

    public function shortCalStringHelper($intDay) {
        switch($intDay) {
            case 0:
                $stringDay = "Sun";
                break;
            case 1:
                $stringDay = "Mon";
                break;
            case 2:
                $stringDay = "Tue";
                break;
            case 3:
                $stringDay = "Wed";
                break;
            case 4:
                $stringDay = "Thu";
                break;
            case 5:
                $stringDay = "Fri";
                break;
            case 6:
                $stringDay = "Sat";
                break;
        }
        return $stringDay;
    }

    public function backup_now($data, $sid) {
        $backupType = $data['backup_type'];
        $inputParams = array();
        $appType = "";
        if(isset($data['client_id'])) {
            $appType = "file-level";
            $backupType = $this->FUNCTIONS->getBackupTypeCoreNameBackupNow($backupType, $appType);
            $inputParams['id'] = $data['client_id'];
        } else {
            $instanceInfo = $this->BP->get_appinst_info($data['instances'][0], $sid);
            $info = $instanceInfo[$data['instances'][0]];
            $inputParams['id'] = $info['client_id'];
            $inputParams['appinst_ids'] = $data['instances'];
            $appType = $info['app_type'];
            $backupType = $this->FUNCTIONS->getBackupTypeCoreNameBackupNow($backupType, $appType);
        }
        if(isset($data['verify'])) {
            switch($data['verify']) {
                case "none":
                    $inputParams['verify_level'] = 0;
                    break;
                case "inline":
                    $inputParams['verify_level'] = 3;
                    break;
            }
        } else {
            $inputParams['verify_level'] = 3;
        }
        if(isset($data['storage'])) {
            if(strtolower($data['storage']) != "internal" and $data['storage'] != "") {
                $inputParams['dev_name'] = "_d" . $data['storage'];
            }
        }

        // For CE, file-level backups are not allowed.
        if ( $appType === "file-level" )
        {
            //Display error message telling the user that file-level backups are not allowed
            $returnArr['error'] = "500";
            $returnArr['message'] = "Unitrends Community Edition only supports virtual machine backups.  Backups of the virtual host are not currently supported. Please select at least one virtual machine to backup.";
        }
        else
        {
            $status = $this->BP->backup_now($backupType, $inputParams, $sid);
            if($status !== false) {
                $returnArr = array();
                foreach($status as $returnItem) {
                    if(isset($returnItem['appinst_id'])) {
                        $item['instance'] = $returnItem['appinst_id'];
                        $instanceInfo = $this->BP->get_appinst_info($item['instance'], $sid);
                        if($instanceInfo != false) {
                            $appName = $instanceInfo[$item['instance']]['app_type'];
                            if ($appName == 'Hyper-V') {
                                $item['host_name'] = $instanceInfo[$item['instance']]['client_name'];
                                $item['instance_name'] = $instanceInfo[$item['instance']]['primary_name'];
                            } else {
                                $item['host_name'] = $instanceInfo[$item['instance']]['primary_name'];
                                $item['instance_name'] = $instanceInfo[$item['instance']]['secondary_name'];
                            }
                        }
                    } else {
                        $clientInfo = $this->BP->get_client_info($returnItem['client_id'], $sid);
                        if ($clientInfo != false) {
                            $item['client_name'] = $item['instance_name'] = $clientInfo['name'];
                        }
                    }
                    $item['job_id'] = $returnItem['job_id'];
                    if($item['job_id'] == -1) {
                        $item['message'] = $returnItem['msg'];
                    }
                    $returnArr[] = $item;
                }
                $returnArr = array("data" => $returnArr);
            } else {
                $returnArr = $status;
            }
        }
        return $returnArr;
    }

    private function gatherDetailedSaveInfo($result, $sid)
    {
        $status = array();

        //loop through and collect each error
        foreach($result as $item) {
            if(isset($item['appinst_id'])) {
                $returnItem['instance'] = $item['appinst_id'];
                $instanceInfo = $this->BP->get_appinst_info($item['appinst_id'], $sid);
                if($instanceInfo !== false) {
                    $appName = $instanceInfo[$item['appinst_id']]['app_type'];
                    if ($appName == 'Hyper-V') {
                        $returnItem['host_name'] = $instanceInfo[$item['appinst_id']]['client_name'];
                        $returnItem['instance_name'] = $instanceInfo[$item['appinst_id']]['primary_name'];
                    } else {
                        $returnItem['host_name'] = $instanceInfo[$item['appinst_id']]['primary_name'];
                        $returnItem['instance_name'] = $instanceInfo[$item['appinst_id']]['secondary_name'];
                    }
                }
            }
            $returnItem['message'] = $item['message'];
            $status[] = $returnItem;
        }

        return $status;
    }

}

?>
