<?php
// defines BP, xml, action, cookie
require 'header.php';

$dpuID = isset($_GET['sid']) ? (int)$_GET['sid'] : $BP->get_local_system_id();

$ActiveDirectory = $BP->get_ini_section("Active Directory", $dpuID);

switch($action) {
	case "list":
		global $Log;
		if($ActiveDirectory !== false) {
			$ADsettings = array();
			foreach($ActiveDirectory as $ADsection){
				$key = $ADsection['field'];
				$value = $ADsection['value'];
				
				$result = array($key => $value);
				$ADsettings = array_merge($ADsettings, $result);
			}
		
			$useAD = $ADsettings['AD_AuthenticationEnabled'];
			$ADserver = $ADsettings['AD_ServerName'];
			$fqdn = $ADsettings['AD_DomainName'];
			$useADSSL = $ADsettings['AD_UseSSL'];
			$SuperUserGroup = $ADsettings['AD_Superuser'];
			$AdministratorGroup = $ADsettings['AD_Admin'];
			$manageGroup = $ADsettings['AD_Manage'];
			$monitorGroup = $ADsettings['AD_Monitor'];
			
			$server = isset($_GET['adserver']) ? $_GET['adserver'] : lookupHostname($BP, $xml, $fqdn);
			$adIP = getADIP($BP, $xml, $fqdn);
			
			if ($adIP == "0.0.0.0") {
				// IP was not found in the hosts file
				// potentially check if fqdn can resolved
				// return the server as set in master.ini
				$server = $ADserver;
			}
						
			$xml->push("root");
			$xml->push("ActiveDirectory", array("useAD" => $useAD,
												"useADSSL" => $useADSSL,
												"Server" => $server,
												"FQDN" => $fqdn,
												"ADIP" => $adIP,
												"SuperuserGroup" => $SuperUserGroup,
												"AdministratorGroup" => $AdministratorGroup,
												"ManageGroup" => $manageGroup,
												"MonitorGroup" => $monitorGroup));
			$xml->pop(); //ActiveDirectory																		
			$xml->pop(); //root									
		}
		echo ($xml->getXml());
		break;
		
	case "change":
		$useAD = $_GET['usead']  == '1' ? "Yes" : "No";
		$useADSSL = $_GET['useadssl'] == '1' ? "Yes" : "No";
		$fqdn = isset($_GET['addomain']) ? $_GET['addomain'] : "";
		$adIP = isset($_GET['adip']) ? $_GET['adip'] : getADIP($BP, $xml, $fqdn);
		$server = isset($_GET['adserver']) ? $_GET['adserver'] : lookupHostname($BP, $xml, $fqdn);
		$superuser = isset($_GET['sugroup']) ? $_GET['sugroup'] : "";
		$admin = isset($_GET['admingroup']) ? $_GET['admingroup'] : "";
		$manage = isset($_GET['managegroup']) ? $_GET['managegroup'] : "";
		$monitor = isset($_GET['monitorgroup']) ? $_GET['monitorgroup'] : "";
	
		// see if hostname in hosts file
		$checkADip = getADIP($BP, $xml, $fqdn);
		$checkHostname = lookupHostname($BP, $xml, $fqdn);
		if($checkADip == '0.0.0.0' || $checkHostname == ""){
			// hosts file entry is not required, continue
			// potentially check if fqdn can resolved
			$adIP = $checkADip;
		}
	
		$settings = array ('AD_AuthenticationEnabled' => $useAD,
						  'AD_UseSSL' => $useADSSL,
						  'AD_ServerName' => $server,
						  'AD_DomainName' => $fqdn,
						  'AD_Superuser' => $superuser,
						  'AD_Admin' => $admin,
						  'AD_Manage' => $manage,
						  'AD_Monitor' => $monitor);				  
		
		$result = true;
	
		foreach ($settings as $field => $value) {
			$result = $BP->set_ini_value("Active Directory", $field, $value, $dpuID);
			if ($result !== true) {
				break;
			}
		}
		
		$xml->push("root");
		$xml->push("ActiveDirectory", array("useAD" => $useAD,
											"useADSSL" => $useADSSL,
											"Server" => $server,
											"FQDN" => $fqdn,
											"ADIP" => $adIP,
											"SuperuserGroup" => $superuser,
											"AdministratorGroup" => $admin,
											"ManageGroup" => $manage,
											"MonitorGroup" => $monitor));
		$xml->pop(); //ActiveDirectory																		
		$xml->pop(); //root			
	
	echo ($xml->getXml());
	break;
}

//make sure server is in hosts file
//also need to check for hosts['long_name']
function getADIP($BP, $xml, $fqdn){
	$adIP = "0.0.0.0";
	$hostInfo = $BP->get_host_info($fqdn);
	if($hostInfo !==false) {
		if(isset($hostInfo['ip'])) {
			$adIP = $hostInfo['ip'];
		}
	}
	return $adIP;
}

function lookupHostname($BP, $xml, $fqdn){
	$server = "";
	$hostInfo = $BP->get_host_info($fqdn);
	if($hostInfo !==false) {
		if(isset($hostInfo['name'])) {
			$server = $hostInfo['name'];
		}
	}
	return $server;
}

?>
