<?php
// defines BP, xml, action, cookie
require 'header.php';

$startTime = -1;
$endTime = -1;
$days = -1;

switch ($action) {				
	case "list":
			$dpuID = isset($_GET['sid']) ? (int)$_GET['sid'] : $BP->get_local_system_id();
			
			if (isset($_REQUEST['days']) || (isset($_REQUEST['start']) && isset($_REQUEST['end']))) {
				$returnValue = true;
				if (isset($_REQUEST['days'])) {
					$days = (int)$_REQUEST['days'];
				} else {
					$startTime = (int)$_REQUEST['start'];
					$endTime = (int)$_REQUEST['end'];
				}
				
				//
				// Loop through all systems.  Will be only one in the list for a DPU, multiple systems on a Vault or manager.
				//
				$systems = $BP->get_system_list();
				
				$xml->push('root');
				$localID = $BP->get_local_system_id();
				$bVault = $BP->local_system_is_vault();
				$bMDPU = isset($_GET['mdpu']) ? true : false;				
				$bManager = $BP->local_system_is_mgr();
				
				foreach ($systems as $systemID => $systemName) {
					if ($systemID == $dpuID || $dpuID == $localID) {
						
						if (!$bVault && $bManager && !$bMDPU && ($systemID != $dpuID)) {
							// if we're a manager, but the user didn't select the manager node, skip the unselected node.
							continue;			
						} else if (!$bManager || ($localID == $systemID)) {
							$arrayFilter = addDaysFilter($days, $startTime, $endTime);
						} else {
							$arrayFilter = array ('dpu' => $systemID);
							$arrayFilter = array_merge($arrayFilter, addDaysFilter($days, $startTime, $endTime));
						}
				
						$alerts = $BP->get_alerts("descending", "timestamp", $arrayFilter);
						if ($alerts !== false) {
							foreach ($alerts as $alert) {
								createAlertReportXML($xml, $alert, $systemID, $systemName);
							}
						}
					}
				}	
				$xml->pop(); //root
			} else {
				$xml->clear(false);
				$BP->buildResult($xml, false, "error: alerts: Must specify # days to run alert report.");
			}
			echo($xml->getXml());
			break;
	
	case "detail":
			// to update a field/value pair or add if not present
			$bValid = false;
			if (isset($_REQUEST['field'])) {
				$field = $_REQUEST['field'];
				if (isset($_REQUEST['value'])) {
					$value = $_REQUEST['value'];
					$bValid = true;
				} else {
					$BP->buildResult($xml, false, "error: CMC configuration: no field value specified.");
					echo($xml->getXml());
				}
			} else {
				$BP->buildResult($xml, false, "error: CMC configuration: no field name specified.");
				echo($xml->getXml());
			}		
			
			if ($bValid) {
				$BP->buildResult($xml, $BP->set_ini_value($section, $field, $value));
				echo($xml->getXml());
			}			
			break;
}


function addDaysFilter($days, $startTime, $endTime, $clientInfo = NULL)
{
	// see if the user specified start and end time.
	if ($startTime != -1) {
		if ($endTime == -1) {
			$endTime = time();
		}
		
	} else {
	
		//$days = -1;
		// default -1, use defaults (week for DPUs, month for clients)
		if ($days == -1) {
			if ($clientInfo == NULL) {
				// 6 days before today gives us 1 week of data.
				$days = 6;
			} else {
				$days = 30;
			}
		} else {
			// subtract 1 day since we are going back in time (inclusive).
			// we will also go back to midnight (below).
			$days = $days - 1;
		}
			
		$endTime = time();
		// convert to start and end times (days * 24 hr/day * 60 min/hr * 60 sec/min)
		$startTime = $endTime - ($days * 24 * 60 * 60);
		// adjust the start time back to midnight of x days ago.
		$dayOffset = date('H:i:s', $startTime);
		$pieces = explode(':', $dayOffset);
		$hour = (int)$pieces[0];
		$minute = (int)$pieces[1];
		$sec = (int)$pieces[2];
		$startTime -= (($hour * 60 * 60) + ($minute * 60) + $sec);
	}

	//printf("end time is %d and start time is %d<br/>", $endTime, $startTime);
	$filterArray = array('start_time' => $startTime, 'end_time' => $endTime);
	return $filterArray;
}

//
// Creates the XML for the backup status node used in multiple php files.  The caller
// specifies the tag name to be used (so that the same routine can generate SDS statuses.
//
function createAlertReportXML($xml, $alert,  $dpuID, $dpuName)
{
	// convert timestamp to local time/day
	$day = date('m/d/Y', $alert['timestamp']);
	$time = date(TIME_FORMAT_12HR, $alert['timestamp']);
	
	$xml->push('Alert', array("Identification" => $alert['id'], "DPUName" => $dpuName));
	$xml->element('Date', $day);
	$xml->element('Time', $time);
	$xml->element('Resolved', $alert['resolved'] == true ? 1 : 0);
	$xml->element('Severity', $alert['severity']);
	$xml->element('SourceName', $alert['source_name']);
	$xml->element('Text', $alert['text']);
	$xml->pop(); // 'Alert
}

$BP->destroyCookie();
?>
