<?php
// defines BP, xml, action, cookie
require 'header.php';

// xml reader operations for clients.
require 'xmlreader.php';

// list base functions
require 'listsbase.php';
$ListBase = new ListBase();

// general library functions
require 'library.php';
$lib = new Library();

// Initialize variables to be used in save.
$scheduleInfo = array();
$bValid = true;

// get System ID, Client ID, application ID.
$dpuID = isset($_GET['sid']) ? (int)$_GET['sid'] : $BP->get_local_system_id();
$cid = isset($_GET['cid']) ? (int)$_GET['cid'] : -1;
$aid = isset($_GET['aid']) ? (int)$_GET['aid'] : -1;
$rae = isset($_GET['rae']) ? true : false;

switch ($action) {

    case "list":
        listSchedules($BP, $xml, $cid, $aid, $dpuID, false);
        echo($xml->getXml());
        break;

    case "all":
        listSchedules($BP, $xml, $cid, $aid, $dpuID, true);
        echo($xml->getXml());
        break;

    case "load":
        $id = isset($_GET['id']) ? (int)$_GET['id'] : -1;
        loadSchedule($BP, $xml, $id, $dpuID);
        echo($xml->getXml());
        break;

    case "save":
        $id = isset($_GET['id']) ? (int)$_GET['id'] : -1;
        if ($id == -1) {
            if (isset($_GET['name'])) {
                $scheduleInfo = array_merge($scheduleInfo, array("name" => $_GET['name']));
            } else {
                $BP->buildResult($xml, false, "Error: must specify either name or id of schedule to save.");
                $bValid = false;
            }
        } else {
            $scheduleInfo = array_merge($scheduleInfo, array("id" => $id));
            if (isset($_GET['name'])) {
                $scheduleInfo = array_merge($scheduleInfo, array("name" => $_GET['name']));
            }
        }
        if ($bValid) {
            if (isset($_GET['desc'])) {
                $scheduleInfo['description'] = $_GET['desc'];
            }
            if (isset($_GET['enabled'])) {
                $enabled = $_GET['enabled'] == "1" ? true : false;
                $scheduleInfo['enabled'] = $enabled;
            }
            if (isset($_GET['aid'])) {
                $scheduleInfo['app_id'] = (int)$_GET['aid'];
            }


            // Pass calendar data via request - can be a lot of text.
            if (isset($_REQUEST['calendar'])) {
                $scheduleInfo['calendar'] = $_REQUEST['calendar'];
            }

            // Build the backup options array.
            $optionList = array();
            $options = array ('dev_name' => 'dev');
            $bOptions = array();
            $iOptions = array('verify_level' => 'verify');
            $optionList = buildOptions($optionList, $options, $bOptions);
            $optionList = addIntegerOptions($optionList, $iOptions);
            // get Instance ID's array.
            if (isset($_REQUEST['ids'])) {
                $optionList['appinst_ids'] = $lib->getIDs($_REQUEST['ids']);
            }
            if (isset($_GET['metanames'])) {
                $metaList = $_GET['metanames'];
                if ($metaList != "") {
                    $metanames = explode(",", $metaList);
                    $optionList['metanames'] = $metanames;
                } else {
                    $optionList['metanames'] = array();
                }
            }
            // Pass any filenames to be excluded via request.
            // File level backup may have a file list.
            $files = getFiles('excludes');
            if (count($files) > 0) {
                $optionList['excl_list'] = $files;
            }
            $files = getFiles('includes');
            if (count($files) > 0) {
                $optionList['incl_list'] = $files;
            }
            if (count($optionList) > 0) {
                $scheduleInfo['backup_options'] = $optionList;
            }

            // Build the schedule options array.
            $optionList = array();
            $options = array ('before_command' => 'bcmd',
                'after_command' => 'acmd');
            $bOptions = array('email_report' => 'email',
                'failure_report' => 'fail',
                'include_new' => 'inc');
            $optionList = buildOptions($optionList, $options, $bOptions);
            // get client ID.
            if (isset($_GET['cid'])) {
                $optionList['client_id'] = (int)$_GET['cid'];
            }

            if (count($optionList) > 0) {
                $scheduleInfo['schedule_options'] = $optionList;
            }

            // Build the regular expression array.
            $optionList2 = array();
            if (isset($_REQUEST['reg'])) {
                $tempArray = $_REQUEST['reg'];
                $regs = explode(':::', $tempArray);
                for ($n = 0; $n < count($regs); $n+=3) {
                    $regExpArray = array();
                    if (isset($regs[$n]) && intval($regs[$n]) !== 0) {
                        $regExpArray['id'] = intval($regs[$n]);
                        $regExpArray['action'] = intval($regs[$n+1]);
                        if (isset($regs[$n+2])) {
                            $regExpArray['filter'] = $regs[$n+2];
                        }
                    }
                    if (!empty($regExpArray)) {
                        $optionList2[] = $regExpArray;
                    }
                }
            }
            $scheduleInfo['regular_expressions'] = $optionList2;

            $result = $rae ? $BP->save_rae_app_schedule_info($scheduleInfo, $dpuID) : $BP->save_app_schedule_info($scheduleInfo, $dpuID);

            // If the call is unsuccessful, APIs return false or an array.
            // If the call is successful, APIs return true if modifying an existing schedule or an ID when creating a new schedule.
            if ($result !== false && !is_array($result)) {
                // If retention set, save settings after schedule successfully saved.
                if (isset($_GET['min']) && isset($_GET['max']) && isset($_GET['legalhold'])) {
                    if (isset($_REQUEST['ids'])) {
                        $instanceIDs = $lib->getIDs($_REQUEST['ids']);
                    } else {
                        $instanceIDs = array();
                        // need to get file-level instance, for the client_id.
                        if (isset($optionList['client_id'])) {
                            $clientID = $optionList['client_id'];
                            $settings = $BP->get_retention_settings(array('client_id' => $clientID), $dpuID);
                            if ($settings !== false) {
                                foreach ($settings as $setting) {
                                    if ($setting['app_name'] == 'file-level') {
                                        $instanceIDs[] = $setting['instance_id'];
                                        break;
                                    }
                                }
                            }
                        }
                    }
                    $retentionResult = setRetention($BP, $instanceIDs,
                        (int)$_GET['min'],
                        (int)$_GET['max'],
                        (int)$_GET['legalhold'],
                        $dpuID);
                    if ($retentionResult === false) {
                        // log the error in setting retention.
                        global $Log;
                        $Log->writeError('Error setting retention for schedule: ' . $BP->getError(), true);
                    }
                }
            }
            $ListBase->buildResult($xml, $result);

        }
        echo($xml->getXml());
        break;

    case "delete":
        $id = (int)$_GET['id'];
        $BP->buildResult($xml, $BP->delete_app_schedule($id, $dpuID));
        echo($xml->getXml());
        break;

    case "enable":
        $id = (int)$_GET['id'];
        $BP->buildResult($xml, $BP->enable_app_schedule($id, $dpuID));
        echo($xml->getXml());
        break;

    case "disable":
        $id = (int)$_GET['id'];
        $BP->buildResult($xml, $BP->disable_app_schedule($id, $dpuID));
        echo($xml->getXml());
        break;

    case "containers":
        $cid = (int)$_GET['cid'];
        $resultArray = $BP->get_vm_schedule_container_list($cid, $dpuID);
        if ($resultArray === false) {
            $BP->buildResult($xml, false);
        } else {
            $xml->push('root');
            foreach ($resultArray as $result) {
                $xml->push('Container');
                $xml->element("id", $result['id']);
                $xml->element("name", $result['name']);
                $xml->pop();
            }
            $xml->pop();
        }

        echo($xml->getXml());
        break;


    case "regexAction":
        $results = $BP->get_vm_schedule_regex_action_list($dpuID);
        if ($results === false) {
            $BP->buildResult($xml, false);
        } else {
            $xml->push('root');
            foreach ($results as $resultA) {
                $xml->push('Action');
                $xml->element("id", $resultA['id']);
                $xml->element("name", $resultA['name']);
                $xml->pop();
            }
            $xml->pop();
        }
        echo($xml->getXml());
        break;

}

//
// This function lists the schedules for this client and application, optionally loading each schedule.
//
function listSchedules($BP, $xml, $cid, $aid, $dpuID, $bLoad = false)
{
    global $ListBase;

    $clients = ($cid === -1) ? $BP->get_client_list($dpuID) : false;
    $scheduleList = $BP->get_app_schedule_list($cid, $aid, $dpuID);
    if ($scheduleList !== false) {
        $xml->push("root");
        foreach ($scheduleList as $schedule) {
            $attributes = $ListBase->getAttributes($schedule);
            if (array_key_exists('enabled', $schedule)) {
                $enabled = $schedule['enabled'] == true ? "1" : "0";
                $attributes['Enabled'] = $enabled;
            }
            if (array_key_exists('client_id', $schedule)) {
                $clientID = $schedule['client_id'];
                $clientName = $clients !== false ? $clients[$clientID] : $clientID;
                $attributes['Client'] = $clientName;
            }
            // handle vCenter schedules.
            if (array_key_exists('esx_uuid', $schedule)) {
                $uuid = $schedule['esx_uuid'];
                $attributes['UUID'] = $uuid;
            }
            if (array_key_exists('key', $schedule)) {
                $key = $schedule['key'];
                $attributes['key'] = $key;
            }
            $xml->push("Schedule", $attributes);
            if ($bLoad) {
                loadSchedule($BP, $xml, $schedule['id'], $dpuID, false);
            }
            $xml->pop(); // schedule
        }
        $xml->pop(); // root
    } else {
        $BP->buildResult($xml, false);
    }
}

//
// This function loads the schedule given its ID.  It optionally wraps the schedule
// information with a root XML tag.
//
function loadSchedule($BP, $xml, $id, $dpuID, $bShowRoot = true) {
    global $rae;
    $scheduleInfo = $rae ? $BP->get_rae_app_schedule_info($id, $dpuID) : $BP->get_app_schedule_info($id, $dpuID);
    if ($scheduleInfo !== false) {
        if ($bShowRoot) {
            $xml->push("root");
        }
        createScheduleXML($xml, $scheduleInfo);
        if ($bShowRoot) {
            $xml->pop(); // root
        }
    } else {
        if ($bShowRoot) {
            $BP->buildResult($xml, false);
        } else {
            // Add a warning that this schedule could not be loaded.
            ;
        }
    }
}

//
// This function walks the schedule information returned from the load and
// creates the XML for each element.
//
function createScheduleXML($xml, $scheduleInfo)
{
    $iCalendarContent = $scheduleInfo['calendar'];
    if ($iCalendarContent === false) {
        $BP->buildResult($xml, false);
    } else {
        $xml->push("Calendar");
        $xml->cData($iCalendarContent);
        $xml->pop(); // Calendar
    }

    $optionList = $scheduleInfo['backup_options'];
    $xml->push('BackupOptions');
    if (array_key_exists('dev_name', $optionList)) {
        $xml->element("Device", $optionList['dev_name']);
    }
    if (array_key_exists('verify_level', $optionList)) {
        $xml->element("VerifyLevel", $optionList['verify_level']);
    }
    if (array_key_exists('appinst_ids', $optionList)) {
        $appInstances = $optionList['appinst_ids'];
        foreach ($appInstances as $appInstance) {
            $xml->element("AppInstance", $appInstance);
        }
    }
    if (array_key_exists('excl_list', $optionList)) {
        $filenames = $optionList['excl_list'];
        foreach ($filenames as $fileName) {
            // For Linux directories, remove the volume placeholder.
            $fileName = str_replace(LINUX_VOLUME, "", $fileName);
            $xml->element("Exclude", $fileName);
        }
    }
    if (array_key_exists('incl_list', $optionList)) {
        $filenames = $optionList['incl_list'];
        foreach ($filenames as $fileName) {
            // For Linux directories, remove the volume placeholder.
            $fileName = str_replace(LINUX_VOLUME, "", $fileName);
            $xml->element("Include", $fileName);
        }
    }
    if (array_key_exists('metanames', $optionList)) {
        $metanames = $optionList['metanames'];
        foreach ($metanames as $exclusionName) {
            $xml->element("Metaname", $exclusionName);
        }
    }
    $xml->pop(); // BackupOptions

    $optionList = $scheduleInfo['schedule_options'];
    $xml->push('ScheduleOptions');
    if (array_key_exists('client_id', $optionList)) {
        $xml->element("ClientID", $optionList['client_id']);
    }
    global $ListBase;
    $ListBase->buildOptionsXML($xml, $optionList);
    $xml->pop(); // ScheduleOptions

    if(array_key_exists('regular_expressions', $scheduleInfo)) {
        foreach ( (array)($scheduleInfo['regular_expressions']) as $regular_expression ) {
            $xml->push("RegExp");
            $xml->element('id', $regular_expression['id']);
            $xml->element('action', $regular_expression['action']);
            $xml->element('filter', $regular_expression['filter']);
            $xml->pop();
        }
    }

}

function setRetention($BP, $instanceArray, $min, $max, $legalHold, $dpuID) {
    $retentionSettings = array();
    $retentionMin = $min;
    $retentionMax = $max;
    foreach ($instanceArray as $instanceID) {
        // Make sure it is a valid instance.
        if ($instanceID != 0) {
            $retentionItem = array();
            $retentionItem['instance_id'] = $instanceID;
            $retentionItem['retention_min'] = $retentionMin;
            $retentionItem['retention_max'] = $retentionMax;
            $retentionItem['legal_hold'] = $legalHold;
            $retentionSettings[] = $retentionItem;
        }
    }
    // Don't call retention if there are no instances.
    if (count($retentionSettings) > 0) {
        $result = $BP->save_retention_settings($retentionSettings, $dpuID);
    } else {
        $result = true;
    }
    return $result;
}

function getFiles($type) {
    $files = array();
    if (isset($_REQUEST[$type])) {
        $fileList = $_REQUEST[$type];
        if ($fileList != "") {
            $filenames = explode(",", $fileList);
            for ($i = 0; $i < count($filenames); $i++) {
                $filenames[$i] = urldecode($filenames[$i]);
            }
            $files = $filenames;
        }
    }
    return $files;
}

$BP->destroyCookie();
?>