<?php

// converts xml string to archive profile
require 'arxml.php';

// archive functions
require 'arfunctions.php';

// defines BP, xml, action, cookie
require '../header.php';

// general library functions
require $rootdir . 'bpl/library.php';
$lib = new Library();

define("MB_PER_GB", 1024);

$localID = $BP->get_local_system_id();
$dpuID = isset($_GET['sid']) ? (int)$_GET['sid'] : $localID;

// figure out which sysID to used based on view.
$sysID = $grandClientView ? $localID : $dpuID;


switch ($action) {

	case "now":
	case "backup":	// Run an archive backup now.
			if (isset($_REQUEST['profile'])) {
				$profileXML = $_REQUEST['profile'];
				$profile = xmlToProfile($profileXML, $lib);
			} else {
				$profile = getProfileFromURL($lib);
			}
			
			$result = $BP->archive_now($profile, $sysID);
			if ($result === false) {
				$BP->buildResult($xml, false);
			} else {
				$xml->push("root");
				$xml->emptyelement("Archive", array("JobID" => $result));
				/*
				foreach ($resultArray as $result) {
					$attributes = array("JobID" => $result['job_id']);			
					if (array_key_exists('appinst_id', $result)) {
						$attributes = array_merge($attributes, array("ID" => $result['appinst_id']));
					}
					if (array_key_exists('msg', $result)) {
						$attributes = array_merge($attributes, array("Message" => $result['msg']));
					}
					$xml->emptyelement("Backup", $attributes);
				}
				*/
				$xml->pop(); // root
			}
								
			echo($xml->getXml());			
			break;
			
	case "test":	// Test to see if an archive job will fit on the media.
			if (isset($_REQUEST['profile'])) {
				$profileXML = $_REQUEST['profile'];
				$profile = xmlToProfile($profileXML, $lib);
			} else {
				$profile = getProfileFromURL($lib);
			}
			
			$result = $BP->check_archive_space($profile, $sysID);
			if ($result === false) {
				$BP->buildResult($xml, false);
			} else {
				$SizeTest = $result;
				// Check Free Space on Target
				$result = $BP->get_connected_archive_media($sysID);
				$bMediaFound = false;
				if ($result !== false) {
					foreach ($result as $media) {
						// find the media for this job.
						if ($media['name'] == $profile['target']) {
							$mediaFree = $media['mb_free'] / MB_PER_GB;
							$mediaFree = sprintf("%.2f", $mediaFree);
							$mediaSize = $media['mb_size'] / MB_PER_GB;
							$mediaSize = sprintf("%.2f", $mediaSize);
							$mediaIsInfinite = "0";
							if (isset($media['is_infinite'])) {
								$mediaIsInfinite = ($media['is_infinite'] == true) ? "1" : "0";
							}
							$bMediaFound = true;
							break;
						}
					}
				} else {
					$xml->element("MediaError", $BP->getError());
				}
				$xml->push("root");
				$minSize = sprintf("%.2f", $SizeTest['min'] / MB_PER_GB);
				$xml->element("Min", $minSize);
				$likelySize = sprintf("%.2f", $SizeTest['likely'] / MB_PER_GB);
				$xml->element("Likely", $likelySize);
				$maxSize = sprintf("%.2f", $SizeTest['max'] / MB_PER_GB);
				$xml->element("Max", $maxSize);
				$append = $profile['options']['append'];
				$xml->element("Append", ($append == true) ? '1' : '0');
				if ($bMediaFound) {
					$xml->emptyelement("Media", array("Size" => $mediaSize, "Free" => $mediaFree, "IsInfinite" => $mediaIsInfinite));
				}
				$xml->pop(); // root
			}
								
			echo($xml->getXml());			
			break;

}

$BP->destroyCookie();
?>