<?php

// archive functions
require 'arfunctions.php';

// defines BP, xml, action, cookie
require '../header.php';

$localID = $BP->get_local_system_id();
$dpuID = isset($_GET['sid']) ? (int)$_GET['sid'] : $localID;

// figure out which sysID to used based on view.
$sysID = $grandClientView ? $localID : $dpuID;

$searchOptions = array();
global $Log;
switch ($action) {
		
	case "search":
	$Log->writeVariable("in search");
		// starts a search files job.
			$cid = $_GET['cid'];
			$cname = $_GET['cname'];
			
			$options = array ('name' => 'name');
			$bOptions = array('expression' => 'expr',
							  'case' => 'case',
							  'include' => 'include');		
			$searchOptions = buildOptions($searchOptions, $options, $bOptions);
			$iOptions = array('client_id' => 'cid',
							  'start_date' => 'start_date',
							  'end_date' => 'end_date');
			$searchOptions = addIntegerOptions($searchOptions, $iOptions);
			
			$maxCount = $_GET['max'];
				
			if (isset($_GET['start_size'])) {
				$startSize = (float)$_GET['start_size'];
				$searchOptions = array_merge($searchOptions, array ("start_size" => $startSize));
			}
			if (isset($_GET['end_size'])) {
				$endSize = (float)$_GET['end_size'];
				$searchOptions = array_merge($searchOptions, array ("end_size" => $endSize));
			}
		
			$result = array();					
			if (!isset($_GET['sid']) || $sysID == $localID) {
				$result = $BP->search_archive_files($searchOptions, $cname, $maxCount);
			} else {
				$result = $BP->search_archive_files($searchOptions, $cname, $maxCount, $sysID);
			}																
			if ($result === false) {
				$BP->buildResult($xml, false);
			} else {
				$xml->push('root');
				displaySearchList($xml, $BP, $result, $cname, $sysID);
				$xml->pop(); // root
			}
		echo($xml->getXml());								
		break;
}

function displaySearchList($xml, $BP, $fileList, $clientName, $systemID)
{
	foreach ($fileList as $fileInfo) {
		$dateTime = date('m/d/Y   h:i:s A', $fileInfo['date']);
		$archiveSetInfo = $BP->get_archive_set_info($fileInfo['archive_set_id'], $systemID);
		$archiveTime = date('m/d/Y   h:i:s A', $archiveSetInfo['timestamp']);
		$Type = "file-level";											  
		$pathName = $fileInfo['filename'];
		$dir = $pathName;
		$file = $pathName;
		$n = strrpos($pathName, '/');
		if ($n != -1) {
			$dir = substr($pathName, 0, $n + 1);
			$file = substr($pathName, $n + 1);
		}
		// For Linux directories, remove the volume placeholder for the view.
		$viewPath = str_replace("@@@:", "", $pathName);   
		$fileSize = is_int($fileInfo['size']) ? $fileInfo['size'] : sprintf("%.2f", $fileInfo['size']);	
		$barcodes = isset($archiveSetInfo['barcodes']) ? implode(', ', $archiveSetInfo['barcodes']) : "";
		
		$attributes = array('Pathname' => $viewPath,
											  'Directory' => $dir,
											  'Filename' => $file,
											  'Client' => $clientName,	
											  'Type' => $Type,
											  'set_id' => $fileInfo['archive_set_id'],
											  'archive_id' => $fileInfo['archive_id'],
											  'media_serial' => $fileInfo['media_serial'],
											  'Barcodes' => $barcodes,
											  'Date' => $dateTime,
											  'ArchiveDate' => $archiveTime,
											  'Size' => $fileSize);
		if ($barcodes != "") {
			$attributes['Barcodes'] = $barcodes;
		}
		
		$xml->emptyelement('FileFound', $attributes);
	}
}

$BP->destroyCookie();
?>
