<?php
// defines BP, xml, action, cookie
require '../header.php';

$localID = $BP->get_local_system_id();
$dpuID = isset($_GET['sid']) ? (int)$_GET['sid'] : $localID;

// figure out which sysID to used based on view.
$sysID = $grandClientView ? $localID : $dpuID;

switch ($action) {				
		
	case "all":
	case "possible":	// Get possible archive media
			$result = $BP->get_possible_archive_media($sysID);
			if ($result !== false) {
				$xml->push('root');
				foreach ($result as $media) {
					$xml->push('Media');
					displayPossibleMedia($xml, $media);
					$xml->pop(); // Media
				}
				$xml->pop(); // MediaType
			} else {
				$BP->buildResult($xml, false);
			}
			echo($xml->getXml());
			break;
			
	case "list":
	case "connected":	// Get connected archive media
			$result = $BP->get_connected_archive_media($sysID);
			if ($result !== false) {
				$xml->push('root');
				foreach ($result as $media) {
					$xml->push('Media');
					displayConnectedMedia($xml, $media);
					$xml->pop(); // Media
				}
				$xml->pop();
			} else {
				$BP->buildResult($xml, false);
			}
			echo($xml->getXml());
			break;
				
	case "mount":	// Mount archive media
			if (isset($_GET['name'])) {
				$mediaName = $_GET['name'];
				$BP->buildResult($xml, $BP->mount_archive_media($mediaName, $sysID));
			} else {
				$BP->buildResult($xml, false, 'archive media name to mount must be specified.');
			}
			echo($xml->getXml());
			break;
			
	case "unmount":	// Unmount archive media
			if (isset($_GET['name'])) {
				$mediaName = $_GET['name'];
				$bForceUnmount = isset($_GET['force']) && ($_GET['force'] == '1') ? true : false;
				$BP->buildResult($xml, $BP->unmount_archive_media($mediaName, $bForceUnmount, $sysID));
			} else {
				$BP->buildResult($xml, false, 'archive media name to unmount must be specified.');
			}
			echo($xml->getXml());
			break;
			
	case "prepare":	// Prepare archive media
			if (isset($_GET['name'])) {
				$mediaName = $_GET['name'];
				if (isset($_GET['label'])) {
					$mediaLabel = $_GET['label'];
					$slots = isset($_GET['slots']) ? $_GET['slots'] : "";
					$BP->buildResult($xml, $BP->prepare_archive_media($mediaName, $mediaLabel, $slots, $sysID));
				} else {
					$BP->buildResult($xml, false, 'archive media label must be specified.');
				}
			} else {
				$BP->buildResult($xml, false, 'archive media name being prepared must be specified.');
			}
			echo($xml->getXml());
			break;
			
	case "sets":	// Get media archive sets
			if (isset($_GET['name'])) {
				$mediaName = $_GET['name'];
				$slots = isset($_GET['slots']) ? $_GET['slots'] : "";
				$sets = $BP->get_media_archive_sets($mediaName, $slots, $sysID);
				if ($sets !== false) {
					$xml->push('root');
					foreach ($sets as $set) {
						$xml->push('Set');
						if (isset($set['description'])) {
							$xml->element('Description', $set['description']);
						}
						if (isset($set['timestamp'])) {
							$date = date('m/d/Y   h:i:sA', $set['timestamp']);
							$xml->element('Date', $date);
						}
						if (isset($set['needs_import'])) {
							$xml->element('NeedsImport', $set['needs_import'] == true ? 1 : 0);
						}
						$xml->pop();
					}
					$xml->pop();
				} else {
					$BP->buildResult($xml, false);
				}
			} else {
				$BP->buildResult($xml, false, 'archive sets media name must be specified.');
			}
			echo($xml->getXml());
			break;
			
	case "import":	// Import archive sets on media into catalog.
			if (isset($_GET['name'])) {
				$mediaName = $_GET['name'];
				$slots = isset($_GET['slots']) ? $_GET['slots'] : "";
				$force = isset($_GET['force']) ? $_GET['force'] == '1' : false;
				$returnValue = $BP->import_archive_catalog($mediaName, $slots, $force, $sysID);
				if ($returnValue !== false) {
					$xml->push('root');
					$setIDs = $returnValue['ids'];
					if (count($setIDs) > 0) {
						foreach ($setIDs as $setID) {
							$xml->element('SetID', $setID);
						}
					}
					if (isset($returnValue['messages']) && count($returnValue['messages']) > 0) {
						$messages = $returnValue['messages'];
						foreach ($messages as $message) {
							$xml->element('Message', $message);
						}
					}
					$xml->pop();
				} else {
					$BP->buildResult($xml, false);
				}
			} else {
				$BP->buildResult($xml, false, 'media name to import must be specified.');
			}
			echo($xml->getXml());
			break;
			
		case "tapeinfo": // Get information about a tape library, including the drives and the slots
			if (isset($_GET['name'])) {
				$mediaName = $_GET['name'];
				$tapeInfo = $BP->get_tape_library_info($mediaName, $sysID);
				
				/*
				$tapeInfo = array(
                     	barcodes_available   => true,
                        drives => array (
                        	1 => array(status => "Loaded", barcode => "barcode0", loaded_slot => "2")
                        ),
                        slots => array (
                        	1 => array(status => "Full", barcode => "barcode0"),
                        	2 => array(status => "Full", barcode => "barcode1"),
                        	3 => array(status => "Full", barcode => "barcode2"),
                        	4 => array(status => "Full"),
                        	5 => array(status => "Empty"),
                            6 => array(status => "Full", barcode => "barcode3")
						)
                );
				*/

				if ($tapeInfo !== false) {
					displayTapeInfo($xml, $tapeInfo);
				} else {
					$BP->buildResult($xml, false);
				}
			} else {
				$BP->buildResult($xml, false, 'media name must be specified.');
			}
			echo($xml->getXml());
		break;
		
}

//
// Builds the XML that corresponds to the possible media return.
//
function displayPossibleMedia($xml, $media) {
	// Handle both an array or a string return type.
	if (is_array($media)) {
		if (array_key_exists('name', $media)) {
			$xml->element('Name', $media['name']);
		}
		if (isset($media['type'])) {
			$xml->element("Type", $media['type']);
		}
	} else {
		$xml->element('Name', $media);
		$xml->element('Type', 'unknown');
	}
}

//
// Builds the XML that corresponds to the connective media return.  Defined in the BPL API Guide section 41.5.
//
function displayConnectedMedia($xml, $media) {
	
	displayPossibleMedia($xml, $media);
	$xml->element('Busy', (array_key_exists('is_busy', $media) && $media['is_busy'] == true) ? "1" : "0");
	$xml->element('Mounted', (array_key_exists('is_mounted', $media) && $media['is_mounted'] == true) ? "1" : "0");
	$xml->element('Initialized', (array_key_exists('is_initialized', $media) && $media['is_initialized'] == true) ? "1" : "0");
	
	if (array_key_exists('activity', $media)) {
		// should be Idle, Archive, Restore, or Import.
		$xml->element('Activity', $media['activity']);
	}
	if (isset($media['mb_size'])) {
		$xml->element("Size", $media['mb_size']);
	}
	if (isset($media['mb_free'])) {
		$xml->element("Free", $media['mb_free']);
	}
	if (isset($media['mb_used'])) {
		$xml->element("Used", $media['mb_used']);
	}
	if (isset($media['is_infinite'])) {
		$xml->element("IsInfinite", ($media['is_infinite'] == true) ? "1" : "0");
	}
	if (isset($media['seed_ok'])) {
		$xml->element("IsSeedingSupported", ($media['seed_ok'] == true) ? "1" : "0");
	}
	if (isset($media['media_serials'])) {
		$xml->element("Serials", $media['media_serials']);
	}
	if (isset($media['media_label'])) {
		$xml->element("Label", $media['media_label']);
	}
}

function displayTapeInfo($xml, $tapeInfo) {
	$xml->push('root');
	
	if (isset($tapeInfo['barcodes_available'])) {
		$xml->element('BarcodesAvailable', $tapeInfo['barcodes_available'] == true ? 1 : 0);
	}	
	if (isset($tapeInfo['drives'])) {
		displayTapeDrives($xml, $tapeInfo['drives']);
	}
	if (isset($tapeInfo['slots'])) {
		displayTapeSlots($xml, $tapeInfo['slots']);
	}	
	
	$xml->pop(); // root
}


function displayTapeDrives($xml, $drives) {
	if ($drives !== false && is_array($drives) && count($drives) > 0 ) {
		$xml->push('Drives', array('Count'=>count($drives)));
		
		foreach ($drives as $key=>$drive) {
			$xml->push('Drive', array('Index'=>$key));
			
			if (isset($drive['loaded_slot'])) {
				$xml->element("LoadedSlot", $drive['loaded_slot']);
			}
			if (isset($drive['status'])) {
				$xml->element("Status", $drive['status']);
			}
			if (isset($drive['barcode'])) {
				$xml->element("Barcode", $drive['barcode']);
			}	
	
			$xml->pop(); // Drive
		}
		$xml->pop(); // Drives
	}
}


function displayTapeSlots($xml, $slots) {
	if ($slots !== false && is_array($slots) && count($slots) > 0 ) {
		$xml->push('Tapes', array('Count'=>count($slots)));
		
		foreach ($slots as $key=>$slot) {
			$xml->push('Tape', array('Index'=>$key));
						
			if (isset($slot['status'])) {
				$xml->element("Status", $slot['status']);
			}
			if (isset($slot['barcode'])) {
				$xml->element("Barcode", $slot['barcode']);
			}
	
			$xml->pop(); // Tape
		}
		$xml->pop(); // Tapes
	}
}

$BP->destroyCookie();
?>
