<?php
// defines BP, xml, action, cookie
require 'header.php';

// converts xml string to client array
require 'xmlreader.php';

$localID = $BP->get_local_system_id();
$dpuID = isset($_GET['sid']) ? (int)$_GET['sid'] : $localID;

// figure out which sysID to used based on view.
$sysID = $grandClientView ? $localID : $dpuID;

switch ($action) {

	case "now":	// backup now
			$backupType = isset($_GET['btype']) ? $_GET['btype'] : "master";
			
			$clientXML = $_REQUEST['clients'];
			$clients = xmlToClient($clientXML);
			
			$bValid = true;
			$clientInfoArray = array();
			$i = 0;
			if (count($clients) > 0) {
				$clientInfoArray = $clients;
			} else {
				$clientList = $clientXML;
				$stringSeparator = "zxz";
				$clients = explode($stringSeparator, $clientList);
				$i = 0;
				if (count($clients) > 0) {
					foreach ($clients as $clientString) {
						if (parseClientString($clientString, $id, $inclusions, $exclusions, $options)) {
							$clientInfoArray[$i]['id'] = $id;
							$clientDetail = $BP->get_client_info($id, $dpuID);
							$clientInfoArray[$i]['priority'] = $clientDetail['priority'];
							$clientInfoArray[$i]['inclusions'] = $inclusions;
							$clientInfoArray[$i]['exclusions'] = $exclusions;
							$clientInfoArray[$i]['options'] = $options;
							$i++;
						} else {
							$BP->buildResult($xml, false, "error getting client information for backup.");
							$bValid = false;
						}
					}
				} else {
					$BP->buildResult($xml, false, "no client information available for backup.");
					$bValid = false;
				}
			}
			
			if ($bValid) {
				if (!isset($_GET['sid']) || $dpuID == $BP->get_local_system_id()) {
					$resultArray = $BP->backup_now($backupType, $clientInfoArray);
				} else {
					$resultArray = $BP->backup_now($backupType, $clientInfoArray, $dpuID);
				}
							
				if ($resultArray === false) {
					$BP->buildResult($xml, false);
				} else {
					$xml->push("root");
					foreach ($resultArray as $result) {
						$attributes = array("ClientID" => $result['client_id'],
											"JobID" => $result['job_id']);			
						if (array_key_exists('msg', $result)) {
							$attributes = array_merge($attributes, array("Message" => $result['msg']));
						}		
						$xml->emptyelement("Backup", $attributes);
					}
					$xml->pop(); // root
				}
			}								
			echo($xml->getXml());			
			break;
			
	case "list":
			// general backup list operations.
			require 'listsbase.php';
			global $Log;
			$ListBase = new ListBase();
		
			$xml->push('root');
			$ListBase->buildCalendarList($BP, $xml, $dpuID, false);
			$ListBase->buildSelectionLists($BP, $xml, $dpuID, false);
			$ListBase->buildOptionsList($BP, $xml, $dpuID, false);
			$ListBase->buildScheduleList($BP, $xml, $dpuID, false);
			$ListBase->buildAppScheduleList($BP, $xml, $dpuID);
			$ListBase->buildArchiveScheduleList($BP, $xml, $dpuID);
				
			// Check to see if the default device is D2D or not (crucial for backups).
			$d2dDefault = ($BP->default_device_is_d2d($dpuID)) ? "1" : "0";
			$xml->element("DefaultD2D", $d2dDefault);
			$xml->pop(); // root
			echo($xml->getXml());
			break;
			
	case "delete":
			// delete one or more backup.  If more than one, ids will be a comma-separated list.
			if (isset($_REQUEST['ids'])) {
				$ids = $_REQUEST['ids'];
				$legalHoldIDs = "";
				if (isset($_REQUEST['legalholdids'])) {
					// comma-separated list of backups selected for deletion which are on legal hold
					$legalHoldIDs = $_REQUEST['legalholdids'];
				}
				$BP->buildResult($xml, $BP->delete_backup($ids, $legalHoldIDs, $sysID));
			} else {
				$BP->buildResult($xml, false, "must specify ID(s) of backup(s) to delete.");
			}
			echo($xml->getXml());
			break;
			
	case "related":
			// get related backups, returns an error if any backups are pending vaulting/replication
			if (isset($_GET['id'])) {
				$id = (int)$_GET['id'];
				// get extended info, currently only includes legal hold
				$getExtendedInfo = isset($_GET['extended']) ? ($_GET['extended'] == '1') : false;
				$result = $BP->get_related_backups($id, $sysID);
				if ($grandClientView) {
					$clients = $BP->get_grandclient_list($dpuID);
				} else {
					$clients = $BP->get_client_list($dpuID);
				}
				$systems = $BP->get_system_list();
				if ($result !== false && $clients !== false && $systems !== false) {
					if ($getExtendedInfo === true) {
						$legalHoldInfo = $BP->get_legalhold_backup_info($id, $sysID);
						if ($legalHoldInfo !== false) {
							$legalHoldInfo = current($legalHoldInfo);
						}
					}
					
					$backupList = $result;
					$dpuName = $systems[$dpuID];
					
					if ($getExtendedInfo !== false && $legalHoldInfo) {
						$attr = array();
						if (isset($legalHoldInfo["is_on_hold"])) {
							$attr["OnHold"] = $legalHoldInfo["is_on_hold"] == true ? "1" : "0";
						}
						if (isset($legalHoldInfo['is_on_hold']) && $legalHoldInfo["is_on_hold"] == true) {
							if (isset($legalHoldInfo["hold_days_backup"])) {
								$attr["LegalHoldDaysBackup"] = $legalHoldInfo["hold_days_backup"];
							}
							if (isset($legalHoldInfo["hold_days_instance"])) {
								$attr["LegalHoldDaysInstance"] = $legalHoldInfo["hold_days_instance"];
							}
							if (isset($legalHoldInfo['hold_expire_time'])) {
								// convert timestamp to local time/day
								$day = date('m/d/Y', $legalHoldInfo['hold_expire_time']);
								$time = date(TIME_FORMAT_12HR, $legalHoldInfo['hold_expire_time']);
								$attr['LegalHoldExpirationDate'] = $day;
								$attr['LegalHoldExpirationTime'] = $time;
							}
						}
						$xml->push('Backups', $attr);
					}
					else {
						$xml->push('Backups');
					}
					
					foreach ($backupList as $backup) {
						if (array_key_exists($backup['client_id'], $clients)) {
							$clientName = $clients[$backup['client_id']];
						} else {
							$clientName = "unknown";
						}
						createShortBackupStatusXML($xml, $backup, $dpuName, $clientName);		
					}
					$xml->pop(); // Backups
				} else {
					$BP->buildResult($xml, false);
				}
			} else {
				$BP->buildResult($xml, false, "must specify ID of backup(s) to get related backups.");
			}
			echo($xml->getXml());
			break;
		
	case "dependent":
			// get dependent backups, same as related but it always returns the related backups
			// whereas related backups returns an error if any backups are pending vaulting or replication
			if (isset($_GET['id'])) {
				$id = (int)$_GET['id'];
				$result = $BP->get_dependent_backups($id, $sysID);
				if ($grandClientView) {
					$clients = $BP->get_grandclient_list($dpuID);
				} else {
					$clients = $BP->get_client_list($dpuID);
				}
				$systems = $BP->get_system_list();
				if ($result !== false && $clients !== false && $systems !== false) {
					$backupList = $result;
					$dpuName = $systems[$dpuID];
					
					$xml->push('Backups');
					
					foreach ($backupList as $backup) {
						if (array_key_exists($backup['client_id'], $clients)) {
							$clientName = $clients[$backup['client_id']];
						} else {
							$clientName = "unknown";
						}
						createShortBackupStatusXML($xml, $backup, $dpuName, $clientName);		
					}
					$xml->pop(); // Backups
				} else {
					$BP->buildResult($xml, false);
				}
			} else {
				$BP->buildResult($xml, false, "must specify ID of backup(s) to get dependent backups.");
			}
			echo($xml->getXml());
			break;
}

//
// This function converts a string of information about clients into its components.
//
// format:
// 		clientString		 id:<id>,inc:<incid>,exc:<excid>,opt:optidzxz
//
//							 id:2,inc:3,exc:1,zxzid:1,exc:0
//
function parseClientString($clientString, &$id, &$inclusions, &$exclusions, &$options) {

	$result = true;
	
	$oneClient = explode(',', $clientString);
	foreach ($oneClient as $clientAttribute) {
		$attrValue = explode(':', $clientAttribute);
		switch ($attrValue[0]) {
			case 'id':
					$id = (int)$attrValue[1];
					break;
			case 'inc':
					$inclusions = $attrValue[1];
					break;
			case 'exc':
					$exclusions = $attrValue[1];
					break;
			case 'opt':
					$options = $attrValue[1];
					break;
		}
	}	
	
	return $result;			
}

$BP->destroyCookie();
?>
