<?php
// defines BP, xml, action, cookie
require 'header.php';

// defines functions for backup status processing.
require('basebackupstatus.php');

// general library functions
require $rootdir . 'bpl/library.php';
$lib = new Library();

$localID = $BP->get_local_system_id();

$dpuID    = isset($_GET['sid'])     ? (int)$_GET['sid']   : $localID;
$deviceID = isset($_GET['devid'])   ? (int)$_GET['devid'] : -1;

$clientID    = isset($_GET['cid'])  ? (int)$_GET['cid']   : NULL;
$appID       = isset($_GET['aid'])  ? (int)$_GET['aid']   : NULL;

$instanceIDs = isset($_GET['iids']) ? $lib->getStringArray($_GET['iids']) : NULL;


$startTime = isset($_GET['start'])  ? (int)$_GET['start'] : NULL;
$endTime   = isset($_GET['end'])    ? (int)$_GET['end']   : NULL;

// figure out which sysID to used based on view.
$sysID = $grandClientView ? $localID : $dpuID;

switch ($action) {				
	case "list":
		$backupsPerDeviceFilter = array( 'device_id' => $deviceID );
		$clients = $grandClientView && $dpuID != $localID ? $BP->get_grandclient_list($dpuID) : $BP->get_client_list($dpuID);
		
		$Log->writeVariable( "Inside the backup device listing code" );
		
		if ( $clientID != NULL ) {
			$backupsPerDeviceFilter[ 'client_ids' ] = array( $clientID );
		} else {
			$clientIDs = array();
			foreach ( $clients as $id => $clientName ) {
				array_push( $clientIDs, $id );
			}
			$backupsPerDeviceFilter[ 'client_ids' ] = $clientIDs;
			
		}
		
		if ( $appID != NULL )      $backupsPerDeviceFilter[ 'app_id' ]      = $appID;
		if ( $startTime != NULL )  $backupsPerDeviceFilter[ 'start_time' ]  = $startTime;
		if ( $endTime != NULL )    $backupsPerDeviceFilter[ 'end_time' ]    = $endTime;
		
		if ( $instanceIDs ) {
			$backupsByInstance = array();
			foreach ( $instanceIDs  as $instanceID ) {
				
				$backupsPerDeviceFilter[ 'instance_id' ] = (int)$instanceID;
				$backupIDs = $BP->get_backups_per_device( $backupsPerDeviceFilter, $sysID );
				
				if ( $backupIDs !== false ) {
					$backupsByInstance = array_merge( $backupsByInstance, $backupIDs );
				}
			}
			$backupIDs = $backupsByInstance;
		} else {
			// Get the backups on the specified device.
			$backupIDs = $BP->get_backups_per_device( $backupsPerDeviceFilter, $sysID );
		}
				
		// Get moreinformation about these backup ID's.
		if (count($backupIDs) > 0) {
			$result_format = array('backup_ids' => $backupIDs);
			$result_format['system_id'] = $sysID;
			$result_format['type'] = $GLOBAL_BACKUP_TYPES;
			$backupArray = $BP->get_backup_status($result_format);
		}
		
		$dpuName = getSystemName($BP, $dpuID);
		$devices = $BP->get_device_list($sysID);
			
		if ( $backupArray != NULL ) {
			$xml->push("root");
			foreach ($backupArray as $backup) {
				createBackupExpandedStatusXML($xml, $backup, $devices, $clients, $dpuID, $dpuName);
			}
			$xml->pop();
		} else {
			$BP->buildResult($xml, false);
		}
		echo($xml->getXml());
		break;
}

$BP->destroyCookie();
?>
