<?php
// defines BP, xml, action, cookie
require 'header.php';

// general library functions
require 'library.php';
$lib = new Library();

// defines functions for backup status processing.
require('basebackupstatus.php');

$dpuID = isset($_GET['sid']) ? (int)$_GET['sid'] : $BP->get_local_system_id();
global $Log;

switch ($action) {

	case "list":	// list cisco UCS information 
			$clientID = isset($_GET['cid']) ? (int)$_GET['cid'] : -1;
			$appID = isset($_GET['aid']) ? (int)$_GET['aid'] : -1; 
			$bCache = isset($_GET['cache']) == true ? 1 : 0;
			
			$ucsspInfo = $BP->get_ucssp_info($clientID, $appID, $bCache, $dpuID);
			if ($ucsspInfo !== false) {				
				$xml->push("root");
				foreach ($ucsspInfo as $item) {
					$id = $item['instance_id'];
					$name = $item['name'];
					$xml->push('UCS_SERVICE_PROFILE', array(	"Identification" => $id,
												"Name" => $name));
					
					if (isset($item['credentials'])) {
						$credentials = $item['credentials'];
						$xml->push("Credential");
					
						$crid = isset($credentials['credential_id']) ? $credentials['credential_id'] : -1;
						$xml->element('ID', $crid);
						$cr_username = isset($credentials['username']) ? $credentials['username'] : "";
						$xml->element('Username', $cr_username);
						$cr_domain = isset($credentials['domain']) ? $credentials['domain'] : "";
						$xml->element('Domain', $cr_domain);
						$cr_is_default = isset($credentials['is_default']) ? $credentials['is_default'] : false;
						$xml->element('Default', $cr_is_default);
						$cr_display_name = isset($credentials['display_name']) ? $credentials['display_name'] : "";
						$xml->element('Name', $cr_display_name);
						$xml->pop(); // Credential
					}
					
					if (isset($item['online'])) {
						$xml->element('Online', $item['online'] ? '1' : '0');
					}
					
					if (isset($item['priority'])) {
						$priority = $item['priority'];
						$xml->element('Priority', $priority);
					}
					
					if (isset($item['is_synchable'])) {
						$xml->element('Synchable', $item['is_synchable'] ? '1' : '0');
					}
					
					$xml->pop(); // UCS_SERVICE_PROFILE		
				}
				// This lets the App know that item replication configuration is supported.
				$xml->element('Supported', 1);
				$xml->pop(); // root
			} else {
				$BP->buildResult($xml, false);
			}
								
			echo($xml->getXml());			
			break;
			
	case 'setcred': // set credentials for UCS
		$clientID     = isset($_GET['cid'])    ? (int)$_GET['cid']                     : -1;
		$appID        = isset($_GET['aid'])    ? (int)$_GET['aid']                     : -1;
		$credentialID = isset($_GET['crid'])   ? (int)$_GET['crid']                    : -1;
		$ids          = isset($_GET['idlist']) ? $lib->getStringArray($_GET['idlist']) : -1;
			
		if ( $clientID == -1 || ( $credentialID == -1 && $ids == -1 ) ) {
			$BP->buildResult($xml, false, "Error: You must select a Cisco UCS system or instance first.");
			$bValid = false;
		} else {
			
			if ( $ids != -1 ) {
				
				foreach ($ids as $id) {
					$info = array();
					$info['instance_id'] = $id;
						
					if ($credentialID) {
						$info['credential_id'] = $credentialID;
					}
					$info['app_aware'] = false;
					$info_array[] = $info;
				}
				
				$result = $BP->save_app_credentials_info( $info_array, $dpuID );
				
				
			} else {
				$result = $BP->save_client_app_credentials($clientID, $appID, $credentialID, $dpuID );
			}
	
			if($result !== false){
				$BP->buildResult($xml, $result);
			} else {
				$BP->buildResult($xml, false);
			}
		}
			
		echo($xml->getXml());
	break;
			
	case 'unsetcred': // delete credentials for UCS
		$clientID     = isset($_GET['cid'])  ? (int)$_GET['cid']  : -1;
		$appID        = isset($_GET['aid'])  ? (int)$_GET['aid']  : -1;
		$ids          = isset($_GET['idlist']) ? $lib->getStringArray($_GET['idlist']) : -1;
			
		if ( ( $clientID == -1 && $ids == -1 )) {
			$BP->buildResult($xml, false, "Error: You must select a Cisco UCS system or instance first.");
			$bValid = false;
		} else {
			if ( $ids != -1 ) {
			
				foreach ($ids as $id) {
					$info = array();
					$info['instance_id'] = $id;
					$info['no_credentials'] = true;
					$info['app_aware'] = false;
					$info_array[] = $info;
				}
			
				$result = $BP->save_app_credentials_info( $info_array, $dpuID );
			} else {
				$result = $BP->delete_client_app_credentials($clientID, $appID, $dpuID );
			}
	
			if($result !== false){
				$BP->buildResult($xml, $result);
			} else {
				$BP->buildResult($xml, false);
			}
		}
			
		echo($xml->getXml());
	break;
			
	case "rae_backup_now":		// start a backup on the specified client for applications that use the Remote Application Engine	
			if (isset($_GET['btype'])) {
				$backupType = ($_GET['btype']);
			}	
		
			// create array of client information
			$clientInfo = array();
			// get client id
			if (isset($_GET['cid'])) {
				$clientInfo['id'] = (int)$_GET['cid'];
			}	
			// get device name
			if (isset($_GET['dev'])) {
				$clientInfo['dev_name'] = ($_GET['dev']);
			}			
			// get Instance ID's array.
			if (isset($_GET['ids'])) {
				$clientInfo['appinst_ids'] = $lib->getIDs($_GET['ids']);
			}
			$clientInfoArray = $clientInfo;
			
			$resultArray = $BP->rae_backup_now($backupType, $clientInfoArray, $dpuID);
			if ($resultArray === false) {
				$BP->buildResult($xml, false);
			} else {
				$xml->push("root");
				foreach ($resultArray as $result) {
					$attributes = array("ClientID" => $result['client_id'],
										"JobID" => $result['job_id']);			
					if (array_key_exists('appinst_id', $result)) {
						$attributes = array_merge($attributes, array("ID" => $result['appinst_id']));
					}
					if (array_key_exists('msg', $result)) {
						$attributes = array_merge($attributes, array("Message" => $result['msg']));
					}
					$xml->emptyelement("Backup", $attributes);
				}
				$xml->pop(); // root
			}
	
			echo($xml->getXml());
			break;
		
	case "rae_restore_app":		// restore a group of app specific backups through Remote Application Engine	
			$backupIDs = isset( $_REQUEST[ 'ids' ] )       ? $_REQUEST[ 'ids' ]       : "";
			$clientID  = isset( $_REQUEST[ 'cid' ] )       ? (int)$_REQUEST[ 'cid' ]  : -1;
			$includes  = isset( $_REQUEST[ 'Includes' ] )  ? $_REQUEST[ 'Includes' ]  : "";
			$excludes  = isset( $_REQUEST[ 'Excludes' ] )  ? $_REQUEST[ 'Excludes' ]  : "";
			$target    = isset( $_REQUEST[ 'Target' ] )    ? $_REQUEST[ 'Target' ]    : "";
			$targetDir = isset( $_REQUEST[ 'Directory' ] ) ? $_REQUEST[ 'Directory' ] : "";
			
			$preCommand  = isset( $_REQUEST[ 'PreCommand' ] )  ? $_REQUEST[ 'PreCommand' ]  : "";
			$postCommand = isset( $_REQUEST[ 'PostCommand' ] ) ? $_REQUEST[ 'PostCommand' ] : "";
			
			$optionsInfo = array();
			
			if ( $clientID != -1 )
				$optionsInfo[ 'client_id' ] = $clientID;
				
			if ( $target != "" )
				$optionsInfo[ 'target' ]    = $target;
				
			if ( $targetDir != "" )
				$optionsInfo[ 'directory' ] = $targetDir;
				
			$includes = explode( '|', $includes );
			$excludes = explode( '|', $excludes );
			
			$optionsInfo[ 'includes' ]  = $includes;
			$optionsInfo[ 'excludes' ]  = array();
			
			if ( $preCommand != "" )
				$optionsInfo[ 'before_command' ] = $preCommand;
			
			if ( $postCommand != "" )
				$optionsInfo[ 'after_command' ]  = $postCommand;
			
			$Log->writeVariable( "rae_restore called with clientID: $clientID, target: $target, directory: $targetDir, includes: $includes, excludes: $excludes, pre: $preCommand, post: $postCommand" );
			
			$result = $BP->rae_restore_application( $backupIDs, $optionsInfo, $dpuID );
			if ($result !== false) {
				$xml->push("root");
				foreach ($result as $job) {
					$jid = $job['job_id'];
					$type = $job['type'];
					if ( $type == "(unknown)" ) {
						$type = "UCS Service Profile Restore";
					}
					$xml->push('Restore', array( "JobID" => $jid,
											 "Type" => $type ));
		
					$xml->pop(); // JOB
				}
				$xml->pop(); // root
			} else {
				$BP->buildResult($xml, false);
			}
	
			echo($xml->getXml());
			break;
}

function xmlToDBs($xml)
{
	$parser = xml_parser_create();
	xml_parser_set_option($parser, XML_OPTION_CASE_FOLDING, 0);
	xml_parser_set_option($parser, XML_OPTION_SKIP_WHITE, 1);
	xml_parse_into_struct($parser, $xml, $values, $tags);
	xml_parser_free($parser);

	$returnArray = array();
	$oneDB = array();

	$stack = array();
	$i = 0;
	foreach ($values as $val) {
		if ($val['type'] == "open") {
			if ($val['tag'] != "DBs" && $val['tag'] != "DB") {
				$field = buildFieldName($val['tag']);
				array_push($stack, $field);
			}

		} else if ($val['type'] == "close") {
			if ($val['tag'] != "DBs" && $val['tag'] != "DB") {
				array_pop($stack);
			}
		} else if ($val['type'] == "complete") {
			$field = buildFieldName($val['tag']);
			array_push($stack, $field);
			setArrayValue($oneDB, $stack, $val['value'], false);
		
			array_pop($stack);		
			if ($val['tag'] == 'No_Credentials') {
				$returnArray[] = $oneDB;
				$oneDB = array();			
			}						
		}
	}
	return $returnArray;	
}

function setArrayValue(&$array, $stack, $value, $bBoolean) {
	if ($stack) {
		$key = array_shift($stack);
		setArrayValue($array[$key], $stack, $value, $bBoolean);
	} else {
		if ($bBoolean) {
			$array = $value == 'true' ? true : false;
		}else {
			$array = $value;
		}
	}
}

function buildFieldName($tag)
{
	$field = "";

	switch ($tag) {
		case "Instance_ID":
			$field = "Instance_ID";
			break;
		
		case "Credential_ID":
			$field = "Credential_ID";
			break;
			
		case "No_Credentials":
			$field = "No_Credentials";
			break;
	}		
	return $field;
}

$BP->destroyCookie();
?>
