<?php
// defines BP, xml, action, cookie
require 'header.php';
define("FILE_SEPARATOR", ",");

$dpuID = isset($_GET['sid']) ? (int)$_GET['sid'] : $BP->get_local_system_id();

switch ($action) {
	case "list":
		// Return this date/time and timezone.
		$bValid = true;
		$date = $BP->get_date($dpuID);
		if ($date !== false) {
			$xml->push("DateTime");
			if (array_key_exists('year', $date)) {
				$xml->element('Year', $date['year']);
			}
			if (array_key_exists('month', $date)) {
				$xml->element('Month', $date['month']);
			}
			if (array_key_exists('day', $date)) {
				$xml->element('Day', $date['day']);
			}
			if (array_key_exists('hour', $date)) {
				$xml->element('Hour', $date['hour']);
			}
			if (array_key_exists('minute', $date)) {
				$xml->element('Minute', $date['minute']);
			}
			if (array_key_exists('second', $date)) {
				$xml->element('Second', $date['second']);
			}
			$tzString = $BP->get_timezone($dpuID);
			if ($tzString !== false) {
				$xml->element('TZ', $tzString);
				if (getNTPSettings($BP, $xml, $dpuID) === false) {
					$xml->clear(false);
					$bValid = false;
					$BP->buildResult($xml, false);
				}
			} else {
				$xml->clear(false);
				$bValid = false;
				$BP->buildResult($xml, false);
			}
			if ($bValid) {
				$xml->pop(); // date
			}
		} else {
			$BP->buildResult($xml, false);
		}
		echo($xml->getXml());
		break;
					
	case "change":	
		// Build the dateInfo array from the arguments.
		
		global $Log;
		
		$result = true;
		$dateInfo = array();
		$options = array();
		$bOptions = array();
		$iOptions = array('year' => 'yr',
						 'month' => 'mo',
						 'day' => 'day',
						 'hour' => 'hr',
						 'minute' => 'min',
						 'second' => 'sec');
		$dateInfo = addIntegerOptions($dateInfo, $iOptions);
		// 
		// If we enable NTP, don't need to set timezone, done via NTP
		//
		$bNTPEnabled = false;
		$result = saveNTPsettings($BP, $dpuID, $bNTPEnabled);
		if ($result !== false) {
			if (!$bNTPEnabled) {
				if (isset($_GET['tz'])) {
					$timezone = $_GET['tz'];
					$result = $BP->set_timezone($timezone, $dpuID);
					
				}
			}
		}
		if ($result !== false) {
			if (count($dateInfo) > 0 && !$bNTPEnabled) {
				// If the user passes in the date, set it.
				$result = $BP->set_date($dateInfo, $dpuID);
			}
		}
		$BP->buildResult($xml, $result);
		echo($xml->getXml());		
		break;
		
	case "tzlist":
		// Get list of timezones.
		$bValid = true;
		$tzList = $BP->get_timezone_list($dpuID);
		if ($tzList !== false) {
			$xml->push("TimeZones");
			foreach ($tzList as $timeZone) {
				$xml->element('TimeZone', $timeZone);
			}
			$xml->pop(); // timezone list
		} else {
			$BP->buildResult($xml, false);
		}
		echo($xml->getXml());
		break;

	case "tz":
		// Get current timezone.
		$tzString = $BP->get_timezone($dpuID);
		if ($tzString !== false) {
			$xml->push("TimeZone");
			$xml->element('TZ', $tzString);
			$xml->pop(); // timezone
		} else {
			$BP->buildResult($xml, false);
		}
		echo($xml->getXml());
		break;
		
	case "ntplist":
		// Get list of ntp settings.
		if (getNTPSettings($BP, $xml, $dpuID) === false) {
			$xml->clear(false);
			$bValid = false;
			$BP->buildResult($xml, false);
		}
		echo($xml->getXml());
		break;
		
	case "ntpsave":
		// Build the ntpInfo array from the arguments.
		$BP->buildResult($xml, saveNTPsettings($BP, $dpuID));
		echo($xml->getXml());		
		break;
	
	case "tzsave":
		
	if (isset($_GET['tz'])) {
		$timezone = $_GET['tz'];
		$result = $BP->set_timezone($timezone, $dpuID);
		}
	
		$BP->buildResult($xml, $result);
		echo($xml->getXML());
		break;
}

function buildServerList($stringNames)
{
	$ntpList = array();
	
	// package names will be in the form <name1>,<name2>,<name3>...	
	$stringNames = trim($stringNames, FILE_SEPARATOR);
	$names = explode(FILE_SEPARATOR, $stringNames);	
	for ($i = 0; $i < count($names); $i++) {
		$ntpList[$i] = urldecode($names[$i]);
	}
	
	return $ntpList;
}

function getNTPSettings($BP, $xml, $dpuID)
{
	$returnValue = true;
	
	$ntpInfo = $BP->get_ntp_settings($dpuID);
	if ($ntpInfo !== false) {
		$xml->push("NTP");
		if (array_key_exists('enabled', $ntpInfo)) {
			$xml->element('Enabled', $ntpInfo['enabled'] == true ? "1" : "0");
		}
		if (array_key_exists('local', $ntpInfo)) {
			$xml->element('Local', $ntpInfo['local'] == true ? "1" : "0");
		}
		if (array_key_exists('broadcast', $ntpInfo)) {
			$xml->element('Broadcast', $ntpInfo['broadcast'] == true ? "1" : "0");
		}
		if (array_key_exists('sync', $ntpInfo)) {
			$xml->element('Sync', $ntpInfo['sync'] == true ? "1" : "0");
		}
		if (array_key_exists('servers', $ntpInfo)) {
			$serverList = $ntpInfo['servers'];
			foreach ($serverList as $server) {
				$xml->element('Server', $server);
			}
		}
		$xml->pop(); // NTP settings
	} else {
		$returnValue = false;
	}
	
	return $returnValue;
}

function saveNTPsettings($BP, $dpuID, &$bEnabled)
{
	$returnValue = true;
	
	// Build the ntpInfo array from the arguments.
	$ntpInfo = array();
	$options = array();
	$bOptions = array('enabled' => 'enabled',
					 'local' => 'local',
					 'broadcast' => 'broadcast',
					 'sync' => 'sync');
	$ntpInfo = buildOptions($ntpInfo, $options, $bOptions);
	if (isset($_REQUEST['servers'])) {
		$serverList = buildServerList($_REQUEST['servers']);
		$ntpInfo['servers'] = $serverList;
	}
	if (count($ntpInfo) > 0) {
		$bEnabled = $ntpInfo['enabled'];
		$returnValue = $BP->save_ntp_settings($ntpInfo, $dpuID);
	}
	
	return $returnValue;
}

//sab 9373
function saveTZandTime($BP, $tzString, $dpuID){
	$returnValue = true;
	
		
	global $Log;
	$returnValue = $BP->set_timezone($tzString, $dpuID);
	
	$Log->writeVariable($tzString);
	
	return $returnValue;
}
	
	
	
	


$BP->destroyCookie();
?>