<?php
//problem with cacheing, IE, and SSL; so use argument url.
//header("Cache-Control: no-cache");
//error_reporting(E_ERROR);

// Set to true after release.
$RELEASE = true;

// Include standard definitions/common functions.
require 'defines.php';
// Include the bpl.so API's. Defines must be included before this.
require 'bp.php';
// Include XML function
require 'xmlwriter.php';
// Include logging functions
require 'logger.php';

// get arguments -- auth (authentication) and type are REQUIRED!
 
// Get authentication cookie.
$authentication_cookie = isset($_REQUEST['auth']) ? $_REQUEST['auth'] : "";

// The action is the operation the user is taking.
$action = isset($_REQUEST['type']) ? $_REQUEST['type'] : "list";

/// Check version number against swf version (set in index.php).
// Set it at release time to fixed version.
$RRCVersion = isset($_REQUEST['ver']) ? $_REQUEST['ver'] : "8.1";
if ($RELEASE) {
        $BPL_VERSION = "8.1";
} else {
        $BPL_VERSION =  trim(shell_exec('rpm -q unitrends-rr'));
}

// Get Logging options
$logLevel = isset($_REQUEST['lvl']) ? (int)$_REQUEST['lvl'] : 0;
$logDirectory = isset($_REQUEST['logdir']) ? $_REQUEST['logdir'] : LOG_DIRECTORY;

// Create standard objects for use in all BPL functions.
$Log = new Logger($logLevel, $logDirectory);
$xml = new ria_xmlWriter(false);
$BP = new BP($authentication_cookie);
$grandClientView = isset($_GET['gcv']) && ($_GET['gcv'] == '1') ? true : false;

// Log the URL passed to the script here.
$Log->writeURL($_SERVER['REQUEST_URI']);

$errorMessage = "You should re-login and try this operation again.  ";
$errorMessage .= "If this behavior continues, you should restart the system.";

// return is XML, set header
header("Content-type: text/xml");

if (!$BP->isBypassCookie()) {
	// If authentication cookie not passed in, return message and error.
	if ($authentication_cookie == "") {
		$errorMessage = 'Error: An empty authentication string was passed from your browser to the system.  ' . $errorMessage;
		$BP->buildResult($xml, false, $errorMessage);
		echo($xml->getXml());
		exit;
	}

	// If authentication cookie invalid, return message and error.
	if (!$BP->validCookie()) {
		$errorMessage = 'Error: Your session has expired or is invalid.  Please log in again to continue.';
		$BP->buildResult($xml, false, $errorMessage, NULL, -1 ); // If the cookie is bad or expired, this flag is sent to prompt the user to log in again.
		echo($xml->getXml());
		exit;
	}
}

// See if the version of the php scripts matches the version passed from the swf on the command line.
if (!$BP->validVersion($RRCVersion, $BPL_VERSION)) {
	$msg = "The version of the Administrator Interface running in your browser is Release ";
	$msg .= $RRCVersion;
	$msg .= ", which is older than the version installed on your system, Release ";
	$msg .= $BPL_VERSION;
	$msg .= ".  To fix, please log out, then clear your browser's cache:\n";
	$msg .= "\n";
	$msg .= "   - If using IE, under Tools > Internet Options > Delete, select Temporary Internet files\n";
	$msg .= "   - If using Firefox, under Tools > Clear Recent History, click on Details and select Cache only\n";
	$msg .= "   - Or, copy and paste this link in a browser for steps: www.wikihow.com/Clear-Your-Browser's-Cache\n";
	$msg .= "\n";
	$msg .= "After clearing the cache, close and restart the browser and login to the Unitrends Administrator Interface again.";

	//
	// If not the initial login command, add a final tag for warnings (ResultArray)
	//
	if (!strstr($_SERVER['REQUEST_URI'], 'buildtree')) {
		$xml->lastTag('ResultArray', 'Result', array('Message' => $msg));
	}
}

$stringError = NULL;

?>
