<?php
// defines BP, xml, action, cookie
require 'header.php';

switch ($action) {
	case "list":	$bValid = true;
					$nvpType = isset($_GET['nvptype']) ? $_GET['nvptype'] : NULL;
					$nvpName = isset($_GET['name']) ? $_GET['name'] : NULL;
					if ($nvpType != NULL && $nvpName != NULL) {
						$nvpList = $BP->get_nvp_list($nvpType, $nvpName);
					} else {
						$BP->buildResult($xml, false, "error: nvp.php: Must specify NVP type and name to get values");
						$bValid = false;		
					}
					if ($bValid) {
						if ($nvpList === false) {
							$BP->buildResult($xml, false);
						} else {
							displayNVPList($xml, $nvpList);
						}
					}
					echo($xml->getXml());
					break;
					
	case "save":	// save a list of name/value pairs as a specified type and name.
					if (isset($_GET['nvptype'])) {
						$nvpType = $_GET['nvptype'];
						if (isset($_GET['name'])) {
							$name = $_GET['name'];
							if (isset($_REQUEST['nvp'])) {
								$nvpList = buildNVPArray($_REQUEST['nvp']);
								if ($nvpList !== false) {
									//printf("In save, nvpArray is<br/>");
									//var_dump($nvpList);
									$BP->buildResult($xml, $BP->save_nvp_list($nvpType, $name, $nvpList));
								} else {
									$BP->buildResult($xml, false, "error: nvp.php: error parsing nvp list.");
								}
							} else {
								$BP->buildResult($xml, false, "error: nvp.php: no name/value pairs specified.");
							}
						} else {
							$BP->buildResult($xml, false, "error: nvp.php: no list name specified.");
						}
					} else {
						$BP->buildResult($xml, false, "error: nvp.php no type name specified.");
					}					
					echo($xml->getXml());		
					break;
					
	case "names":	// return the names of all NVP groupings, optionally filtered by nvptype.
					if (isset($_GET['nvptype'])) {
						$nvpNameList = $BP->get_nvp_names($_GET['nvptype']);
					} else {
						$nvpNameList = $BP->get_nvp_names();
					}
					if ($nvpNameList === false) {
						$BP->buildResult($xml, false);
					} else {
						displayNVPMetadata($xml, "Name", $nvpNameList);
					}
					echo($xml->getXml());
					break;
					
	case "types":	// Return the list of types of all NVP groupings.
					$nvpTypeList = $BP->get_nvp_types();
					if ($nvpTypeList === false) {
						$BP->buildResult($xml, false);
					} else {
						displayNVPMetadata($xml, "Type", $nvpTypeList);
					}
					echo($xml->getXml());
					break;
								

	case "delete":	// removes a named set of name/value pairs
					$nvpType = isset($_GET['nvptype']) ? $_GET['nvptype'] : NULL;
					$nvpName = isset($_GET['name']) ? $_GET['name'] : NULL;
					if ($nvpType != NULL && $nvpName != NULL) {
						$BP->buildResult($xml, $BP->delete_nvp_list($nvpType, $nvpName));
					} else {
						$BP->buildResult($xml, false, "error: nvp.php: Must specify NVP type and name to delete values");
					}
					echo($xml->getXml());
					break;

}

function displayNVPList($xml, $nvpArray)
{
	$xml->push("root");
	foreach ($nvpArray as $field => $value) {
		$xml->emptyelement("NVP", array("Name" => $field, "Value" => $value));
	}
	$xml->pop();
}

function displayNVPMetadata($xml, $stringTag, $nameList)
{
	$xml->push("root");
	foreach ($nameList as $name) {
		$xml->element($stringTag, $name);
	}
	$xml->pop();
}

function buildNVPArray($nvpString)
{
	$nvpList = array();
	global $stringSeparator;
	
	// nvp string will be in the form <name><separator><value>,<name><separator><value>, ...
	
	// strip quotes
	$nvpString = trim($nvpString, ",");
	$nameValuePairs = explode(",", $nvpString);

	foreach ($nameValuePairs as $nameValuePair) {
		//printf("in for, building array, nvPair is <br/>");
		//var_dump($nameValuePair);
		//unique separator string.  Also in Flex user services file.
		$pieces = explode($stringSeparator, $nameValuePair);
		//printf("After Explode, separator is %s, piece[0] = %s, piece[1] is %s<br/>", $stringSeparator, $pieces[0], $pieces[1]);
		if ($pieces[0] != "") {
			$name = $pieces[0];
			$value = $pieces[1];			
			$nvpList[$name] = $value;
		}		
	}

	return $nvpList;
}

$BP->destroyCookie();
?>
