<?php
// defines BP, xml, action, cookie
require 'header.php';

//
// security level definitions and scripts
//
define("SECURITY_NONE", "None");
define("SECURITY_LOW", "Low");
define("SECURITY_MEDIUM", "Med");
define("SECURITY_HIGH", "High");

define("LCD_DIR", "/usr/bp/lcdman.dir/");

define("LCD_NONE", "lcd_sec_none.sh");
define("LCD_LOW", "lcd_sec_low.sh");
define("LCD_MEDIUM", "lcd_sec_med.sh");
define("LCD_HIGH", "lcd_sec_hi.sh");
define("LCD_STATUS", "lcd_sec_stat.txt");

define("EXIT_NONE", 13);
define("EXIT_LOW", 12);
define("EXIT_MEDIUM", 11);
define("EXIT_HIGH", 10);

$rootPassword = isset($_REQUEST['password']) ? urldecode($_REQUEST['password']) : "";
$securityLevel = isset($_GET['security']) ? $_GET['security'] : SECURITY_LOW;

global $Log;

if ($action == 'list') {
	$result = get_port_status($errorMessage);
	if ($result !== false) {
		$xml->push('root');
		$xml->element('Status', $result);
		$dataport_count = $BP->get_ini_value("Configuration Options", "dataport_count");
		if ($dataport_count !== false) {
			$xml->element('DataportCount', $dataport_count);
		}
		$xml->pop();
	} else {
		$BP->buildResult($xml, false, $errorMessage);
	}
} else {
	$Log->enterFunction("configure_ports", "root password", $securityLevel);
	$result = configure_ports($rootPassword, $securityLevel, $errorMessage);
	$Log->exitFunction("configure_ports", $result);
	if ($result === true) {
		$BP->buildResult($xml, true);
	} else {
		$BP->buildResult($xml, false, $errorMessage);
	}
}
echo($xml->getXml());


// function to shutdown and optionally restart system.  There must
// be an entry for apache for /sbin/shutdown (with PASSWORD) in
// /etc/sudoers.
//
function configure_ports($rootPassword, $securityLevel, &$msg) {
	$status = -1;
	$res = trim(shell_exec('echo $UID'));
	// we're not running as root
	if (!login_is_valid('root', $rootPassword)) {
		$msg = "Invalid root password detected.  A common mistake is to use the UI password instead of the root password of the system.  ";
		$msg .= "Please ensure that you are using the system root password.";
		return 1;
	}
	
	$commandStart = "sudo -u root -S /bin/bash ";
	$command = sprintf("%s %s", $commandStart, LCD_DIR);
	
	$exitCode = EXIT_LOW;
	switch ($securityLevel) {
		case SECURITY_NONE:
			$command .= LCD_NONE;
			$exitCode = EXIT_NONE;
			break;
		case SECURITY_LOW:
			$command .= LCD_LOW;
			$exitCode = EXIT_LOW;
			break;
		case SECURITY_MEDIUM:
			$command .= LCD_MEDIUM;
			$exitCode = EXIT_MEDIUM;
			break;	
		case SECURITY_HIGH:
			$command .= LCD_HIGH;
			$exitCode = EXIT_HIGH;
			break;		
	}
	global $Log;
	$Log->writeVariable($command);
	$handle = popen($command, 'w');
	fwrite($handle, "$rootPassword\n");
	$status = pclose($handle);
	$result = false;
	if ($status != $exitCode) {
		$msg = "The port configuration could not be changed to " . $securityLevel . ".";
	} else {
		$msg = "The port configuration was updated successfully to " . $securityLevel . ".";
		$result = true;
	}
	return $result;
}

/* checks for valid login credentials, returns 1 if valid, 0 otherwise
 *
 * @param $username - user to check
 * @param $password - password for this user
 * @return - 1 for valid login, 0 otherwise
 */
function login_is_valid($username, $password) {
	$passencoded = "'" . str_replace("'", "'\''", $password) . "'";
	$userencoded = "'" . str_replace("'", "'\''", $username) . "'";
	$cmd = "echo -e $passencoded | sudo -u $userencoded -S whoami 2>/dev/null";
	$res = trim(shell_exec($cmd));
	if ($res == $username) {
		return 1;
	} else {
		return 0;
	}
}

//
// This function returns the existing port status by looking at the
// LCD status file.
//
function get_port_status(&$msg)
{
	ob_start();
	$returnValue = false;
	$command = sprintf("/bin/cat %s%s 2>/dev/null", LCD_DIR, LCD_STATUS);
	$result = shell_exec($command);
	if (!is_null($result)) {
		$resultArray = explode('|', $result);
		if (count($resultArray) > 1) {
			$stringValue = $resultArray[1];
			$index = strpos($stringValue, ":");
			if ($index != -1) {
				$stringValue = substr($stringValue, $index + 2);
			}
			$returnValue = $stringValue;
		}
	} else {
		//$msg = 'Error determining port status';
		// ports have never been set; security is none.
		$returnValue = SECURITY_NONE;
	}
	return $returnValue;
	ob_end_clean();
}
?>