<?php
// defines BP, xml, action, cookie
require 'header.php';
define("FILE_SEPARATOR", ",");
define("CHAR_LIMIT", 8191);

// If replicated/grand client view, we are restoring replicated backups from the local system.  Otherwise, check for the sid.
$dpuID = (isset($_GET['sid']) && !$grandClientView) ? (int)$_GET['sid'] : $BP->get_local_system_id();

$restoreOptions = array();

switch ($action) {
	case "vault":
	case "files":
	case "synthesis":
			// restore a list of files from the given backup, vaulted backup, or synthesized view.
			$backupID = (int)$_GET['id'];
				
			$inclusionList = array();
			$char = 0;
			if (isset($_REQUEST['inclusion'])) {
				$inclusions = $_REQUEST['inclusion'];
				$inclusionNames = explode(FILE_SEPARATOR, $inclusions);
				for ($i = 0; $i < count($inclusionNames); $i++) {
					$inclusionNames[$i] = urldecode($inclusionNames[$i]);
					$char += strlen($inclusionNames[$i]);
				}
				$inclusionList = $inclusionNames;
			}
			$exclusionList = array();
			if (isset($_REQUEST['exclusion'])) {
				$exclusions = $_REQUEST['exclusion'];
				$exclusionNames = explode(FILE_SEPARATOR, $exclusions);
				for ($i = 0; $i < count($exclusionNames); $i++) {
					$exclusionNames[$i] = urldecode($exclusionNames[$i]);
				}
				$exclusionList = $exclusionNames;
			}
										
			$options = array ('directory' => 'dir',
							  'before_command' => 'bcmd',
							  'after_command' => 'acmd');
			$bOptions = array('flat' => 'flat',
							  'non_destructive' => 'nondestructive',
							  'newer' => 'newer',
							  'today' => 'today',
							  'unix' => 'unix');		
			$restoreOptions = buildOptions($restoreOptions, $options, $bOptions);
			$iOptions = array('client_id' => 'cid');
			$restoreOptions = addIntegerOptions($restoreOptions, $iOptions);
			// Only pass down verify if set.
			if (isset($_GET['verify'])) {
				$verify = $_GET['verify'];
				$restoreOptions = array_merge($restoreOptions, array("verify" => ($verify == "1") ? true : false));	
			}		
			//
			//  Based on the action, call the proper restore API.
			//
			if($char < CHAR_LIMIT){

				if ($action == "files") {			
					$result = $BP->restore_files($backupID, $inclusionList, $exclusionList, $restoreOptions, $dpuID);
				} else if ($action == "vault") {
					$result = $BP->restore_vaulted_files($backupID, $inclusionList, $exclusionList, $restoreOptions, $dpuID);
				} else {
					$backupGroup = $_GET['group'];
					$result = $BP->restore_synthesized_files($backupGroup, $backupID, $inclusionList, $exclusionList, $restoreOptions, $dpuID);
				}
				if ($result !== false) {
					$xml->push("root");
					$xml->element("JobID", $result);
					$xml->pop(); // root
				} else {
					$BP->buildResult($xml, false);
				}
			} else {
				$BP->buildResult($xml, false, "The combined path lengths of the files selected (" . $char . ") exceed the maximum allowed (". CHAR_LIMIT . ").  Please select an entire directory, or select fewer files to restore.");
			}
			echo($xml->getXml());
			break;
}

$BP->destroyCookie();
?>