<?php
// initialize variables before includes to all for simple URL.
if (!isset($_GET['auth'])) {
	$_REQUEST['auth'] = "1:";
}

// indicate to bp.php to bypass authentication using defaults
putenv("bypassCookie=true");

if (!isset($_GET['days'])) {
	$_GET['days'] = 1;
}
if (!isset($_GET['lvl'])) {
	$_REQUEST['lvl'] = 3;
}
// Writer used to build RSS-specific xml.
require 'rsswriter.php';

// defines BP, xml, action, cookie
require '../header.php';

// defines functions for URL parsing.
require $rootdir . 'bpl/urloptions.php';
//require $rootdir . 'bpl/basebackupstatus.php';

$http = 'http://';
$serverAddress = $_SERVER['SERVER_ADDR'];
$imageDir = $http . $serverAddress . '/recoveryconsole/help/images/';

$uri = $_SERVER['REQUEST_URI'];
$thisURL = $http . $serverAddress . $uri;

$imageGreen = $imageDir . 'status_s.swf';
$imageYellow = $imageDir . 'status_w.swf';
$imageRed = $imageDir . 'status_f.swf';

$action = isset($_GET['action']) ? $_GET['action'] : "rss";
$dpuID = isset($_GET['sid']) ? (int)$_GET['sid'] : $BP->get_local_system_id();

{			
	// Default to retrieve all backup types.
	$backupTypes = $GLOBAL_BACKUP_TYPES;
	
	$result_format = array();
	$attributes = getTimeArguments();
			
	// Override the default backup types for SQL and securesync reports.
	if ($action == 'sql') {
		$backupTypes = $GLOBAL_SQL_TYPES;
	} else if ($action == 'sync') {
		$backupTypes = $GLOBAL_SS_TYPES;
	}
	
	$result_format = array_merge($result_format, $attributes, array('type' => $backupTypes));
				
	//
	// get system and client list
	//
	$systems = $BP->get_system_list();
	$clients = $BP->get_client_list($dpuID);
	
	$rss = new rssWriter($xml);
	$rrcURL = $rss->getURL();
	
	$localName = $systems[$dpuID];
	$asset = $BP->get_asset_tag();
	$assetTag = ($asset !== false) ? " (" . $asset . ")" : "";
	
	$days = isset($_GET['days']) ? $_GET['days'] : "";
	
	$rss->openChannel("Unitrends Appliance " . $localName . $assetTag . " Backup Status", $rss->getURL(),
					  "Status of backups over the past " . $days . " day(s).", $rss->getImageURL());
	
	$originalFormat = $result_format;
	
	$result_format['system_id'] = $dpuID;
	// get statuses, then sort newest to oldest, and display.
	$backupStatusArray = $BP->get_backup_status($result_format);
	if ($backupStatusArray !== false && count($backupStatusArray) > 0) {
		usort($backupStatusArray, "compareDates");
		foreach ($backupStatusArray as $result) {
			$clientID = $result['client_id'];
			$clientName = $clients[$clientID];
			createRSSBaseBackupStatusXML($xml, $result, NULL,
									  $dpuID, $localName,
									  $clientID, $clientName);
		}							
	}
		
	$rss->closeChannel();
	$rss->finish();
	
	echo($xml->getXml());
}

//
// This function builds an expanded status which is a combination of values returned by
// bp_get_backup_status and bp_get_backup_info.
//
function createRSSBaseBackupStatusXML($xml, $backup, $deviceList, $dpuID, $dpuName, $clientID, $clientName)
{
	// convert timestamp to local time/day
	$day = date('m/d/Y', $backup['start_time']);
	$time = date(TIME_FORMAT_12HR, $backup['start_time']);
		
	$backupType	= getBackupTypeString($backup['type']);
			
	global $action;	
	global $imageGreen;
	global $imageYellow;
	global $imageRed;
	
	switch ($action) {
		case 'rss':
			$Tag = "item";
			break;
		case 'sync':
			$Tag = "SecureSyncStatus";
			break;
		default:
			$Tag = "Backup";
			break;
	}
	

	if (!isset($backup['id'])) {
		$backup['id'] = "N/A";
	}
	
	$attributes = array('Type' => $backupType,
						"Identification" => $backup['id'],
						"DPUName" => $dpuName,
						"ClientName" => $clientName);
	
	if ($action == 'rss') {
		if (isset($backup['complete'])) {
			$bComplete = true;
			if (array_key_exists('status', $backup)) {
				switch ($backup['status']) {
					case STATUS_SUCCESS:		$backupStatus = "Success";
												break;
					case STATUS_WARNING:		$backupStatus = "Warning";
												break;
					case STATUS_FAILURE:		$backupStatus = "Failure";
												break;
				}
			}
		} else {
			$bComplete = false;
		}
		
		// create the description.
		
		$s = 'Elapsed time: ' . $backup['elapsed_time'] . ' seconds<br/>';
		
		$s .= 'Complete? ' . ($bComplete ? 'Yes' : 'No') . '<br/>';
		
		if ($bComplete) {
			$s .= 'Size: ' . $backup['size'] . ' MB<br/>';
		}
		
		if (array_key_exists('app_name', $backup)) {
			$s .= 'Application: ' . $backup['app_name'] . '<br/>';
		}	
		if (array_key_exists('server_instance_name', $backup)) {
			$s .= 'Instance: ' . $backup['server_instance_name'] . '<br/>';
		} else if (isset($backup['sharepoint_guid'])) {
			$s .= 'Instance: ' . $backup['sharepoint_guid'];
		}
		if (array_key_exists('vm_name', $backup)) {
			$s .= 'Virtual Machine: ' . $backup['vm_name'] . '<br/>';
		} else if (array_key_exists('database_name', $backup)) {
			$s .= 'Database: ' . $backup['database_name'];
		} else if (isset($backup['oracle_sid'])) {
			$s .= 'Database: ' . $backup['oracle_sid'];
		}
	
		$attributes['title'] = "Client: " . $clientName . "; Type: " . $backupType . "; Status: ";
		$attributes['title'] .= ($bComplete) ? $backupStatus : "Active";
		$attributes['title'] .=  " (id:" . $backup['id'] . ")";
		$attributes['description'] = $s;
		$pubDate = date('D j M Y G:i:s T', $backup['start_time']);
		$attributes['pubDate'] = $pubDate;
		//$attributes['guid'] = "ID:" . $backup['id'] . ":ClientID:" . $backup['client_id'];
		
		global $rss;
		$attributes['guid'] = $rss->getURL() . "?ID=" . $backup['id'] . "&ClientID=" . $backup['client_id'];
		$rss->openItem($attributes);
	} else {
		$xml->push($Tag, $attributes);
	}
		
	if ($action == 'rss') {
		$rss->closeItem();
	} else {
		$xml->pop(); // Backup
	}
}

function getTimeArguments()
{	
	$attributes = array();

	$startTime = -1;
	$endTime = -1;
	
	$options = new Options();
	
	if (isset($_GET['arguments'])) {
		$options->parseCommandLine($_GET['arguments']);
		$startTime = $options->getStartTime();
		if ($startTime != -1) {
			$attributes = array('start_time' => $startTime);
		}
		$endTime = $options->getEndTime();
		if ($endTime != -1) {
			$attributes = array_merge($attributes, array('end_time' => $endTime));
		}
	} else if (isset($_GET['days'])) {		
		$days = $_GET['days'];	
		$endTime = time();
		// convert to start and end times (days * 24 hr/day * 60 min/hr * 60 sec/min)
		$startTime = $endTime - ($days * 24 * 60 * 60);
		// adjust the start time back to midnight of x days ago.
		$dayOffset = date('H:i:s', $startTime);
		$pieces = explode(':', $dayOffset);
		$hour = (int)$pieces[0];
		$minute = (int)$pieces[1];
		$sec = (int)$pieces[2];
		$startTime -= (($hour * 60 * 60) + ($minute * 60) + $sec);
		$attributes = array('start_time' => $startTime, 'end_time' => $endTime);
	}
	
	return $attributes;
}

//
// Function that compares the start dates of two function,
// sort DESCENDING order.
//
function compareDates($a, $b) {
	if ($a['start_time'] == $b['start_time']) {
		$result = 0;
	} else if ($a['start_time'] > $b['start_time']) {
		$result = -1;
	} else {
		$result = 1;
	}
	return $result;
}

$BP->destroyCookie();
?>
