<?php
// defines BP, xml, action, cookie
require 'header.php';

// general backup list operations.
require 'listsbase.php';
$ListBase = new ListBase();

// Detect the system ID on which to operate.
$dpuID = isset($_GET['sid']) ? (int)$_GET['sid'] : $BP->get_local_system_id();

switch ($action) {

	case "option":
	case "selection list":
			$scheduleList = $BP->get_schedule_list($dpuID);
			if ($scheduleList !== false) {
				if (!isset($_GET['id'])) {
					if ($action == "option") {
						$id = $ListBase->getID($BP, 'get_option_lists', $dpuID);
					} else {
						$id = $ListBase->getID($BP, 'get_selection_lists', $dpuID);
					}
				} else {
					$id = (int)$_GET['id'];
				}
				if ($id != -1) {
					$scheduleNames = searchForlistID($action, $id, $scheduleList, $dpuID);
					if (($scheduleNames !== false) && (count($scheduleNames) > 0)) {
						$xml->push('root');
						foreach ($scheduleNames as $name) {
							$xml->element('Schedule', $name);
						}
						$xml->pop();
					} else {
						// No schedules are referenced.  Pass true and no names back to the caller.
						$BP->buildResult($xml, true);
					}					
				} else {
					// The id of the list does not exist, so no references.  Pass true and no names back to the caller.
					$BP->buildResult($xml, true);
				}
			} else {
				$BP->buildResult($xml, false);
			}
			echo($xml->getXml());
			break;
					
	case "calendar":
			$scheduleList = $BP->get_schedule_list($dpuID);
			if ($scheduleList !== false) {
				if (!isset($_GET['id'])) {
					$id = $ListBase->getID($BP, 'get_calendar_list', $dpuID);
				} else {
					$id = (int)$_GET['id'];
				}
				if ($id != -1) {
					$scheduleNames = searchForCalendarID($id, $scheduleList, $dpuID);
					if (($scheduleNames !== false) && (count($scheduleNames) > 0)) {
						$xml->push('root');
						foreach ($scheduleNames as $name) {
							$xml->element('Schedule', $name);
						}
						$xml->pop();
					} else {
						// No schedules are referenced.  Pass true and no names back to the caller.
						$BP->buildResult($xml, true);
					}					
				} else {
					// The id of the list does not exist, so no references.  Pass true and no names back to the caller.
					$BP->buildResult($xml, true);
				}
			} else {
				$BP->buildResult($xml, false);
			}
			echo($xml->getXml());
			break;

}

//
// This function is passed a calendar ID and list of schedules and determines the
// names of schedules where this calendar is referenced.
//
// Returns: false - no schedules are referenced
//			OR - array of schedule names that use this calendar ID.
//
function searchForCalendarID($calendarID, $scheduleList, $dpuID)//:Boolean or list of names if found
{
	$bFound = false;
	global $BP;
	
	$scheduleNames = array();
	$i = 0;
	foreach ($scheduleList as $schedule) {
		$scheduleInfo = $BP->get_schedule_info($schedule['id'], $dpuID);
		if ($scheduleInfo !== false) {
			if (array_key_exists('calendar', $scheduleInfo) && ($scheduleInfo['calendar'] == $calendarID)) {
				$bFound = true;
				// Check first to see if name already in list; don't add again if so.
				if (!in_array($schedule['name'], $scheduleNames)) {
					$scheduleNames[$i++] = $schedule['name'];
				}
			}
		}
	}
	
	if ($bFound) {
		$bFound = $scheduleNames;
	}
	
	return $bFound;
}

//
// This function is passed a list (option, selection list) ID and list of schedules and determines the
// names of schedules where this list is referenced.
//
// Returns: false - no schedules are referenced
//			OR - array of schedule names that use this list ID.
//
function searchForListID($type, $listID, $scheduleList, $dpuID)//:Boolean or list of names if found
{
	$bFound = false;
	global $BP;
	
	$scheduleNames = array();
	$i = 0;
	foreach ($scheduleList as $schedule) {
		$scheduleInfo = $BP->get_schedule_info($schedule['id'], $dpuID);
		if ($scheduleInfo !== false) {
			if (array_key_exists('clients', $scheduleInfo)) {
				$clientArray = $scheduleInfo['clients'];
				if (count($clientArray) > 0) {
					foreach ($clientArray as $client) {
						if ($type == 'option') {
							$bInList = checkClientForID($client, $listID, 'options');
						} elseif ($type == 'selection list') {
							$bInList = checkClientForID($client, $listID, 'inclusions');
							if (!$bInList) {
								$bInList = checkClientForID($client, $listID, 'exclusions');
							}
						}
						if ($bInList) {
							$bFound = true;
							if (!in_array($schedule['name'], $scheduleNames)) {
								$scheduleNames[$i++] = $schedule['name'];
							}
						}
					}
				}
			}
		}
	}
	
	if ($bFound) {
		$bFound = $scheduleNames;
	}
	
	return $bFound;
}

//
// This function checks to see if the client array for the specified list type
// (inclusions, exclusions, options) contains the list ID.  If the list type
// is an array, it's a split so each array element is checked for the list ID.
//
// Returns - true if list ID found, false if not.
//
function checkClientForID($client, $listID, $type)//: Boolean
{
	$bFound = false;
					
	if (array_key_exists($type, $client)) {			
		$element = $client[$type];
		if (is_array($element)) {
			foreach ($element as $elementID) {
				if ($elementID == $listID) {
					$bFound = true;
				}
			}
		} else if ($element == $listID) {
			$bFound = true;
		}
	}
		
	return $bFound;
}
?>