<?php
// defines BP, xml, action, cookie
require 'header.php';

// converts xml string to client array
require 'xmlreader.php';

// include startup operations.
require 'startupfunctions.php';	

// include system information functions.
require 'systeminfo.php';

$dpuID = isset($_GET['sid']) ? (int)$_GET['sid'] : $BP->get_local_system_id();
$bCache = (isset($_GET['cache']) and ($_GET['cache'] === '1') )? true : false;
$grandClientView = isset($_GET['gcv']) && ($_GET['gcv'] === '1') ? true : false;

// Get xml cache file - path in master.ini  -   /var/www/html/recoveryconsole/cache/UI-Startup.xml
$startupCachePath = $BP->get_ini_value('CMC', 'StartupCacheFile', $dpuID);
$masterUseCache = $BP->get_ini_value('CMC', 'LoginCache', $dpuID);

// create temporary cache file
$tmpcache = $startupCachePath . ".new";

$useCache = true;
if (file_exists($startupCachePath)) {
    if ($bCache === false) {
        $useCache = false;
    }

    // check if using replication view - use cache if user has explicitly click to reload
    if ($grandClientView === true && $bCache === false) {
        $useCache = false;
    }

    // check master.ini cache setting
    if ($masterUseCache === "false") {
        $useCache = false;
    }

    // check file size, if zero do not use cache
    if (filesize($startupCachePath) < 300) {
        $useCache = false;
    }
} else {
    $useCache = false;
}

if ($useCache === true) {
    // Used cached xml file
    echo(file_get_contents($startupCachePath));
} else {
    $xml->push('root');
// Build a systems information base, used for building the customer and system XML lists.
    $systemsArray = buildSystemsArray($BP);

// Create the list of customers and systems.
    $bValid = buildCustomerList($BP, $xml, false, $systemsArray);
    if ($bValid == true) {
        $bValid = buildSystemList($BP, $xml, false, $systemsArray);
        if ($bValid == true) {
            // Check to see if the default device is D2D or not (crucial for backups).
            $d2dDefault = ($BP->default_device_is_d2d($dpuID)) ? "1" : "0";
            $xml->element("DefaultD2D", $d2dDefault);

            $ApplianceType = "unknown";
            $LicensedCapacity = "unknown";
            $Clients = "unknown";
            $nRC = $nVC = 0;
            $BP->bypass_cookie(2);
            $licenseInfo = $BP->get_license_info();
            if ($licenseInfo !== false) {
                createLicenseXML($BP, $xml, $licenseInfo, $dpuID);

                if (array_key_exists('feature_string', $licenseInfo)) {
                    parseLicenseString($licenseInfo['feature_string'], $ApplianceType, $LicensedCapacity,
                        $Clients, $nRC, $nVC);
                } else {
                    if (array_key_exists('license_type', $licenseInfo) && $licenseInfo['license_type'] == "DEMO") {
                        $nRC = $nVC = "Demo";
                    }
                }

            } else {
                $message = "Error retrieving license information.";
                $message = $BP->getError() . ":" . $message;
                $Log->writeError($message, true);
                $nRC = $nVC = "Error";
            }

            // Check identity
            $nvp = $BP->get_nvp_list('RRC', 'configuration');
            if ($nvp !== false && count($nvp) > 0) {
                $xml->element('Identity', $nvp['Identity']);
            }

            // Check platform type
            $Appliance = UNKNOWN;
            $Version = UNKNOWN;
            $Kernel = UNKNOWN;
            $OS = UNKNOWN;
            $InstallDate = UNKNOWN;
            $commandName = SYSTEM_INFORMATION;
            $commandOutput = $BP->run_command($commandName, "");
            if ($commandOutput !== false) {
                parseDPUCommandOutput($commandOutput, $Appliance, $Version, $Kernel, $InstallDate, $OS);
            } else {
                $message = "Error running System information command for system info.";
                $message = $BP->getError() . ":" . $message;
                $Log->writeError($message, true);
            }
            $xml->element('Appliance', $Appliance);
        }

        $xml->pop(); // root
        $output = $xml->getXml();
        file_put_contents($tmpcache, $output);
        rename($tmpcache, $startupCachePath);
        echo($xml->getXml());
    }
}

$BP->destroyCookie();
?>