<?php
// defines BP, xml, action, cookie
require 'header.php';

// set of functions for user management
require 'userfunctions.php';

// set of functions used at initial login, including building a system list.
require 'startupfunctions.php';

// create empty systemInfo array (for update vs add).
$systemInfo = array();
$stringError = NULL;

// add vs update
$bUpdate = false;

switch ($action) {
	case "list":
			buildSystemList($BP, $xml, true, NULL, true);
			echo($xml->getXml());
			break;

	case "summary":
			buildSystemList($BP, $xml, true, NULL, false);
			echo($xml->getXml());
			break;
		
	case "change":			
	case "update":
			$bUpdate = true;
			// if updating, specify id or name.				
			if (isset($_GET['id'])) {
				$systemID = (int)$_GET['id'];
				$systemInfo = $BP->get_system_info($systemID);
				if ($systemInfo === false) {
					$BP->buildResult($xml, false);
					echo($xml->getXml());
					break;
				}
			}
			// if systemInfo set, fall through to add.
		
	case "add":	
			// Get the system definition from arguments.
			if (isset($_GET['name'])) {
				$name = $_GET['name'];
				$systemInfo['name'] = $name;
			}
			if (isset($_GET['host'])) {
				$host = $_GET['host'];
				$systemInfo['host'] = $host;
			}	
			if (isset($_GET['location_id'])) {
				$location_id = (int)$_GET['location_id'];
				$systemInfo = array_merge($systemInfo, array("location_id" => $location_id));	
				
			} else if (isset($_GET['customer_name']) && isset($_GET['location_name'])) {
				// surmise the locationID from customer/location names.
				$customerName = $_GET['customer_name'];
				$locationName = $_GET['location_name'];
				$locationID = getLocationIDFromName($BP, $locationName, $customerName);
				if ($locationID != -1) {
					$systemInfo = array_merge($systemInfo, array("location_id" => $locationID));
				} else {
					$stringError = sprintf("systems.php: location '%s' is not valid for customer '%s'",
										   $locationName, $customerName);
				}
			}
			
			//
			// if $host is set, user wants entry added to hosts file.
			//
			if (is_null($stringError)) {
				if (isset($_GET['name']) || isset($_GET['id'])) {
					if (isset($_GET['dev_id'])) {
						$deviceID = (int)$_GET['dev_id'];
						$result = $BP->set_replication_device($systemInfo['id'], $deviceID);
						if ($result === false) {
							global $Log;
							$err = "error setting replication device to " . $deviceID;
							$Log->writeError($err, true);
						}
					}
					$BP->buildResult($xml, $BP->save_system_info($systemInfo));
				} else {
					$BP->buildResult($xml, false, "systems.php: improper argument format; System name or ID must be specified.");
				}
			} else {
				$BP->buildResult($xml, false, $stringError);
			}
			echo($xml->getXml());
			break;
					
	case "delete":
			// If deleting, provide id.	
			if (isset($_GET['id'])) {
				$id = (int)$_GET['id'];
				$BP->buildResult($xml, $BP->remove_system($id));
			} else {
				$BP->buildResult($xml, false, "Improper argument format; ID must be specified when deleting a system.");
			}
			echo($xml->getXml());
			break;
			
	case "virtual":
			// See if virtual appliance.
			if (isset($_GET['id'])) {
				$id = (int)$_GET['id'];
				$result = $BP->is_virtual($id);
				if ($result !== -1) {
					$Virtual = $result == true ? "1" : "0";
					$xml->push('root');
					$xml->element('Virtual', $Virtual);
					$xml->pop();
				} else {
					$BP->buildResult($xml, false);
				}
			} else {
				$BP->buildResult($xml, false, "Improper argument format; ID must be specified when checking if virtual.");
			}
			echo($xml->getXml());
			break;
			
	case "demo":
			// See if demo virtual appliance.
			if (isset($_GET['id'])) {
				$id = (int)$_GET['id'];
				$result = $BP->is_demo($id);
				if ($result !== -1) {
					$Demo = $result == true ? "1" : "0";
					$xml->push('root');
					$xml->element('Demo', $Demo);
					$xml->pop();
				} else {
					$BP->buildResult($xml, false);
				}
			} else {
				$BP->buildResult($xml, false, "Improper argument format; ID must be specified when checking if demo.");
			}
			echo($xml->getXml());
			break;
			

}

$BP->destroyCookie();
?>
