<?php
// converts xml string to virtual client information
require 'vclientxml.php';

// utility for supported api
require 'wir_supported_util.php';

// defines BP, xml, action, cookie
require '../header.php';

// general library functions
require $rootdir . 'bpl/library.php';

$lib = new Library();

// Defines for VF reservations
define("VF_UNIQUE_ID", 1);

//
// Standard URL variables for system, client, virtual client IDs.
//
$dpuID = isset($_GET['sid']) ? (int)$_GET['sid'] : $BP->get_local_system_id();
$cid = isset($_GET['cid']) ? (int)$_GET['cid'] : -1;
$vid = isset($_GET['vid']) ? (int)$_GET['vid'] : -1;
$gcid = isset($_GET['gcid']) ? (int)$_GET['gcid'] : -1;
$appID = isset($_GET['appid']) ? (int)$_GET['appid'] : -1;

// Initialize variables to be used in save.
$clientInfo = array();
$bValid = true;


switch ($action) {

	case "list":
		$result = $BP->virtual_clients_supported($dpuID);
		if ($result !== -1) {
			$xml->push("root");
			createWIRSupportedXML($xml, $result);
			if ($result == true) {
				$clients = $BP->get_virtual_client_list($dpuID);
				if ($clients !== false) {
					foreach ($clients as $client) {
						$attributes = array('ID' => $client['virtual_id'],
											'ClientID' => $client['real_client_id'],
											'Name' => $client['client_name']);
						if (isset($client['grandclient'])) {
							$attributes['GrandClient'] = $client['grandclient'];
						}
						if (isset($client['system_id'])) {
							$attributes['SystemID'] = $client['system_id'];
						}
						if (isset($client['system_name'])) {
							$attributes['SystemName'] = $client['system_name'];
						} 
						
						$xml->push('VClient', $attributes);
						if (isset($client['current_state'])) {
							$xml->element('CurrentState', $client['current_state']);
						}
						if (isset($client['pending_state'])) {
							$xml->element('PendingState', $client['pending_state']);
						}
						if (isset($client['valid'])) {
							$xml->element('Valid', $client['valid'] == true ? "1" : "0");
						}
						if (isset($client['disabled'])) {
							$xml->element('Disabled', $client['disabled'] == true ? "1" : "0");
						}
						if (isset($client['live_time'])) {
							$xml->element('LiveTime', $client['live_time']);
						}
						
						// Get Processors and Memory for summary page.
						$clientDetail = $BP->get_virtual_client($client['virtual_id'], $dpuID);
						if (isset($clientDetail['processors'])) {
							$xml->element('Processors', $clientDetail['processors']);
						}
						if (isset($clientDetail['memory'])) {
							$xml->element('Memory', $clientDetail['memory']);
						}
									
						// For virtual client on appliance
						if (isset($client['port'])) {
							// for virtual client on appliance
							$xml->element('Port', $client['port']);
							// Get VF space
							$vfSpace = $BP->get_vf_space_in_use($client['virtual_id'], VF_UNIQUE_ID, $dpuID);
							if ($vfSpace !== false) {
								$xml->element('Reservation', $vfSpace);
							} else {
								$xml->element('ReservationError', $BP->getError());
							}
						}
						
						// support for UEB WIR
						if (isset($client['ip_addr'])) {
							// only for external hypervisor
							$xml->element('IPAddress', $client['ip_addr']);
						}
						if (isset($client['vm_guid'])) {
							// only for external hypervisor
							$xml->element('VMGuid', $client['vm_guid']);
						}
						if (isset($clientDetail['hypervisor_type'])) {
							$xml->element('HypervisorType', $clientDetail['hypervisor_type']);
						}
						if (isset($clientDetail['vm_name'])) {
							// only for external hypervisors
							$xml->element('VMName', $clientDetail['vm_name']);
						}
						if (isset($clientDetail['hypervisor_name'])) {
							// only for external hypervisors
							$xml->element('HypervisorName', $clientDetail['hypervisor_name']);
						}
						
						$xml->pop(); // client
					}
				} else {
					$bValid = false;
				}
			}
			$xml->pop(); //root
			if (!$bValid) {
				$xml->clear(false);
				$BP->buildResult($xml, false);
			}
		} else {
			$BP->buildResult($xml, false);
		}
		echo($xml->getXml());
		break;
		
	case "all":
		$candidates = $BP->get_virtual_candidates($dpuID);
		if ($candidates !== false) {
			$xml->push('root');
			foreach ($candidates as $candidate) {
				$clientInfo = $BP->get_client_info($candidate['client_id']);
				
				$attributes = array('Name' => $candidate['client_name'],
									'ClientID' => $candidate['client_id'],
									'ClientOS' => $candidate['os_id']);
									//$clientInfo['os_type']);
									 
				if (isset($candidate['virtual_id'])) {
					$attributes['ID'] = $candidate['virtual_id'];
				}
				if (isset($candidate['backup_id'])) {
					$attributes['BackupID'] = $candidate['backup_id'];
				}
				if (isset($candidate['grandclient'])) {
					$attributes['GrandClient'] = $candidate['grandclient'] == true ? "1" : "0";
				}
				if (isset($candidate['system_id'])) {
					$attributes['SystemID'] = $candidate['system_id'];
				}
				if (isset($candidate['system_name'])){
					$attributes['SystemName'] = $candidate['system_name'];
				} 				
				
				$xml->emptyElement('Client', $attributes);
			}
			$xml->pop(); // root
		} else {
			$BP->buildResult($xml, false);
		}
		echo($xml->getXml());
		break;
		
	case "info":
		$client = $BP->get_virtual_client($vid, $dpuID);
		if ($client !== false) {
			$xml->push('root');
			if (isset($client['real_client_id'])) {
				$clientID = $client['real_client_id'];
				$clientInfo = $BP->get_client_info($clientID, $dpuID);
				if ($clientInfo !== false) {
					$clientName = $clientInfo['name'];
					$clientOS = $clientInfo['os_type'];	//11/14/13 - bug 18197 
				}
			} else {
				$clientID = -1;
				$clientName = 'dummy';
			}
			$attributes = array('ID' => $vid,
								'ClientID' => $clientID,
								'Name' => $clientName,
								'OSType' => $clientOS);
			$xml->push('VClient', $attributes);
			if (isset($client['port'])) {
				$xml->element('Port', $client['port']);
			}
			if (isset($client['processors'])) {
				$xml->element('Processors', $client['processors']);
			}
			if (isset($client['memory'])) {
				$xml->element('Memory', $client['memory']);
			}
			if (isset($client['current_state'])) {
				$xml->element('CurrentState', $client['current_state']);
			}
			if (isset($client['pending_state'])) {
				$xml->element('PendingState', $client['pending_state']);
			}
			if (isset($client['valid'])) {
				$xml->element('Valid', $client['valid'] == true ? "1" : "0");
			}
			if (isset($client['disabled'])) {
				$xml->element('Disabled', $client['disabled'] == true ? "1" : "0");
			}
			if (isset($client['audit_verify'])) {
				$xml->element('AuditVerify', $client['audit_verify'] == true ? "1" : "0");
			}
			if (count($client['disks']) > 0) {
				$diskCount = (count($client['disks']));  //11/14/13 - bug 18197 
				
				$disks = $client['disks'];
				$i = 0;
				$sep = "";
				$s = "";
				foreach ($disks as $disk) {
					$s .= $sep . $disk;
					$sep = ",";
				}
				$xml->element('Disks', $s);
				$xml->element('DiskCount', $diskCount);
			}
			// Get the boot disk value if set (it should be); 0 (for now) if not set.
			$bootDisk = isset($client['boot_disk']) ? $client['boot_disk'] : 0;
			$xml->element('Boot', $bootDisk);
			if (count($client['incl_vols']) > 0) {
				$volumes = $client['incl_vols'];
				$i = 0;
				foreach ($volumes as $volume) {
					$attributes = array('Filename' => $volume, 'id' => $i, 'Name' => $volume, 'View' => $volume);
					$xml->emptyElement('Volume', $attributes);
					$i++;
				}
			}
			if (isset($client['excl_vols'])) {
				$volumes = $client['excl_vols'];
				foreach ($volumes as $volume) {
					$attributes = array('Name' => $volume);
					$xml->emptyElement('Exclude', $attributes);
				}
			}
			
			// support for UEB WIR
			if (isset($client['hypervisor_type'])) {
				$xml->element('HypervisorType', $client['hypervisor_type']);
			}
			if (isset($client['vm_name'])) {
				// only for external hypervisors
				$xml->element('VMName', $client['vm_name']);
			}
			if (isset($client['hypervisor_name'])) {
				// only for external hypervisors
				$xml->element('HypervisorName', $client['hypervisor_name']);
			}
			
			$xml->pop(); // client
			$xml->pop(); // root
		} else {
			$BP->buildResult($xml, false);
		}
		echo($xml->getXml());
		break;
						
	case "update":	
		// fall through to add.
	
	case "add":	
		// Build the client profile.
		if (isset($_REQUEST['client'])) {
			$clientXML = $_REQUEST['client'];
			$clientInfo = xmlToClient($clientXML, $lib);
		}
		$result = $BP->save_virtual_client($clientInfo, $dpuID);
		$BP->buildResult($xml, $result);
		echo($xml->getXml());	
		break;
					
	case "delete":
		$deleteFromHypervisor = isset($_GET['deletefromhypervisor']) ? (int)$_GET['deletefromhypervisor'] : 1;
		// see if the client ID is provided
		$BP->buildResult($xml, $BP->delete_virtual_client($vid, $deleteFromHypervisor, $dpuID));
		echo($xml->getXml());
		break;

	case "state":
		$state = $BP->get_virtual_client_state($vid, $dpuID);
		if ($state !== false) {
			$xml->push('State');
			if (isset($state['current_state'])) {
				$xml->element('CurrentState', $state['current_state']);
			}
			if (isset($state['pending_state'])) {
				$xml->element('PendingState', $state['pending_state']);
			}
			$xml->pop();
		} else {
			$BP->buildResult($xml, false);
		}
		echo($xml->getXml());
		break;
		
		// Operations a user can perform on a virtual client.
	case "run":
		$bStart = isset($_GET['flag']) ? true : false;
		$requireNetwork = isset($_REQUEST['requirenetwork']) ? ($_REQUEST['requirenetwork'] == 1) : true;
		$bValid = true;
		if ($bStart == true && $requireNetwork == true) {
			// If entering live mode, check to see if a network bridge has been created first, and error out if not.
			$virtualBridge = $BP->get_virtual_bridge($dpuID);
			if ($virtualBridge === false) {
				$bValid = false;
			} else if (is_array($virtualBridge) && $virtualBridge[0] == "") {
				$bValid = false;
			} else if (is_string($virtualBridge) && $virtualBridge == "") {
				$bValid = false;
			}
			if (!$bValid) {
				$errorString = "No network bridge is available for the virtual failover clients.  ";
				$errorString .= "This must be set up in Settings > Instant Recovery > Network Bridge.";
				$BP->buildResult($xml, false, $errorString);
				$bValid = false;
			}
		}
		if ($bValid) {
			$BP->buildResult($xml, $BP->run_virtual_client($vid, $bStart));
		}
		echo($xml->getXml());
		break;
		
	case "audit":
		$bStart = isset($_GET['flag']) ? true : false;
		$BP->buildResult($xml, $BP->audit_virtual_client($vid, $bStart));
		echo($xml->getXml());
		break;
		
	case "disable":
		$bDisable = isset($_GET['flag']) ? true : false;
		$BP->buildResult($xml, $BP->disable_virtual_restores($vid, $bDisable, $dpuID));
		echo($xml->getXml());
		break;
		
	case "support":
		$result = $BP->virtual_clients_supported($dpuID);
		if ($result !== -1) {
			$xml->push('root');
			createWIRSupportedXML($xml, $result);
			$xml->pop();
		} else {
			$BP->buildResult($xml, false);
		}
		echo($xml->getXml());
		break;
		
		
	case "backlog":
		$result = $BP->get_last_virtual_restore($vid, $dpuID);
		if ($result !== false) {
			$xml->push('root');
			if (count($result) > 0) {
				$xml->push('Last');
				foreach ($result as $backup) {
					displayBackupItem($BP, $xml, $backup, $dpuID);
				}
				$xml->pop(); // Last
			}
			$result = $BP->get_virtual_restore_backlog($vid, $dpuID);
			if ($result !== false) {
				$xml->push('Backlog');
				foreach ($result as $backup) {
					displayBackupItem($BP, $xml, $backup, $dpuID);
				}
				$xml->pop(); // Backlog
			}
			$xml->pop();
		} else {
			$BP->buildResult($xml, false);
		}
		echo($xml->getXml());
		break;
		
		case "gclient_info":
			$result = $BP->get_client_info($gcid, $dpuID);
			if ( $result !== false ) {
				$xml->push('root');
				if (isset($result['applications'])){
					$appsarray = $result['applications'];
					foreach ($appsarray as $id => $application) {
					$xml->push('Application', array("Identification" => $id,
													"Name" => $application['name'],
													"Type" => $application['type']));
					$xml->pop(); // Application
					}
				}
				$xml->pop(); //root
			}
			echo($xml->getXml());
			break;
			
		case "gclient_exchange_info":
			$result = $BP->get_grandclient_exchange_info($gcid, $dpuID);
			if ( $result !== false ) {
				$xml->push("root");
				foreach ($result as $item) {
					$xml->push('Database', array("Identification" => $item['instance_id'],
												 "Name" => $item['name']));
					if (isset($item['wvf'])) {
						$xml->element('WVF', $item['wvf'] ? '1' : '0');	 
					}
												 
					$xml->pop(); // Database
				}
			$xml->pop(); //root	
			}
			echo($xml->getXml());
			break;
			
		case "gclient_sql_info":
			$result = $BP->get_grandclient_sql_info($gcid, $appID);
			if ( $result !== false ) {
				$xml->push("root");
				foreach ($result as $item) {
					$pieces = explode('\\', $item['instance']); 
					$xml->push('SQL', array("Identification" => $item['instance_id'],
											 "Instance" => $item['instance'],
											 "Database" => $item['database']));
											 
					if (isset($item['wvf'])) {
						$xml->element('WVF', $item['wvf'] ? '1' : '0');	 
					}
					
					$systemDB = $BP->is_sql_system_db($item['instance_id']);
                    $xml->element('SystemDB', $systemDB == true ? "1" : "0");
												 
					$xml->pop(); // Database
				}
			$xml->pop(); //root	
			}
			echo($xml->getXml());
			break;
			
			
			
	}

//
// Creates an XML item for backups restored to a virtual client.
//
function displayBackupItem($BP, $xml, $backup, $dpuID) {

	// convert timestamp to local time/day
	$day = date('m/d/Y', $backup['start_time']);
	$time = date(TIME_FORMAT_12HR, $backup['start_time']);
	
	// Check to see if type is set, because if the backup is already purged, it will not be.
	if (isset($backup['type'])) {
		$backupType	= getBackupTypeString($backup['type']);
	} else {
		$backupType = "unknown";
	}

	$xml->push('Backup', array('Type' => $backupType, "Identification" => $backup['id'], "ClientName" => $backup['cname']));
	$xml->element('Date', $day);
	$xml->element('Time', $time);
	
	// Check to see if elapsed_time and size are set, because if the backup is already purged, they will not be.	
	if (isset($backup['elapsed_time'])) {
		$xml->element('ElapsedTime', $backup['elapsed_time']);
	}
	if (isset($backup['size'])) {
		$xml->element('Size', $backup['size']);
	}
	
	//
	// For applications, return the instance ID and construct the name.
	//
	$xml->element("InstanceID", $backup['instance_id']);
	$xml->element("Instance", $backup['instance_name']);

	//
	// For v-clients grandclient, return, system ID, and system name
	//	
	if (isset($backup['grandclient'])) {
		$xml->element('GrandClient', $backup['grandclient'] == true ? '1' : '0');
	}
	if (isset($backup['system_id'])) {
		$xml->element('SystemID', $backup['system_id']);
	}
	if (isset($backup['system_name'])) {
		$xml->element('SystemName', $backup['system_name']);
	}
	
	// If the backup has file count, note this.
	// if type is 'verify', show "N/A" rather than 0
	if (isset($backup['files'])) {
		if($backup['type'] == 'verify'){
			$xml->element('Files', "N/A");
		}else{
			$xml->element('Files', $backup['files']);
		}
	}
	
	// See if backup is currently being restored (for backlog API).
	if (isset($backup['currently_running'])) {
		$xml->element('Running', $backup['currently_running'] == true ? '1' : '0');
	}
	$xml->pop();
}

$BP->destroyCookie();
?>