<?php
// defines BP, xml, action, cookie
require 'header.php';
define("FILE_SEPARATOR", ",");
define("UNITRENDS", 'unitrends-rr');

$dpuID = isset($_GET['sid']) ? (int)$_GET['sid'] : $BP->get_local_system_id();

// initialize check Result for eligibility check if unitrends package is in the update list.
$preCheck = "None";

switch ($action) {

	case "list":
			$updates = $BP->get_update_list($dpuID);
			if ($updates !== false) {
				$xml->push("root");
				foreach ($updates as $update) {
					$name = $update['name'];
					$version = isset($update['version']) ? $update['version'] : 'unknown';
					// See if the Unitrends package is in the list.  If so, run pre-check.
					if ($name == UNITRENDS) {
						$checkStatus = $BP->precheck_install($version, $dpuID);
						if ($checkStatus !== -1) {
							if ($checkStatus == true) {
								$preCheck = "Yes";
							} else {
								$preCheck = "No:" . $BP->getError();
							}
						} else {
							$preCheck = "Error:" . $BP->getError();
						}
					}
					$xml->push("Update", array("Name" => $name));
					$xml->element("Version", $version);
					$xml->pop(); // update
				}
				// put the checkresult last
				$xml->element("PreCheck", $preCheck);
				$xml->pop(); //root
			} else {
				$BP->buildResult($xml, false);
			}
			echo($xml->getXml());
			break;
	
	case "detail":
			// if detail, specify package package name list of items to get detail.			
			if (isset($_REQUEST['names'])) {
				$packageList = buildPackageList($_REQUEST['names']);
			} else {
				$BP->buildResult($xml, false, "updates: must specify names to see update package details.");
				echo($xml->getXml());
				break;
			}
			$packageInfoArray = $BP->get_update_info($packageList, $dpuID);
			if ($packageInfoArray !== false) {
				displayPackageInfo($xml, $packageInfoArray);
			} else {
				$BP->buildResult($xml, false);
			}
			echo($xml->getXml());
			break;
					
	case "update":
			// if updating, specify package name list of items to install.			
			if (isset($_REQUEST['names'])) {
				$packageList = buildPackageList($_REQUEST['names']);
			} else {
				$BP->buildResult($xml, false, "updates: must specify names of packages to be installed.");
				echo($xml->getXml());
				break;
			}
			$returnArray = $BP->install_updates($packageList, $dpuID);
			if ($returnArray !== false) {
				//
				// The install command did not fail, but the return may not be reporting success.  If not,
				// it could be because the package was installed earlier by dependency (when we call updates
				// individually).  Only check if we are installing packages one at-a-time (list count of 1).
				//
				if ((count($packageList) == 1) && packageNotUpdated($returnArray)) {
					// Go get the list of updates, then see if any of the names on our list are still
					// in the available updates.  If they are still in the list, then the package install
					// truly failed.  If the package name (or names) is not in the list, it was already installed
					$updateList = $BP->get_update_list($dpuID);
					if ($updateList !== false) {
						$bAlreadyUpdated = true;
						// Get the package name, the first and only item in the package list, and see if
						// it is on the available list or already updated due to dependency.
						$packageName = $packageList[0];
						foreach ($updateList as $update) {
							if ($update['name'] == $packageName) {
								$bAlreadyUpdated = false;
								break;
							}
						}
						// If package no longer available, it has already been updated, so this is
						// really successful from the RRC-perspective.  Alter the return array to report success.
						if ($bAlreadyUpdated) {
							$returnArray['success'] = true;
							$commandOutput = "'" . $packageName . "' was already updated and is at the latest version.";
							$returnArray['output'] = array($commandOutput);
						}
					} else {
						global $Log;
						$Log->writeError('Error getting update list.', true);
						// even if the list failed, we could be okay.  Examine the returnArray further
						// to see if already updated.
						$packageName = $packageList[0];
						if (alreadyInstalled($returnArray)) {
							$returnArray['success'] = true;
							$commandOutput = "'" . $packageName . "' was already updated and is at the latest version.";
							$returnArray['output'] = array($commandOutput);
						}
					}
				}
				displayInstallOutput($xml, $returnArray);
			} else {
				$BP->buildResult($xml, false);
			}
			echo($xml->getXml());
			break;
			
	case "history":
			// retrieve update history string.
			$history = $BP->show_update_history($dpuID);
			if ($history !== false) {
				$xml->push("root");
				$xml->push("History");
				$xml->cData($history);
				$xml->pop(); // History
				$xml->pop(); //root
			} else {
				$BP->buildResult($xml, false);
			}
			echo($xml->getXml());
			break;
}

function buildPackageList($stringNames)
{
	$packageList = array();
	
	// package names will be in the form <name1>,<name2>,<name3>...	
	$stringNames = trim($stringNames, FILE_SEPARATOR);
	$names = explode(FILE_SEPARATOR, $stringNames);	
	for ($i = 0; $i < count($names); $i++) {
		$packageList[$i] = urldecode($names[$i]);
	}
	
	return $packageList;
}

function displayInstallOutput($xml, $returnArray)
{
	$xml->push('root');
	
	$outputString = "";
	if (array_key_exists('output', $returnArray)) {
		$commandOutput = $returnArray['output'];
		foreach ($commandOutput as $commandOneOutput) {
			$outputString .= $commandOneOutput;
			$outputString .= '<br/>';
		}
	}
	
	$packageOutput = "Install Output";
	$xml->push("Command", array("Name" => $packageOutput));
	$xml->element("Success",  $returnArray['success'] == true ? "1" : "0");
	$xml->push("Output");
	$xml->cData($outputString);
	$xml->pop(); // Output
	$xml->pop(); // Command
	$xml->pop('Root');
}

function displayPackageInfo($xml, $packageInfoArray)
{
	$xml->push("root");
	foreach ($packageInfoArray as $update) {
		$xml->push("Update", array("Name" => $update['name']));
		if (array_key_exists('version', $update))
			$xml->element("Version", $update['version']);
		if (array_key_exists('size', $update))
			$xml->element("Size", $update['size']);
		if (array_key_exists('group', $update))
			$xml->element("Group", $update['group']);
		if (array_key_exists('repo', $update))
			$xml->element("Repository", $update['repo']);
		if (array_key_exists('summary', $update))
			$xml->element("Summary", $update['summary']);
		if (array_key_exists('description', $update))
			$xml->element("Description", $update['description']);
		$xml->pop(); // update
	}
	$xml->pop(); //root
}

function packageNotUpdated($returnArray) {
	
	$bReturn = false;
	
	if ($returnArray['success'] == false) {
			$outputArray = $returnArray['output'];
			foreach ($outputArray as $outputString) {
					if (strstr($outputString, 'was not upgraded')) {
						$bReturn = true;
						break;
					}
			}
	}
	
	return $bReturn;
}

function alreadyInstalled($returnArray) {
	
	$bReturn = false;
	
	if ($returnArray['success'] == false) {
			$outputArray = $returnArray['output'];
			foreach ($outputArray as $outputString) {
					if (strstr($outputString, 'already installed and latest') ||
					    strstr($outputString, 'was not upgraded (current version')) {
						$bReturn = true;
						break;
					}
			}
	}
	
	return $bReturn;
}

$BP->destroyCookie();
?>