<?php
// defines BP, xml, action, cookie
require 'header.php';

// defines functions for master.ini processing
require('baseini.php');

// parameters passed to all API's
$dpuID = isset($_GET['sid']) ? (int)$_GET['sid'] : $BP->get_local_system_id();
//$syncType = isset($_GET['synctype']) ? $_GET['synctype'] : "SecureSync";

switch ($action) {
	case "list":
		$result = $BP->get_securesync_config($dpuID);
		if ($result !== false) {
			$xml->push('root');
			buildVaultingProcessXML($xml, $result);
			buildVaultConnectionXML($xml, $BP, "CMC");
			$bIsSupported = $BP->is_appconfig_supported($dpuID);
			$xml->element('ItemVaulting', $bIsSupported ? '1' : '0');
			$xml->pop();
		} else {
			$BP->buildResult($xml, $result);
		}
		echo($xml->getXml());
		break;
						
	case "update":
		$settings = array();
		$options = array ('TransportType' => 'transport',
						  //'SyncTo' => 'to',
						  //'TemporarySpaceLocation' => 'temp',
						  //'BlockOutPeriods' => 'block',
						  'SyncReportMailTo' => 'mail',
						  'SyncReportTime' => 'time',
						  'TransportType' => 'transport',
						  'LocalDirToSync' => 'dir',
						  'ExchangeDirToSync' => 'edir',
						  'VaultName' => 'vault');
						  
		$bOptions = array('SyncBareMetals' => 'bm',
						  'SyncSQLBackups' => 'sql',
						  'EnableSyncLocalDir' => 'sdir',
						  'EnableSyncExchange' => 'sedir',
						  'SyncCopyOnly' => 'cp');
						  	
		$settings = buildOptions($settings, $options, $bOptions);
		$iOptions = array('CheckIntervalSeconds' => 'ck',
						  'MaxDeltaGBs' => 'gb',
						  'SyncRetry' => 'try');
		$settings = addIntegerOptions($settings, $iOptions);
		
		// Block-out could be very long, pass via POST so need to decode the string.
		if (isset($_REQUEST['block'])) {
			$settings['BlockOutPeriods'] = urldecode($_REQUEST['block']);
		}
			
		$result = $BP->save_securesync_config($settings, $dpuID);
		// If no error, also update master.ini with connection settings.
		if ($result !== false) {
			$result = saveIniValues($BP, $dpuID);
		}
		$BP->buildResult($xml, $result);
		echo($xml->getXml());
		break;
					
	case "enable":
		$BP->buildResult($xml, $BP->enable_securesync(true, $dpuID));
		echo($xml->getXml());
		break;
		
	case "disable":
		$BP->buildResult($xml, $BP->enable_securesync(false, $dpuID));
		echo($xml->getXml());
		break;
		
	case "stop":
		// Disable future vaulting and stop current vaulting by restarting securesync.
		$result = $BP->enable_securesync(false, $dpuID);
		if ($result !== false) {
			$BP->buildResult($xml, $BP->restart_securesync($dpuID));
		} else {
			$BP->buildResult($xml, false);
		}
		echo($xml->getXml());
		break;
		
	case "restart":
		$BP->buildResult($xml, $BP->restart_securesync($dpuID));
		echo($xml->getXml());
		break;
		
	case "enabled":
		$BP->buildResult($xml, $BP->is_securesync_enabled($dpuID));
		echo($xml->getXml());
		break;
}

//
// This function constructs the XML returned for securesync settings.
//
function buildVaultingProcessXML($xml, $result) {
	if (array_key_exists('AutoSyncEnabled', $result)) {
		$xml->element('AutoSyncEnabled', $result['AutoSyncEnabled'] == true ? '1' : '0');
	}
	if (array_key_exists('SyncBareMetals', $result)) {
		$xml->element('SyncBareMetals', $result['SyncBareMetals'] == true ? '1' : '0');
	}
	if (array_key_exists('SyncSQLBackups', $result)) {
		$xml->element('SyncSQLBackups', $result['SyncSQLBackups'] == true ? '1' : '0');
	}
	if (array_key_exists('TemporarySpaceLocation', $result)) {
		$xml->element('TemporarySpaceLocation', $result['TemporarySpaceLocation']);
	}
	if (array_key_exists('SyncTo', $result)) {
		$xml->element('SyncTo', $result['SyncTo']);
	}
	if (array_key_exists('SyncUser', $result)) {
		$xml->element('SyncUser', $result['SyncUser']);
	}
	if (array_key_exists('TransportType', $result)) {
		// Remove quotes surrounding transport type if they are present.
		$transportType = $result['TransportType'];
		$transportType = trim($transportType, '"');
		$xml->element('TransportType', $transportType);
	}
	if (array_key_exists('BlockOutPeriods', $result)) {
		$xml->element('BlockOutPeriods', $result['BlockOutPeriods']);
	}
	if (array_key_exists('SyncReportMailTo', $result)) {
		$xml->element('SyncReportMailTo', $result['SyncReportMailTo']);
	}
	if (array_key_exists('SyncReportTime', $result)) {
		$xml->element('SyncReportTime', $result['SyncReportTime']);
	}
	if (array_key_exists('EnableSyncLocalDir', $result)) {
		$xml->element('EnableSyncLocalDir', $result['EnableSyncLocalDir'] == true ? '1' : '0');
	}
	if (array_key_exists('LocalDirToSync', $result)) {
		$xml->element('LocalDirToSync', $result['LocalDirToSync']);
	}
	if (array_key_exists('EnableSyncExchange', $result)) {
		$xml->element('EnableSyncExchange', $result['EnableSyncExchange'] == true ? '1' : '0');
	}
	if (array_key_exists('ExchangeDirToSync', $result)) {
		$xml->element('ExchangeDirToSync', $result['ExchangeDirToSync']);
	}
	if (array_key_exists('VaultName', $result)) {
		$xml->element('VaultName', $result['VaultName']);
	}
	if (array_key_exists('CheckIntervalSeconds', $result)) {
		$xml->element('CheckIntervalSeconds', $result['CheckIntervalSeconds']);
	}
	if (array_key_exists('MaxDeltaGBs', $result)) {
		$xml->element('MaxDeltaGBs', $result['MaxDeltaGBs']);
	}
	if (array_key_exists('SyncCopyOnly', $result)) {
		$xml->element('SyncCopyOnly', $result['SyncCopyOnly'] == true ? '1' : '0');
	}
	if (array_key_exists('SyncRetry', $result)) {
		$xml->element('SyncRetry', $result['SyncRetry']);
	}
}

//
// This function constructs the XML returned for securesync settings.
//
function buildVaultConnectionXML($xml, $BP, $sectionName) {
	displaySection($xml, $BP, $sectionName);
}

function saveIniValues($BP, $dpuID) {

	$options = array ('VaultConnection' => 'vc',
					  'VaultUpstreamSpeed' => 'vu',
					  'VaultDownstreamSpeed' => 'vd',
					  'VaultBandwidth' => 'vb');				  
	$bOptions = array();		
	$connections = array();		
	$connections = buildOptions($connections, $options, $bOptions);
	
	$result = true;
	foreach ($connections as $field => $value) {
		$result = $BP->set_ini_value("CMC", $field, $value, $dpuID);
		if ($result !== true) {
			break;
		}
	}
	
	return $result;
}

$BP->destroyCookie();
?>
