<?php
// defines BP, xml, action, cookie
require 'header.php';

// set workspaceInfoID ID to null (for update vs. add)
$workspaceInfoID = NULL;
$workspaceInfo = array();

switch ($action) {

	case "list":
			$bValid = true;
			$dpuID = isset($_GET['sid']) ? (int)$_GET['sid'] : $BP->get_local_system_id();
			if (!isset($_GET['sid']) || $dpuID == $BP->get_local_system_id()) {
				$workspaces = $BP->get_workspace_list();
			} else {
				$workspaces = $BP->get_workspace_list($dpuID);
			}
			if ($workspaces === false) {
				$bValid = false;
			} else {
				$xml->push("root");
				foreach ($workspaces as $id => $name) {
					if (!isset($_GET['sid']) || $dpuID == $BP->get_local_system_id()) {
						$workspaceInfo = $BP->get_workspace_info($id);
					} else {
						$workspaceInfo = $BP->get_workspace_info($id, $dpuID);
					}
					$networkID = sprintf("%d.%d", $dpuID, $id);
					if ($workspaceInfo === false) {
						$dummyInfo = array ('unknown' => 'unknown');
						displayWorkspace($xml, $name, $id, $networkID, $dummyInfo);
					} else {
						displayWorkspace($xml, $name, $id, $networkID, $workspaceInfo);
					}
				}
				$xml->pop(); //root
			}
			if (!$bValid) {
				$xml->clear(false);
				$BP->buildResult($xml, false);
			}
			echo($xml->getXml());
			break;
					
	case "change":
			// if updating, specify id or map name/system name to workspace ID				
			if (isset($_GET['id'])) {
				$id = $_GET['id'];
				$workspaceInfoID = array("id" => $id);
			} else {
				$BP->buildResult($xml, false, "workspace update must have id specified.");
				echo($xml->getXml());
				break;
			}
			// fall through to add.
	
	case "add":	
			// Get the definition from arguments.
			if (isset($_GET['name'])) {
				$name = $_GET['name'];
				$workspaceInfo = array ("name" => $name);
			}				
			if ($workspaceInfoID != NULL) {
				$workspaceInfo = array_merge($workspaceInfoID, $workspaceInfo);
			}
			
			$options = array ('login' => 'login',
							  'password' => 'password',
							  'domain' => 'domain',
							  'samba_share' => 'samba_share',
							  'samba_path' => 'samba_path',
							  'samba_login' => 'samba_login',
							  'samba_password' => 'samba_password');
			$bOptions = array();			
			$workspaceInfo = buildOptions($workspaceInfo, $options, $bOptions);						
			
			if (isset($_GET['name']) || isset($_GET['id'])) {
				$dpuID = isset($_GET['sid']) ? (int)$_GET['sid'] : $BP->get_local_system_id();
				if (!isset($_GET['sid']) || $dpuID == $BP->get_local_system_id()) {
					$BP->buildResult($xml, $BP->save_workspace_info($workspaceInfo));
				} else {
					$BP->buildResult($xml, $BP->save_workspace_info($workspaceInfo, $dpuID));
				}
				echo($xml->getXml());
			} else {
				$BP->buildResult($xml, false,
						"workspaces: improper argument format; name or id must be specified.");
				echo($xml->getXml());
			}
			break;
					
	case "delete":
			// see if the dpu ID is provided
			$dpuID = isset($_GET['sid']) ? (int)$_GET['sid'] : $BP->get_local_system_id();
			if (isset($_GET['id'])) {
				$workspaceID = $_GET['id'];
			} else {
				// user specified name, translate to ID.
				$workspaceName = $_GET['name'];
				$workspaceID = getWorkspaceIDFromName($BP, $workspaceName, $dpuID);
			}
			if ($workspaceID !== "") {
				if (!isset($_GET['sid']) || $dpuID == $BP->get_local_system_id()) {
					$BP->buildResult($xml, $BP->remove_workspace($workspaceID));
				} else {
					$BP->buildResult($xml, $BP->remove_workspace($workspaceID, $dpuID));
				}
			} else {
				$stringError = sprintf("workspaces: could not determine workspace id from name %s.",
										$workspaceName);
				$BP->buildResult($xml, false, $stringError);
			}
			echo($xml->getXml());
			break;
					
	case "samba":
			$bValid = true;
			$dpuID = isset($_GET['sid']) ? (int)$_GET['sid'] : $BP->get_local_system_id();
			if (!isset($_GET['sid']) || $dpuID == $BP->get_local_system_id()) {
				$sambaList = $BP->get_samba_shares();
			} else {
				$sambaList = $BP->get_samba_shares($dpuID);
			}
			if ($sambaList === false) {
				$bValid = false;
			} else {
				$xml->push("root");
				foreach ($sambaList as $samba) {
					$xml->push("Samba");
					if (array_key_exists('samba_share', $samba))
						$xml->element('SambaShare', $samba['samba_share']);
					if (array_key_exists('samba_path', $samba))
						$xml->element('SambaPath', $samba['samba_path']);
					$xml->pop();
				}
				$xml->pop(); //root
			}
			if (!$bValid) {
				$xml->clear(false);
				$BP->buildResult($xml, false);
			}
			echo($xml->getXml());
			break;
}

function displayWorkspace($xml, $name, $id, $networkID, $workspaceInfo)
{	
	$xml->push("Workspace", array("Name" => $name,
						 "ID" => $id,
						 "NetworkID" => $networkID));
	if (array_key_exists('login', $workspaceInfo))
		$xml->element('Login', $workspaceInfo['login']);
	if (array_key_exists('domain', $workspaceInfo))
		$xml->element('Domain', $workspaceInfo['domain']);
	if (array_key_exists('samba_share', $workspaceInfo))
		$xml->element('SambaShare', $workspaceInfo['samba_share']);
	if (array_key_exists('samba_path', $workspaceInfo))
		$xml->element('SambaPath', $workspaceInfo['samba_path']);
	if (array_key_exists('samba_login', $workspaceInfo))
		$xml->element('SambaLogin', $workspaceInfo['samba_login']);
	if (array_key_exists('vault', $workspaceInfo))
		$xml->element('Vault', $workspaceInfo['vault'] == true ? "1" : "0");
		
	// If an error occurred getting info, pass that back to caller.
	if (array_key_exists('unknown', $workspaceInfo)) {
		$xml->element('LoadError', $name);
	}
	$xml->pop(); // workspace
}

function getWorkspaceIDFromName($BP, $workspaceName, $dpuID)
{
	$workspaceID = "";
	
	if (!isset($_GET['sid']) || $dpuID == $BP->get_local_system_id()) {
		$workspaces = $BP->get_workspace_list();
	} else {
		$workspaces = $BP->get_workspace_list($dpuID);
	}
	
	foreach ($workspaces as $id => $name) {
		if ($workspaceName == $name) {
			$workspaceID = $id;
			break;
		}
	}
	return $workspaceID;
}
$BP->destroyCookie();
?>
