<?php

header( 'Expires: -1' ); 
header( 'Last-Modified: ' . gmdate( 'D, d M Y H:i:s' ) . ' GMT' ); 
header( 'Cache-Control: no-store, no-cache' ); 
header( 'Cache-Control: post-check=0, pre-check=0', false ); 
header( 'Pragma: no-cache' ); 

// set to true when we release.
// Its ok to have the major, minor and patch versions in this - so that we always get the most up to date build.
// ^^ No, it's not.  The user sees this in the feedback box, which is why we only show the major version in the released product.
$RELEASE = true;
//
// Set the address for the HTTP Services.
//
if (isset($_SERVER['HTTP_HOST'])) {
	$serverAddress = $_SERVER['HTTP_HOST'];
} else if (isset($_SERVER['SERVER_NAME'])) {
	$serverAddress = $_SERVER['SERVER_NAME'];
} else {
	$serverAddress = $_SERVER['SERVER_ADDR'];
}

$rpmVersion = trim(shell_exec('rpm -q unitrends-rr | head -1'));
$rawVersion = preg_replace("/[^0-9\\.\\-]/","", $rpmVersion );

$rawVersion = preg_replace("/[\\-]/","", $rawVersion, 2 );

$exploded = explode( "-", $rawVersion );
$majorVersion = (string)$exploded[ 0 ];
$minorVersion = (string)$exploded[ 1 ];
$exploded = explode( ".", $minorVersion );
$releaseVersion = (string)$exploded[ 0 ];
$buildVersion = (string)$exploded[ 1 ];

//
// Pass flag to app if virtual or not.
//
bp_bypass_cookie(2);
$UEB = bp_is_virtual() ? 'true' : 'false';
$OnMetalArray = bp_get_capabilities("Unitrends-Metal");
$isOnMetalSystem = (is_array($OnMetalArray) and array_key_exists('Unitrends-Metal', $OnMetalArray) and $OnMetalArray['Unitrends-Metal'] != false) ? 'true' : 'false';

if ($RELEASE) {
        $UI_Ver = "$majorVersion";
} else {
       $UI_Ver = "$majorVersion.$releaseVersion.$buildVersion";
}

// Always get the very latest build version
//$UI_Ver = "$majorVersion.$releaseVersion.$buildVersion";

bp_destroy_cookie();
?>
<html lang="en" >
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
	<meta name="author" content="Unitrends" />
	<meta name="description" content="The Unitrends Unitrends Rapid Recovery Console" />
	<title><?php echo $serverAddress ?> Unitrends Administrator Interface</title>
</head>
<script src="bpria/bin/AC_OETags.js?vsn=<?php echo $UI_Ver?>" language="javascript"></script>
<script src="bpria/bin/flex-onbeforeunload.js" language="javascript"></script>
<style>
body { margin: 0px; overflow:hidden }
</style>
<script language="JavaScript" type="text/javascript">
	<!--
	// -----------------------------------------------------------------------------
	// Globals
	// Major version of Flash required
	// -- ssf: updating to Flash Player 10 since we compile to Flash player 10.
	var requiredMajorVersion = 10;
	// Minor version of Flash required
	var requiredMinorVersion = 0;
	// Minor version of Flash required
	var requiredRevision = 0;
	// -----------------------------------------------------------------------------
	// -->

	// Connect the onbefore unload function
	window.onbeforeunload = function (e) {
		if (FlexOnBeforeUnload.prompt) {
			return FlexOnBeforeUnload.promptText;
		}
	}
	</script>
</head>

<body scroll="no">

<!-- lmc - no history support for now.
<script language="JavaScript" type="text/javascript" src="bpria/bin/history.js"></script>
-->
<script language="JavaScript" type="text/javascript">
<!--
// Version check for the Flash Player that has the ability to start Player Product Install (6.0r65)
var hasProductInstall = DetectFlashVer(6, 0, 65);

// Version check based upon the values defined in globals
var hasRequestedVersion = DetectFlashVer(requiredMajorVersion, requiredMinorVersion, requiredRevision);


// Check to see if a player with Flash Product Install is available and the version does not meet the requirements for playback
if ( hasProductInstall && !hasRequestedVersion ) {
	// MMdoctitle is the stored document.title value used by the installation process to close the window that started the process
	// This is necessary in order to close browser windows that are still utilizing the older version of the player after installation has completed
	// DO NOT MODIFY THE FOLLOWING FOUR LINES
	// Location visited after installation is complete if installation is required
	var MMPlayerType = (isIE == true) ? "ActiveX" : "PlugIn";
	var MMredirectURL = window.location;
    document.title = document.title.slice(0, 47) + " - Flash Player Installation";
    var MMdoctitle = document.title;

	AC_FL_RunContent(
		"src", "bpria/bin/playerProductInstall",
		"FlashVars", "MMredirectURL="+MMredirectURL+'&MMplayerType='+MMPlayerType+'&MMdoctitle='+MMdoctitle+"",
		"width", "100%",
		"height", "100%",
		"align", "middle",
		"id", "bpria/bin/bpria",
		"wmode","Transparent",
		"quality", "high",
		"bgcolor", "#869ca7",
		"name", "bpria/bin/bpria",
		"allowScriptAccess","sameDomain",
		"type", "application/x-shockwave-flash",
		"pluginspage", "http://www.adobe.com/go/getflashplayer"
	);
} else if (hasRequestedVersion) {
	// if we've detected an acceptable version
	// embed the Flash Content SWF when all tests are passed


	var localeChain;
	var resourceBundle;

	var locale = "en_US";

	switch( locale ) {
		case "en_ES":
			localeChain = locale;
			resourceBundle = "bpria/bin/Resources_en_ES.swf?vsn=<?php echo $UI_Ver?>";
			break;
		case "de_DE":
			localeChain = locale;
			resourceBundle = "bpria/bin/Resources_de_DE.swf?vsn=<?php echo $UI_Ver?>";
			break;
		case "fr_FR":
			localeChain = locale;
			resourceBundle = "bpria/bin/Resources_fr_FR.swf?vsn=<?php echo $UI_Ver?>";
			break;
		default:
			localeChain = locale;
			resourceBundle = "bpria/bin/Resources_en_US.swf?vsn=<?php echo $UI_Ver?>";
	}

	// if we've detected an acceptable version
	// embed the Flash Content SWF when all tests are passed
	AC_FL_RunContent(
			"src", "bpria/bin/bpria",
			"width", "100%",
			"height", "100%",
			"align", "middle",
			"id", "bpria/bin/bpria",
			"wmode","opaque",
			"quality", "high",
			"bgcolor", "#869ca7",
			"name", "bpria/bin/bpria",
			<!-- replace with installed system's IP address -->
			"flashvars", "url=https://<?php echo $serverAddress?>/recoveryconsole/" +
				"&Version=<?php echo $UI_Ver?>" +
				"&autologin=yes" +
				"&UEB=<?php echo $UEB?>" +
                "&isOnMetalSystem=<?php echo $isOnMetalSystem?>" +
				"&uconnect=http://www.unitrends.com/forum/forum.php" +
				"&resourceModuleURLs=" + resourceBundle +
				"&localeChain=" + localeChain,
			"allowScriptAccess","sameDomain",
			"type", "application/x-shockwave-flash",
			"pluginspage", "http://www.adobe.com/go/getflashplayer",
			"uncacheversion","?vsn=<?php echo $UI_Ver?>"
	);
  } else {  // flash is too old or we can't detect the plugin
    var alternateContent = '<br/><br/>'
	+ '<b>The Unitrends Administrator Interface '
	+ 'requires the the Adobe Flash Player.<br/></b>'
	+ '<br/><bl>'
	+ '<li>If you have access to the internet, you should go to '
   	+ '<a href=http://www.adobe.com/go/getflash/>this link</a> '
  	+ 'and download it.</li> '
	+ '<li>If this computer does not have internet access, '
	+ 'you should download the Adobe Flash Player to another computer '
	+ 'that has internet access, then copy it '
	+ 'to this computer and install it.</li>'
	+ '</bl>';
    document.write(alternateContent);  // insert non-flash content
  }
// -->
</script>
<script language="javascript" src="//commondatastorage.googleapis.com/code.snapengage.com/js/7a62b709-4a75-4c83-8a16-e8e549561e96.js" type="text/javascript"></script>
<noscript>
<object classid="clsid:D27CDB6E-AE6D-11cf-96B8-444553540000"
		id="bpria/bin/bpria" width="100%" height="100%"
		codebase="http://fpdownload.macromedia.com/get/flashplayer/current/swflash.cab">
		<param name="movie" value="bpria/bin/bpria.swf?vsn=<?php echo $UI_Ver?>" />
		
		<param name="flashVars" value="url=https://<?php echo $serverAddress?>/recoveryconsole/&Version=<?php echo $UI_Ver?>&autologin=yes&UEB=<?php echo $UEB?>&isOnMetalSystem=<?php echo $isOnMetalSystem?>&uconnect=http://www.unitrends.com/forum/forum.php&resourceModuleURLs=bpria/bin/Resources_en_ES.swf&localeChain=en_US" />
		
		<param name="WMode" value="direct" />
		<param name="quality" value="high" />
		<param name="bgcolor" value="#869ca7" />
		<param name="allowScriptAccess" value="sameDomain" />
		<embed src="bpria/bin/bpria.swf?vsn=<?php echo $UI_Ver?>" quality="high" bgcolor="#869ca7"
			width="100%" height="100%" name="bpria/bin/bpria" align="middle"
			url="https://<?php echo $serverAddress?>/recoveryconsole/"
			flashVar="url=https://<?php echo $serverAddress?>/recoveryconsole/&Version=<?php echo $UI_Ver?>&autologin=yes&UEB=<?php echo $UEB?>&isOnMetalSystem=<?php echo $isOnMetalSystem?>&uconnect=http://www.unitrends.com/forum/forum.php&resourceModuleURLs=bpria/bin/Resources_en_ES.swf&localeChain=en_US"
			play="true"
			loop="false"
			wmode="direct"
			quality="high"
			allowScriptAccess="sameDomain"
			type="application/x-shockwave-flash"
			pluginspage="http://www.adobe.com/go/getflashplayer">
		</embed>
</object>

</noscript>
</body>
<!--
lmc - no history support for now.
<iframe name="_history" src="bpria/bin/history.htm" frameborder="0" scrolling="no" width="22" height="0"></iframe>
-->
</html>
