<?php
// functions to update system user passwords given the current root password

// example: change root's password from unitrends1 to mypassword
//   $msg = '';
//   $status = change_system_password('root', 'unitrends1', 'mypassword', $msg);
//   echo "Status was $status: $msg\n";

/* attempts to reset a user's password using user login credentials
 *
 * @param $user - name of user for which password should be changed
 * @param $current_root_pass - current root password
 * @param $new_user_pass - new password for user
 * @param &$msg - string to update with human-readable command status
 * @return - 0 on success, nonzero otherwise
 */
function change_system_password($user, $current_root_pass, $new_user_pass, &$msg) {
	$status = -1;
	$res = trim(shell_exec('echo $UID'));
	if ($res == 0) {
		// running as root, no sudo needed for passwd command
		$handle = popen("passwd --stdin $user", 'w');
		fwrite($handle, "$new_user_pass\n");
		$status = pclose($handle);
	} else {
		// we're not running as root
		if (!login_is_valid('root', $current_root_pass)) {
			$msg = "Invalid password for user root.";
			return 1;
		}
		$handle = popen("sudo -S passwd --stdin $user", 'w');
		fwrite($handle, "$current_root_pass\n$new_user_pass\n");
		$status = pclose($handle);
	}
	if ($status != 0) {
		$msg = "The system password for $user could not be updated.";
	} else {
		$msg = "The system password for $user was successfully updated.";
	}
	return $status;
}

/* checks for valid login credentials, returns 1 if valid, 0 otherwise
 *
 * @param $username - user to check
 * @param $password - password for this user
 * @return - 1 for valid login, 0 otherwise
 */
function login_is_valid($username, $password) {
	$passencoded = "'" . str_replace("'", "'\''", $password) . "'";
	$userencoded = "'" . str_replace("'", "'\''", $username) . "'";
	$cmd = "echo -e $passencoded | sudo -u $userencoded -S whoami 2>/dev/null";
	$res = trim(shell_exec($cmd));
	if ($res == $username) {
		return 1;
	} else {
		return 0;
	}
}
?>
